var CanvasManager = function(parent)
{
	var _this					= this;
	_this.parent				= parent;
	_this.textureContextList	= new Object();
	_this.imgData				= false;
	_this.pointX				= 0;
	_this.pointY				= 0;
	_this.canvasKey				= _GLOBALS.CONF.pages.canvasKey;
	_this.elementKey			= _GLOBALS.CONF.pages.element;
	_this.lastScale				= 0;
	
	_this.textureHigh			= _GLOBALS.CONF.pages.textureHigh;
	_this.textureLow			= _GLOBALS.CONF.pages.textureLow;
	_this.getTextureHigh		= _GLOBALS.CONF.pages.getTextureHigh;
	_this.getTextureLow			= _GLOBALS.CONF.pages.getTextureLow;
	
	_this.canvasNeedPath		= new Array();
	_this.canvasNeedPath.push(_this.textureLow);
	_this.canvasNeedPath.push(_this.textureHigh);
	
	_this.canvasNeedFormat		= new Array();
	_this.canvasNeedFormat.push(_this.getTextureLow);
	_this.canvasNeedFormat.push(_this.getTextureHigh);
	
	_this.loadTexture = function ( index , cumulIndex , doublePage)
	{
		// Si le canvas !exist
		if(!_this.textureContextList[_this.canvasKey+index] || (cumulIndex && !_this.textureContextList[_this.canvasKey+index][_this.pathLowDKey+cumulIndex] ))
		{
			// Si c'est la page de gauche
			if(!cumulIndex)
			{
				_this.textureContextList[_this.canvasKey+index] = new Object();
			}
			
			var cLs = _this.canvasNeedPath.length;
			for( var nIs = 0 ; nIs < cLs ; nIs++ )
			{
				var canvasNeedPath = _this.canvasNeedPath[nIs];
				_this.textureContextList[_this.canvasKey+index][canvasNeedPath+cumulIndex]				= new Image();
				_this.textureContextList[_this.canvasKey+index][canvasNeedPath+cumulIndex].drawed		= false;				
			}
			// Si c'est la page de gauche
			if(!cumulIndex)
			{
				_this.textureContextList[_this.canvasKey+index][_this.elementKey]			= document.createElement('canvas');
				_this.textureContextList[_this.canvasKey+index][_this.elementKey].height	= _GLOBALS.CONF.getDocument.height;
				_this.textureContextList[_this.canvasKey+index][_this.elementKey].width		= _GLOBALS.CONF.getDocument.width;
				_this.textureContextList[_this.canvasKey+index].ctx							= _this.textureContextList[_this.canvasKey+index][_this.elementKey].getContext('2d');
				_this.constructPos( _this.textureContextList[_this.canvasKey+index] , index );
				// _this.parent.blockCont.append(_this.textureContextList[_this.canvasKey+index][_this.elementKey]);
			}
		
			var cLs = _this.canvasNeedFormat.length;			
			for( var nIs = 0 ; nIs < cLs ; nIs++ )
			{
				_this.drawByFormat( _this.canvasKey+index , _this.canvasNeedFormat[nIs]+cumulIndex , _this.canvasNeedPath[nIs]+cumulIndex , index , cumulIndex );
			}
			
			//HIGH D
			// _this.drawByFormat( _this.canvasKey+index , _this.getHighDKey+cumulIndex , _this.textureKey+cumulIndex , index , cumulIndex );
		}
		
		// Si le traitement en cours concerne la page de gauche && que la page de droite n'est pas encore crée && que la conf est en double page && la page != de la premiere
		// && aussi != de la derniere Alors demande de creer la page de droite sinon retourne l'element CANVAS
		if((!_this.textureContextList[_this.canvasKey+index][_this.pathLowDKey+(cumulIndex+1)] && !cumulIndex) && (_GLOBALS.CONF.pages.doublePage && index != 1 && index != _GLOBALS.CONF.pages.length))
		{
			return _this.loadTexture( index , cumulIndex+1 , doublePage );
		}
		
	    return _this.textureContextList[_this.canvasKey+index][_this.elementKey];
	};
	
	
	_this.drawByFormat = function( canvasKey , getFormatKey , pathFormatKey , index , cumulIndex )
	{
		if( _this.textureContextList[canvasKey][pathFormatKey].drawed )
		{
			return void(0);
		}
		_this.textureContextList[canvasKey][getFormatKey] = function()
		{
			_this.textureContextList[canvasKey][pathFormatKey].onload = function ()
			{
				if(!_this.textureContextList[canvasKey])
				{
					return void(0);
				}
				_this.textureContextList[canvasKey][pathFormatKey].readyToDraw = function(callback)
				{
					var x = _this.textureContextList[canvasKey].pos.x;
					var y = _this.textureContextList[canvasKey].pos.y;
					var width = _this.textureContextList[canvasKey].pos.width;
					var height = _this.textureContextList[canvasKey].pos.height;
					
					_this.textureContextList[canvasKey][pathFormatKey].drawed = true;
					
					try
					{
						_this.textureContextList[canvasKey].ctx.drawImage(this, x+width*cumulIndex , y, width , height );
						/*Kev*/
						if (pathFormatKey == "pathTextureHigh0" || pathFormatKey == "pathTextureHigh1")
						{
							_GLOBALS.main.linksManager.drawLinks(_this.textureContextList[canvasKey], index, cumulIndex);
						}
						/*****/
					}catch(e){
						console.log(e);
					}
					
					if(callback)
					{
						callback(_this.textureContextList[canvasKey]);
					}
				};
				_this.textureContextList[canvasKey][pathFormatKey].readyToDraw();
				return void(0);
			};
			
			if( getFormatKey == _this.getTextureHigh+cumulIndex )
			{
				_this.textureContextList[canvasKey][pathFormatKey].src = UTILS.getPathImage( _GLOBALS.CONF.pages.pathTextureHigh , index+cumulIndex );
			}
			return void(0);
		}
		
		if( getFormatKey == _this.getTextureLow+cumulIndex )
		{
			_this.textureContextList[canvasKey][pathFormatKey].src = UTILS.getPathImage( _GLOBALS.CONF.pages.pathTextureLow , index+cumulIndex );
			_this.textureContextList[canvasKey][getFormatKey]();
		}
		
		return void(0);		
	}
	
	_this.texture = function(index)
	{
		return _this.loadTexture( index , 0 , _GLOBALS.CONF.pages.doublePage );
	}
	
	
	_this.setElem = function(elem,tYpe)
	{
		if(!elem.infoCanvas)
		{
			elem.infoCanvas = {};
		}
		
		if( elem.infoCanvas[tYpe] && elem.infoCanvas[tYpe].needSave )
		{
			return elem;
		}
		
		elem.infoCanvas[tYpe] = {};
		elem.infoCanvas[tYpe] =
		{
			needSave		:false,
			x				:0,
			y				:0,
			pagesWDB		: _GLOBALS.CONF.pagesOnInit.width,
			pagesW			: _GLOBALS.CONF.pagesOnInit.width/2,
			pagesH			: _GLOBALS.CONF.pagesOnInit.height/2,
			docD2W			: _GLOBALS.CONF.getDocument.width/2,
			docD2H			: _GLOBALS.CONF.getDocument.height/2,
			currScale		: _GLOBALS.CONF.pages.currScale,
			addX			: 0,
			addY			: 0,
			pSW				: 0,
			pSH				: 0,
			realPosPageX	: 0,
			realPosPageY	: 0,
			xCenter			: 0,
			yCenter			: 0,
			xDiff			: 0,
			yDiff			: 0,			
			fingerX			: 0,
			fingerY			: 0,
			pDiffX			: 0,
			pDiffY			: 0,			
			pDiffXProp		: 0,
			pDiffYProp		: 0
		}
		
		return elem;
	}
	
	_this.constructPos = function( elem , index , scaleDiff , diffX , diffY , callBack , diffOrigX , diffOrigY , controlManagerPoint)
	{
		elem = _this.setElem(elem,"init");
		elem = _this.setElem(elem,"nat");
		
		var isSimple = false;
		var elemInit = elem.infoCanvas.init;
		// var elemNat = elem.infoCanvas.nat;

		if(!_this.imgData || _GLOBALS.idResize != _this.idResize)
		{
			_this.idResize = _GLOBALS.idResize;
			_this.imgData = elem.ctx.createImageData(_GLOBALS.CONF.getDocument.width, _GLOBALS.CONF.getDocument.height);
		}
		
		elem.ctx.putImageData(_this.imgData, 0, 0);
		
		if( scaleDiff )
		{
			elemInit.currScale += scaleDiff;
		}else
		{
			scaleDiff = 0;
		}

		if( diffX && diffY )
		{
			elemInit.addX = diffX;
			elemInit.addY = diffY;
		}
		
		//Si !double || page == a la premiere page alors la largeur du canvas est /2
		if( !_GLOBALS.CONF.pages.doublePage || index === 1 || ( !UTILS.impair(index) && index === _GLOBALS.CONF.pages.length ) )
		{
			isSimple = true;
			elemInit.pagesWDB /= 2;
		}
		
		elemInit.pSW		= custFloor( (elemInit.pagesWDB) * elemInit.currScale );//largeur page		
		elemInit.pSH		= custFloor( (elemInit.pagesH) * elemInit.currScale );//hauteur page
		
		elemInit.realPosPageX		= elemInit.docD2W - elemInit.pSW;//position x page
		elemInit.realPosPageY		= elemInit.docD2H - elemInit.pSH;//position y page		
		
		
		elemInit.x			= custFloor( (elemInit.realPosPageX - elemInit.addX) );
		elemInit.y			= custFloor( (elemInit.realPosPageY - elemInit.addY) );
		
		
		// elemInit.xCenter	= elemInit.x + elemInit.pagesWDB;
		// elemInit.yCenter	= elemInit.y + elemInit.pagesH;
		
		// elemInit.xDiff		= elemNat.pSW - elemInit.pSW;
		// elemInit.yDiff		= elemNat.pSH - elemInit.pSH;
		
		// if( !diffOrigX || !diffOrigY )
		// {
			// diffOrigX = 0;
			// diffOrigY = 0;			
		// }
	
		var lastX = elemInit.x;
		var lastY = elemInit.y;
		
		if( elemInit.x > elemInit.docD2W )
		{
			elemInit.x = elemInit.docD2W;
		}
		else if( elemInit.x+(elemInit.pagesWDB*2)*elemInit.currScale < elemInit.docD2W )
		{
			elemInit.x = elemInit.docD2W-((elemInit.pagesWDB*2)*elemInit.currScale);
		}
		
		if( elemInit.y > elemInit.docD2H )
		{
			elemInit.y = elemInit.docD2H;
			
		}
		else if( elemInit.y+((elemInit.pagesH*2)*elemInit.currScale) < elemInit.docD2H )
		{
			elemInit.y = elemInit.docD2H-((elemInit.pagesH*2)*elemInit.currScale);
		}
		
		if(controlManagerPoint)
		{
			controlManagerPoint.transformDiffDefX += (lastX - elemInit.x);
			controlManagerPoint.transformDiffDefY += (lastY - elemInit.y);
		}

		if(!elem.pos)
		{
			elem.pos = {};
		}
		
		/*Kev*/
		/*08_10*/		
		if(!elem.linksList)
		{
			elem.linksList = new Array();
		}
		/*******/

		elem.pos.x			= Math.floor(elemInit.x);
		elem.pos.y			= Math.floor(elemInit.y);
		elem.pos.currScale	= elemInit.currScale;
		elem.pos.width		= _GLOBALS.CONF.pagesOnInit.width * elemInit.currScale;
		elem.pos.height		= _GLOBALS.CONF.pagesOnInit.height * elemInit.currScale;
		
		
		imgDatatpW = elem.pos.width;
		imgDatatpH = elem.pos.height;
		
		if(!isSimple)
		{
			imgDatatpW = elem.pos.width*2;
		}
		
		var chadX = 0;
		var chady = 0;
		var chadblur = 10;
		if( elemInit.currScale === _GLOBALS.CONF.pages.currScale )
		{
			elem.ctx.save();
			elem.ctx.shadowColor = 'black';
			elem.ctx.shadowBlur = chadblur;
			elem.ctx.shadowOffsetX = chadX;
			elem.ctx.shadowOffsetY = chady;
			elem.ctx.fillStyle = "rgba(100,100,100,0.5)";
			elem.ctx.fillRect( elem.pos.x , elem.pos.y , imgDatatpW , imgDatatpH );
			elem.ctx.restore();
		}
		if(callBack)
		{
			callBack(elem);
		}
	}
	
	_this._construct = function()
	{
		return void(0);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoaded("CanvasManager");