/*Kev*/

_GLOBALS.LinkTypeZoomPartiel = "zoomPartiel";
_GLOBALS.LinkTypeVideoFiche = "video fiche";
_GLOBALS.LinkTypeVideoIncruster = "video incuster";
_GLOBALS.LinkTypeWeb = "web";
_GLOBALS.LinkTypeGalerie = "galerie";
_GLOBALS.LinkTypeFiche = "fiche";
_GLOBALS.LinkTypeImageFiche = "image fiche";
_GLOBALS.LinkTypeImageIncruster = "image incruster";
_GLOBALS.LinkTypeAudio = "audio";
_GLOBALS.LinkTypeGotoPage = "gotopage";
_GLOBALS.LinkTypePhone = "phone";
_GLOBALS.LinkTypeMail = "mail";
_GLOBALS.LinkTypeNone = "none";

_GLOBALS.VideoExtSupported = ["m4v","ogv","webm"];
_GLOBALS.VideoTypeSupported = ["video/mp4","video/ogg","video/webm"];
		
		
var VideoIncruster = function(lien) {
	var _this = this;
	_this.lienObj;
	_this.html;
	_this.element;
	
	_this._construct = function()
	{
        _this.lienObj = lien;
	}
	
	_this.setElement = function(elem) {
		_this.element = elem;
	}
	
	_this.destroyVideo = function() {
		$(_this.element).detach();
		$(_this.element).remove();
	}
	
	_this.hide = function() {
		$(_this.element).removeClass('hide');
		$(_this.element).removeClass('show');
		$(_this.element).addClass('hide');	
	}

	_this.show = function() {
		$(_this.element).removeClass('show');
		$(_this.element).removeClass('hide');
		$(_this.element).addClass('show');	
	}
	
	_this.getHtml = function(videoTag) {
		_this.html = '<div class="linkVideo show" href="';
		_this.html += _this.lienObj.url;
		_this.html += '" style="';
		_this.html += 'left:' + _this.lienObj.xScreen + 'px; ' + 'top:' + _this.lienObj.yScreen + 'px; ' + 'width:' + _this.lienObj.w + 'px; ' + 'height:' + _this.lienObj.h + 'px; ';
		_this.html += '">'
		_this.html += videoTag;
		_this.html +='</div>';
		return _this.html;
	}
		
	_this._construct();	
}


var LinkObj = function( linkAttr ) {
	var _this = this;
	_this.xOrig = 0;
	_this.xScreen = 0;
	_this.x = 0;
	_this.yOrig = 0;
	_this.yScreen = 0;
	_this.y = 0;
	_this.wOrig = 0;
	_this.w = 0;
	_this.hOrig = 0;
	_this.h = 0;
	_this.url = "";
	_this.urlvideo = new Array();
	_this.target = "";
	_this.color = "";
	_this.pagenum = "";
	_this.type;
	_this.icon;
	
	 _this._construct = function()
	{
        _this.xOrig = parseInt($(linkAttr).attr('x'));
		_this.yOrig = parseInt($(linkAttr).attr('y'));
        _this.wOrig = parseInt($(linkAttr).attr('w'));
		_this.hOrig = parseInt($(linkAttr).attr('h'));
		_this.pagenum = $(linkAttr).attr('pagenum');
		
        if ($(linkAttr).attr('url') != undefined)
        	_this.url = $(linkAttr).attr('url');
        else if ($(linkAttr).attr('page') != undefined)
        	_this.url = "page:" + $(linkAttr).attr('page');
        
        if ($(linkAttr).attr('target') != undefined)
        	_this.target = $(linkAttr).attr('target');
		_this.color = "0,0,255,0.1";
	}
	
	_this.resizeLink = function(currScale, decalageX, decalageY) {
		
		_this.x = UTILS.arrondi(_this.xOrig*currScale);
        _this.y = UTILS.arrondi(_this.yOrig*currScale);
        _this.xScreen = _this.x + decalageX;
        _this.yScreen = _this.y + decalageY;
        _this.w = UTILS.arrondi(_this.wOrig*currScale);
        _this.h = UTILS.arrondi(_this.hOrig*currScale);
	}
	
	_this.setIcon = function(type) {
		var filename = '';
		if (type == _GLOBALS.LinkTypeVideoIncruster || type == _GLOBALS.LinkTypeVideoFiche)
			filename = 'video.png';
		else 
			return;
		
		var img = new Image();
		img.src = _GLOBALS.CONF.iconesPath + filename; 
		img.onload = function(){
			_this.icon = this;
		}	
	}
	
	
	_this._construct();
}



var LinkTypeManager = function() {
	var _this = this;
	
	_this.getLinkType = function( lien ) {
		if (lien.url.length == 0) {
			return _GLOBALS.LinkTypeNone;
		}
		
		if (lien.target == "swf_fiche" || lien.target == "swf_video") {
			var extension = UTILS.getFileExtension(lien.url);
			if (extension == "jpg" || extension == "png") {
				return (lien.target == "swf_fiche") ? _GLOBALS.LinkTypeImageFiche : _GLOBALS.LinkTypeImageIncruster;
			}
			if (extension == "flv") {
				for (var i = 0; i < _GLOBALS.VideoExtSupported.length; i++) {
					lien.urlvideo[i] = UTILS.getFilenameWithoutExtension(lien.url) + "." + _GLOBALS.VideoExtSupported[i];
    			}		
				return (lien.target == "swf_fiche") ? _GLOBALS.LinkTypeVideoFiche : _GLOBALS.LinkTypeVideoIncruster;
			}
			console.log('alerte 1 ! '); 
		}
		
		if (lien.target == "_blank") {
			if (/[http:]/.exec(lien.url)) {
				return _GLOBALS.LinkTypeWeb;
			}
			console.log('alerte 2 ! ');
		}
		
		if (lien.target == "_self") {
			if (/[mailto:]/.exec(lien.url)) {
				return _GLOBALS.LinkTypeMail;
			}
			console.log('alerte 3 ! ');
		}
		
		if (lien.target.length == 0) {
			if (/[page:]/.exec(lien.url)) {
				return _GLOBALS.LinkTypeGotoPage;
			}
		}
		
		console.log('lien non reconnu ! ');
		console.log(lien);
		return _GLOBALS.LinkTypeNone;	
	}
}


var LinksManager = function( links ) {
    
    var _this = this;
    _this.links;
    _this.pageWidth;
    _this.pageHeight;
    _this.redrawLinksTimer = null;
    _this.videoTimer = null;
    _this.linkTypeManager = new LinkTypeManager();
    _this.videoIncruster = new Array();
    
    _this._construct = function()
	{
		var nbPages = _GLOBALS.CONF.pages.length;
        _this.links = new Array();
        
        for (var pagenum = 1; pagenum <= nbPages; pagenum++) {
        	var linksForPage = $(links).find('page[num='+pagenum+']').find('lien');
        	$(linksForPage).attr("pagenum",pagenum);
             
            _this.links[pagenum] = new Array(); 
        	for (var i = 0; i < linksForPage.length; i++) {
           		var lien = new LinkObj(linksForPage[i]);           		
           		lien.type = _this.linkTypeManager.getLinkType(lien);
           		lien.setIcon(lien.type);
           		
           		if (lien.type != _GLOBALS.LinkTypeNone && !_this.isDoublonLinks(_this.links[pagenum], lien)) {
           			_this.links[pagenum].push(lien);
           		}
        	}
        }
        
        _this.pageWidth  = _GLOBALS.CONF.pagesOnInit.width;
        _this.pageHeight = _GLOBALS.CONF.pagesOnInit.height;
        
	}
    
    _this.isDoublonLinks = function( liensArr , lienToCheck) {
    	for (var i = 0; i < liensArr.length; i++) {
    		var lien = liensArr[i];
    		var tolerence = 5;
    		var xDif = Math.abs(lien.xOrig-lienToCheck.xOrig);
    		var yDif = Math.abs(lien.yOrig-lienToCheck.yOrig);
    		var wDif = Math.abs(lien.wOrig-lienToCheck.wOrig);
    		var hDif = Math.abs(lien.hOrig-lienToCheck.hOrig);
    		if (xDif < tolerence && yDif < tolerence && wDif < tolerence && hDif < tolerence) {
    			if (lien.url != lienToCheck.url) {
    				console.log('Doublon found mais pas la meme url !');
    				console.log(lien);
    				console.log(lienToCheck);
    			}
    			return true;
    		}
    	}
    	return false;
    }
        
    _this.getLinksForPage = function( pagenum, currScale, decalageX, decalageY)
    
	{ 
		var linksForPage = _this.links[pagenum];
		//console.log(linksForPage);
		for (var i = 0; i < linksForPage.length; i++) {
           		var lien = linksForPage[i];
				lien.resizeLink(currScale, decalageX, decalageY);         	
        }
        return linksForPage;
    }
    
    _this.isTouchPointALink = function( offsetX, offsetY ) {  	
    	var linksFounded = new Array();
    	
    	var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
    	var infoPage = UTILS.byPageIfDouble(pagenum);			
		var pageToShow = 1;
		if( infoPage["isDouble"] )
			pageToShow = 2;
			
		
			
    	for (var j = 0; j < pageToShow; j++) {
    		var pagen = pagenum+j;
    		for (var i = 0; i < _this.links[pagen].length; i++) {
    			var lien = _this.links[pagen][i];
    			if ((offsetX >= lien.xScreen && offsetX <= lien.xScreen + lien.w) && (offsetY >= lien.yScreen && offsetY <= lien.yScreen + lien.h)) {
    				//console.log("trouved !!!!!!");
    				if (lien.type == _GLOBALS.LinkTypeImageIncruster)
    					return false;
    				linksFounded.push(lien);
    			}
    		}
    	}
    	if (linksFounded.length > 0) {
    		//console.log(linksFounded);
    		var bestMatch = linksFounded[0];
    		for (var i = 1; i < linksFounded.length; i++) {
    			var lien = linksFounded[i];
    			if (bestMatch.w * bestMatch.h > lien.w * lien.h) {
    				bestMatch = lien;
    			}
    		}
    		console.log("Lien cliqued :");
    		console.log(bestMatch);
    			
    		_this.loadLink(bestMatch);
    		return true;
    	}
    	return false;	
    } 
    
    _this.getVideoTag = function(lien, isPopup) {
    		var path = (isPopup) ? _GLOBALS.CONF.pages.videoFichePath : _GLOBALS.CONF.pages.videoIncrustePath;
    		var size = (isPopup) ? 80 : 100;
    		var style = (isPopup) ? 'popup' : 'incruster';
    		var controls = (isPopup) ? 'controls="controls"' : 'controls="controls"';
    		var id = (isPopup) ? 'v2' : 'v';
    		
			var video = '<div class="videoParent '+ style +'">';
    		video += '<video id="'+id+'" class="video" width="'+size+'%" height="'+size+'%" autobuffer="true" '+controls+'>';
    		for (var i = 0; i < _GLOBALS.VideoTypeSupported.length; i++) {
    			video += '<source src="' + path + lien.urlvideo[i] + '" type="' + _GLOBALS.VideoTypeSupported[i] + '">';
    		}
    		video += 'Your browser does not support the video tag.</video>';
    		if (isPopup) {
    			var closeSize = ($(window).height() <= 480) ? 36 : 48;
    			video += '<div class="close" ';
    			video += 'style="width:'+closeSize+'px; height:'+closeSize+'px;">';
    			video += '<img src="'+_GLOBALS.CONF.iconesPath+'x_2.png" style="height:100%; margin-left:-50%; margin-top:-50%;">';
    			video += '</div>';
    		}
    		video += '</div>';
    		return video;
    }
        
    _this.loadLink = function(lien) {
    	_this.closeVideo();
    	
    	if (lien.type == _GLOBALS.LinkTypeWeb || lien.type == _GLOBALS.LinkTypeMail)
    		window.open(lien.url,lien.target,"",false);

		if (lien.type == _GLOBALS.LinkTypeImageFiche) {	
			_this.drawImageOnBody(lien);
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeVideoFiche) {

			$('body').append(_this.getVideoTag(lien,true));

			$('.videoParent').css('opacity','0');
			$('.videoParent').transition({opacity:1},1000);
			$('.blockCont').css('-webkit-filter','blur(5px)');
			$('.close').click(function() {                                     
				_this.closeVideo();
			});
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeGotoPage) {
    		var gotoPage = lien.url.split(':').pop();
    		_GLOBALS.main.controlManager.goToPage(gotoPage);
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeVideoIncruster) {
    		/*var video = $('video')[0];
    		console.log(video);
			if(video.paused) {				
				video.play();
			} else {
				video.pause();
			}*/
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeImageIncruster) {

    	}
    }
    
    _this.closeImage = function( )
	{
		$('.imageParent').transition({opacity:0},500,function(){$('.imageParent').remove();});
		$('.blockCont').css('-webkit-filter',''); 
	}
	
    _this.closeVideo = function( )
	{
		$('.videoParent.popup').transition({opacity:0},500,function(){$('.videoParent.popup').detach();});
		$('.blockCont').css('-webkit-filter',''); 
	}
	
	_this.resetVideo = function() {
		for (var v in _this.videoIncruster)	{
			var videoIncruster = _this.videoIncruster[v];
			videoIncruster.destroy();
			_this.videoIncruster[v] = null;
		}
		_this.videoIncruster = new Array();
		console.log("on detruit tout les elements video du DOM, et on vide la liste");
	}
	
	
	_this.showVideo = function()
	{
		clearTimeout(_this.videoTimer);
		_this.videoTimer = setTimeout(function() {

					var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;

					if (_this.videoIncruster[pagenum]) {
						var videoIncruster = _this.videoIncruster[pagenum];
						if (videoIncruster.element) {
							videoIncruster.show();
							console.log("l'element video est juste masquer, donc on le show");
						} else {
							var html = videoIncruster.getHtml(_this.getVideoTag(videoIncruster.lienObj,false));
		               		$(html).appendTo($('body'));
	               			videoIncruster.setElement($('.linkVideo'));
	               			console.log("l'element video n'est plus dans le DOM, donc on le reconstruit");
						}
					} else {
						
						for (var v in _this.videoIncruster)	{
							var videoIncruster = _this.videoIncruster[v];
							videoIncruster.destroy();
							console.log("on detruit l'element video du DOM, car changement de page");
						}						
					}

		},400);
	}
	
	_this.hideVideo = function( )
	{
		if ($('.linkVideo.show').length) {
			var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
			if (_this.videoIncruster[pagenum]) {
				var videoIncruster = _this.videoIncruster[pagenum];
				var v = $(videoIncruster.element).find('#v');
				$(v)[0].pause();
				videoIncruster.element.hide();
				console.log("on masque juste l'element video");
			}
		}
	}
		

    _this.drawLinks = function(elem, pagenum, multiplicateurX) {
    			
		var decalageX = (elem.pos.x+(multiplicateurX*elem.pos.width));
        var decalageY = elem.pos.y;
               	        
        var links =  _this.getLinksForPage(pagenum+multiplicateurX, elem.pos.currScale, decalageX, decalageY);
        
        for (var l = 0; l < links.length; l++) {
        			
        	var lienObj = links[l];
            
        	if (lienObj.type == _GLOBALS.LinkTypeVideoIncruster || lienObj.type == _GLOBALS.LinkTypeVideoFiche) {
                
                if (lienObj.type == _GLOBALS.LinkTypeVideoIncruster) {
                	if (_this.videoIncruster[pagenum] == undefined) {              			
              			var videoIncruster = new VideoIncruster(lienObj);
              			var html = videoIncruster.getHtml(_this.getVideoTag(_this.lienObj,false));
	               		$(html).appendTo($('body'));
               			videoIncruster.setElement($('.linkVideo'));
               			_this.videoIncruster[pagenum] = videoIncruster;
               			console.log("Nouvelle objet video construit, et on le rajoute a l'affichage");
	                } else {
	                	
	                	var videoIncruster = _this.videoIncruster[pagenum];
	                	$(videoIncruster.element).css('left',lienObj.xScreen+'px');
	                	$(videoIncruster.element).css('top',lienObj.yScreen+'px');
	                	$(videoIncruster.element).css('width',lienObj.w+'px');
	                	$(videoIncruster.element).css('height',lienObj.h+'px');
	                	
	                	console.log("Resize de la video");
	                	
	                	_this.hideVideo();
	                	_this.showVideo();
	                }
                }
                
                elem.ctx.fillStyle = "rgba(0,0,0,1)";
    			elem.ctx.fillRect(lienObj.x+decalageX,lienObj.y+decalageY,lienObj.w,lienObj.h);
    			elem.ctx.drawImage(lienObj.icon,(lienObj.x+decalageX)+((lienObj.w-lienObj.icon.width)/2),(lienObj.y+decalageY)+((lienObj.h-lienObj.icon.height)/2),(lienObj.icon.width),(lienObj.icon.height));
        		    			
        	} else if (lienObj.type == _GLOBALS.LinkTypeImageIncruster) {
				_this.drawImageOnContext(elem,lienObj);
  				
           	} else {
           		
  				elem.ctx.fillStyle = "rgba("+lienObj.color+")";
    			elem.ctx.fillRect(lienObj.x+decalageX,lienObj.y+decalageY,lienObj.w,lienObj.h);
           	}

        }
   	}    
   	   	
   	_this.drawImageOnContext = function(elem, lienObj) {
   		
   		if (elem.linksList[lienObj.url]) {
   			_this.onImageReady(elem,elem.linksList[lienObj.url],lienObj);
   		} else {
			var img = new Image();
			img.src = _GLOBALS.CONF.pages.imageIncrustePath + lienObj.url;
			img.onload = function(){
				_this.onImageReady(elem,img,lienObj);
				elem.linksList[lienObj.url] = img;
			}	
   		}	
   	}
   	
   	_this.onImageReady = function(elem, img, lienObj) {
		var ratioW = img.width/lienObj.w;
		var ratioH = img.height/lienObj.h;
		var newW = lienObj.w;
		var newH = lienObj.h;
		var newX = lienObj.xScreen;
		var newY = lienObj.yScreen;
		
		if (ratioH > ratioW) {
			newW = img.width / ratioH;
			newX += (lienObj.w - newW)/2;
		} else {
			newH = img.height / ratioW;
			newY += (lienObj.h - newH)/2;	
		}
		if (elem.ctx)
			elem.ctx.drawImage(img,(newX),(newY),(newW),(newH));
		//console.log('image Draw');	
   	}
   	
   	_this.drawImageOnBody = function(lienObj) {
   		
		$('body').append('<div class="imageParent"></div>');
		$('.imageParent').css({opacity:0});
		$('.imageParent').transition({opacity:1},1000);
		
		var img = new Image();
		img.src = _GLOBALS.CONF.pages.imageFichePath + lienObj.url;
		img.onload = function(){
			var closeSize = ($(window).height() <= 480) ? 36 : 48;
			var windowW = $(window).width()-closeSize;
			var windowH = $(window).height()-closeSize;
			var newW = this.width;
			var newH = this.height;
			var newX = ((windowW - newW)/2) + (closeSize/2);
			var newY = ((windowH - newH)/2) + (closeSize/2);
				
			if (this.width > windowW || this.height > windowH) {
				var newW = windowW;
				var newH = windowH;
				var ratioW = this.width/windowW;
				var ratioH = this.height/windowH;			

				if (ratioH > ratioW) {
					newW = this.width / ratioH;
					newX = ((windowW - newW)/2) + (closeSize/2);
					newY = (closeSize/2);
				} else {
					newH = this.height / ratioW;
					newY = ((windowH - newH)/2) + (closeSize/2);
					newX = (closeSize/2);
				}
			} 
			var div = '';
			div += '<div class="image" style="margin-left:'+(newX)+'px; margin-top:'+(newY)+'px; width:'+(newW)+'px; height:'+(newH)+'px">'
			div += '<img src="'+this.src+'" style="height: 100%;">';
			div += '</div>';
			div += '<div class="close" ';
			div += 'style="margin-left:'+(newX+newW)+'px; margin-top:'+(newY)+'px; width:'+closeSize+'px; height:'+closeSize+'px;">';
			div += '<img src="'+_GLOBALS.CONF.iconesPath+'x_2.png" style="height: 100%; margin-left:-50%; margin-top:-50%;">';
			//div += 'style="background: url('+_GLOBALS.CONF.iconesPath+'x_2.png) no-repeat; ';
			
			div += '</div>';
			
			$('.imageParent').append(div);
			$('.blockCont').css('-webkit-filter','blur(5px)');
			$('.close').click(function() {                                    
				_this.closeImage();                                     
			});
		}
   	}
   			
		
	/* EVENTS */
		
	$(window).bind("resize",function(e)
	{
		_this.hideVideo();
		_this.closeImage();
		_this.resetVideo();
	});
		
	_this.onDragElem = function( ) {
		_this.hideVideo();
	}

	_this.onDropElem = function( ) {
		_this.showVideo();
	}
	
	_this.goToPage = function(nb)
	{
		_this.hideVideo();
		_this.showVideo();
	}

   	
    _this._construct();
}
/*****/

_GLOBALS.callbackLoaded("LinksManager");