var CanvasManager = function(parent)
{
	var _this					= this;
	_this.parent				= parent;
	_this.textureContextList	= new Object();
	_this.imgData				= false;
	_this.pointX				= 0;
	_this.pointY				= 0;
	_this.canvasKey				= _GLOBALS.CONF.pages.canvasKey;
	_this.elementKey			= _GLOBALS.CONF.pages.element;
	_this.lastScale				= 0;
	
	_this.textureHigh			= _GLOBALS.CONF.pages.textureHigh;
	_this.textureLow			= _GLOBALS.CONF.pages.textureLow;
	_this.getTextureHigh		= _GLOBALS.CONF.pages.getTextureHigh;
	_this.getTextureLow			= _GLOBALS.CONF.pages.getTextureLow;
	
	_this.canvasNeedPath		= new Array();
	_this.canvasNeedPath.push(_this.textureLow);
	_this.canvasNeedPath.push(_this.textureHigh);
	
	_this.canvasNeedFormat		= new Array();
	_this.canvasNeedFormat.push(_this.getTextureLow);
	_this.canvasNeedFormat.push(_this.getTextureHigh);
	
	_this.loadTexture = function ( index , cumulIndex , doublePage)
	{
		// Si le canvas !exist
		if(!_this.textureContextList[_this.canvasKey+index] || (cumulIndex && !_this.textureContextList[_this.canvasKey+index][_this.pathLowDKey+cumulIndex] ))
		{
			// Si c'est la page de gauche
			if(!cumulIndex)
			{
				_this.textureContextList[_this.canvasKey+index] = new Object();
			}
			
			var cLs = _this.canvasNeedPath.length;
			for( var nIs = 0 ; nIs < cLs ; nIs++ )
			{
				var canvasNeedPath = _this.canvasNeedPath[nIs];
				_this.textureContextList[_this.canvasKey+index][canvasNeedPath+cumulIndex]				= new Image();
				_this.textureContextList[_this.canvasKey+index][canvasNeedPath+cumulIndex].drawed		= false;				
			}
			// Si c'est la page de gauche
			if(!cumulIndex)
			{
				_this.textureContextList[_this.canvasKey+index][_this.elementKey]			= document.createElement('canvas');
				_this.textureContextList[_this.canvasKey+index][_this.elementKey].height	= _GLOBALS.CONF.getDocument.height;
				_this.textureContextList[_this.canvasKey+index][_this.elementKey].width		= _GLOBALS.CONF.getDocument.width;
				_this.textureContextList[_this.canvasKey+index].ctx							= _this.textureContextList[_this.canvasKey+index][_this.elementKey].getContext('2d');
				_this.constructPos( _this.textureContextList[_this.canvasKey+index] , index );
				// _this.parent.blockCont.append(_this.textureContextList[_this.canvasKey+index][_this.elementKey]);
			}
		
			var cLs = _this.canvasNeedFormat.length;			
			for( var nIs = 0 ; nIs < cLs ; nIs++ )
			{
				_this.drawByFormat( _this.canvasKey+index , _this.canvasNeedFormat[nIs]+cumulIndex , _this.canvasNeedPath[nIs]+cumulIndex , index , cumulIndex );
			}
			
			//HIGH D
			// _this.drawByFormat( _this.canvasKey+index , _this.getHighDKey+cumulIndex , _this.textureKey+cumulIndex , index , cumulIndex );
		}
		
		// Si le traitement en cours concerne la page de gauche && que la page de droite n'est pas encore cre && que la conf est en double page && la page != de la premiere
		// && aussi != de la derniere Alors demande de creer la page de droite sinon retourne l'element CANVAS
		if((!_this.textureContextList[_this.canvasKey+index][_this.pathLowDKey+(cumulIndex+1)] && !cumulIndex) && (_GLOBALS.CONF.pages.doublePage && index != 1 && index != _GLOBALS.CONF.pages.length))
		{
			return _this.loadTexture( index , cumulIndex+1 , doublePage );
		}
		
	    return _this.textureContextList[_this.canvasKey+index][_this.elementKey];
	};
	
	
	_this.drawByFormat = function( canvasKey , getFormatKey , pathFormatKey , index , cumulIndex )
	{
		if( _this.textureContextList[canvasKey][pathFormatKey].drawed )
		{
			return void(0);
		}
		_this.textureContextList[canvasKey][getFormatKey] = function()
		{
			_this.textureContextList[canvasKey][pathFormatKey].onload = function ()
			{
				if(!_this.textureContextList[canvasKey])
				{
					return void(0);
				}
				_this.textureContextList[canvasKey][pathFormatKey].readyToDraw = function(callback)
				{
					var x = _this.textureContextList[canvasKey].pos.x;
					var y = _this.textureContextList[canvasKey].pos.y;
					var width = _this.textureContextList[canvasKey].pos.width;
					var height = _this.textureContextList[canvasKey].pos.height;
					
					_this.textureContextList[canvasKey][pathFormatKey].drawed = true;
					
					try
					{
						_this.textureContextList[canvasKey].ctx.drawImage(this, x+width*cumulIndex , y, width , height );
						/*Kev*/
						if (pathFormatKey == "pathTextureHigh0" || pathFormatKey == "pathTextureHigh1")
							_GLOBALS.main.linksManager.drawLinks(_this.textureContextList[canvasKey], index, cumulIndex);
						/*****/
					}catch(e){
						console.log(e);
					}
					
					if(callback)
					{
						callback(_this.textureContextList[canvasKey]);
					}
				};
				_this.textureContextList[canvasKey][pathFormatKey].readyToDraw();
				return void(0);
			};
			
			if( getFormatKey == _this.getTextureHigh+cumulIndex )
			{
				_this.textureContextList[canvasKey][pathFormatKey].src = UTILS.getPathImage( _GLOBALS.CONF.pages.pathTextureHigh , index+cumulIndex );
			}
			return void(0);
		}
		
		if( getFormatKey == _this.getTextureLow+cumulIndex )
		{
			_this.textureContextList[canvasKey][pathFormatKey].src = UTILS.getPathImage( _GLOBALS.CONF.pages.pathTextureLow , index+cumulIndex );
			_this.textureContextList[canvasKey][getFormatKey]();
		}
		
		return void(0);		
	}
	
	_this.texture = function(index)
	{
		return _this.loadTexture( index , 0 , _GLOBALS.CONF.pages.doublePage );
	}
	
	
	_this.setElem = function(elem,tYpe)
	{
		if(!elem.infoCanvas)
		{
			elem.infoCanvas = {};
		}
		
		if( elem.infoCanvas[tYpe] && elem.infoCanvas[tYpe].needSave )
		{
			return elem;
		}
		
		elem.infoCanvas[tYpe] = {};
		elem.infoCanvas[tYpe] =
		{
			needSave		:false,
			x				:0,
			y				:0,
			pagesWDB		: _GLOBALS.CONF.pagesOnInit.width,
			pagesW			: _GLOBALS.CONF.pagesOnInit.width/2,
			pagesH			: _GLOBALS.CONF.pagesOnInit.height/2,
			docD2W			: _GLOBALS.CONF.getDocument.width/2,
			docD2H			: _GLOBALS.CONF.getDocument.height/2,
			currScale		: _GLOBALS.CONF.pages.currScale,
			addX			: 0,
			addY			: 0,
			pSW				: 0,
			pSH				: 0,
			realPosPageX	: 0,
			realPosPageY	: 0,
			xCenter			: 0,
			yCenter			: 0,
			xDiff			: 0,
			yDiff			: 0,			
			fingerX			: 0,
			fingerY			: 0,
			pDiffX			: 0,
			pDiffY			: 0,			
			pDiffXProp		: 0,
			pDiffYProp		: 0
		}
		
		return elem;
	}
	
	_this.constructPos = function( elem , index , scaleDiff , diffX , diffY , callBack , diffOrigX , diffOrigY , controlManagerPoint)
	{
		elem = _this.setElem(elem,"init");
		elem = _this.setElem(elem,"nat");
		
		var isSimple = false;
		var elemInit = elem.infoCanvas.init;
		// var elemNat = elem.infoCanvas.nat;

		if(!_this.imgData || _GLOBALS.idResize != _this.idResize)
		{
			_this.idResize = _GLOBALS.idResize;
			_this.imgData = elem.ctx.createImageData(_GLOBALS.CONF.getDocument.width, _GLOBALS.CONF.getDocument.height);
		}
		
		elem.ctx.putImageData(_this.imgData, 0, 0);
		
		if( scaleDiff )
		{
			elemInit.currScale += scaleDiff;
		}else
		{
			scaleDiff = 0;
		}

		if( diffX && diffY )
		{
			elemInit.addX = diffX;
			elemInit.addY = diffY;
		}
		
		//Si !double || page == a la premiere page alors la largeur du canvas est /2
		if( !_GLOBALS.CONF.pages.doublePage || index === 1 || ( !UTILS.impair(index) && index === _GLOBALS.CONF.pages.length ) )
		{
			isSimple = true;
			elemInit.pagesWDB /= 2;
		}
		
		elemInit.pSW		= custFloor( (elemInit.pagesWDB) * elemInit.currScale );//largeur page		
		elemInit.pSH		= custFloor( (elemInit.pagesH) * elemInit.currScale );//hauteur page
		
		elemInit.realPosPageX		= elemInit.docD2W - elemInit.pSW;//position x page
		elemInit.realPosPageY		= elemInit.docD2H - elemInit.pSH;//position y page		
		
		
		elemInit.x			= custFloor( (elemInit.realPosPageX - elemInit.addX) );
		elemInit.y			= custFloor( (elemInit.realPosPageY - elemInit.addY) );
		
		
		// elemInit.xCenter	= elemInit.x + elemInit.pagesWDB;
		// elemInit.yCenter	= elemInit.y + elemInit.pagesH;
		
		// elemInit.xDiff		= elemNat.pSW - elemInit.pSW;
		// elemInit.yDiff		= elemNat.pSH - elemInit.pSH;
		
		// if( !diffOrigX || !diffOrigY )
		// {
			// diffOrigX = 0;
			// diffOrigY = 0;			
		// }
	
		var lastX = elemInit.x;
		var lastY = elemInit.y;
		
		if( elemInit.x > elemInit.docD2W )
		{
			elemInit.x = elemInit.docD2W;
		}
		else if( elemInit.x+(elemInit.pagesWDB*2)*elemInit.currScale < elemInit.docD2W )
		{
			elemInit.x = elemInit.docD2W-((elemInit.pagesWDB*2)*elemInit.currScale);
		}
		
		if( elemInit.y > elemInit.docD2H )
		{
			elemInit.y = elemInit.docD2H;
			
		}
		else if( elemInit.y+((elemInit.pagesH*2)*elemInit.currScale) < elemInit.docD2H )
		{
			elemInit.y = elemInit.docD2H-((elemInit.pagesH*2)*elemInit.currScale);
		}
		
		if(controlManagerPoint)
		{
			controlManagerPoint.transformDiffDefX += (lastX - elemInit.x);
			controlManagerPoint.transformDiffDefY += (lastY - elemInit.y);
		}

		if(!elem.pos)
		{
			elem.pos = {};
		}
		
		/*Kev*/
		/*08_10*/		
		if(!elem.linksList)
		{
			elem.linksList = new Array();
		}
		/*******/

		elem.pos.x			= Math.floor(elemInit.x);
		elem.pos.y			= Math.floor(elemInit.y);
		elem.pos.currScale	= elemInit.currScale;
		elem.pos.width		= _GLOBALS.CONF.pagesOnInit.width * elemInit.currScale;
		elem.pos.height		= _GLOBALS.CONF.pagesOnInit.height * elemInit.currScale;
		
		
		imgDatatpW = elem.pos.width;
		imgDatatpH = elem.pos.height;
		
		if(!isSimple)
		{
			imgDatatpW = elem.pos.width*2;
		}
		
		var chadX = 0;
		var chady = 0;
		var chadblur = 10;
		if( elemInit.currScale === _GLOBALS.CONF.pages.currScale )
		{
			elem.ctx.save();
			elem.ctx.shadowColor = 'black';
			elem.ctx.shadowBlur = chadblur;
			elem.ctx.shadowOffsetX = chadX;
			elem.ctx.shadowOffsetY = chady;
			elem.ctx.fillStyle = "rgba(100,100,100,0.5)";
			elem.ctx.fillRect( elem.pos.x , elem.pos.y , imgDatatpW , imgDatatpH );
			elem.ctx.restore();
		}
		if(callBack)
		{
			callBack(elem);
		}
	}
	
	_this._construct = function()
	{
		return void(0);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("CanvasManager");var CarrouselManager = function( parent , objName )
{
	var _this = this;
	_this.objName;
	_this.parent;
	_this.tools				= parent.xmlLinksList.getXml.tools;
	_this.contDiv			= "";
	_this.objectToAppend	= "";
	_this.appendToElem		= "";
	_this.thumbs			= {};
	_this.thumbs.width		= "";
	_this.thumbs.height		= "";
	_this.thumbs.marginLeft	= "";
	_this.imgList			= {};
	_this.carrouselClassName	= "";
	_this.thumbSizeW		= 0;
	_this.carrouselTouchMoveIs = false;
	_this.carrouselTouchMovePosXDif = 0;
	_this.carrouselTouchMovePosXDifOriginal = 0;
	_this.posElem			= 0;
	_this.originPosElem		= 0;
	_this.maxthumbs			= 5;
	_this.rotatTime			= 300;
	_this.xTime				= 200;
	_this.goToThumbTimer	= false;
	_this.perspectiveCss3	= "100px";
	_this.degCss3			= "360";
	_this.countNeedLoad		= 0;
	_this.countNeedLoadonLoading = 0;
	_this.carrousel			= false
	_this.addressToLoadAfter = 0;
	_this.addressToLoadBefor = 0;
	_this.ul_sousCarrousel = "ul_sousCarrousel";
	_this.languePage		= _GLOBALS.main.xmlLinksList.getXml.langue.find("menuitem[index=93]").attr("label");
	_this._construct = function()
	{
		if(!_this.checkIfCustomEnabled())
		{
			return false;
		}
		
		_this.constructMenuCss();
	}
	
	_this.transitBasic = function( elem , posOrNeg , timeT )
	{
		if(!timeT)
		{
			timeT = 0;
		}
		elem.clearQueue();
		elem.transition(
		{
			// perspective: _this.perspectiveCss3,
			// rotateY: _this.degCss3*posOrNeg
		},timeT);
		elem.attr("style",elem.attr("style")+"transform:translateZ(100px)")
		return false;
	}
	
	_this.checkIfCustomEnabled = function()
	{
		var carrousel = "";
		if(!_this.carrousel)
		{
			carrousel = _this.carrousel = _this.tools.find("carrousel");
		}else
		{
			carrousel = _this.carrousel;
		}
		
		_this.carrouselClassName = carrousel.attr("className");
		_this.sousCarrousel = _this.carrouselClassName+" .sousCarrousel";
		_this.objectToAppend = "<div class='"+_this.carrouselClassName+"'></div>";
		_this.appendToElem = $(carrousel.attr("appendToElem"));
		
		if( !carrousel.attr("enabled") || carrousel.attr("enabled") == "false" )
		{
			return false;
		}
		// thumbs
		var thumbs = carrousel.find("thumbs");
		_this.thumbs.width = Math.floor(thumbs.attr("width"));
		_this.thumbs.height = Math.floor(thumbs.attr("height"));
		_this.thumbs.marginLeft = Math.floor(thumbs.attr("marginLeft"));
		
		return true;
	}
	
	_this.constructMenuCss = function()
	{
		var carrousel = "";
		if(!_this.carrousel)
		{
			carrousel = _this.carrousel = _this.tools.find("carrousel");
		}else
		{
			carrousel = _this.carrousel;
		}
		var defCss = carrousel.children("defCss");
		var styleCur = "";
		if(defCss)
		{
			styleCur = document.createElement("style");
			$(styleCur).append(defCss.text());
			$("head").append($(styleCur));
		}
	}
	
	_this.carrouselTouchMove = function(event,curThis)
	{
		var eventTouch = event;
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		
		_this.carrouselTouchMoveIs = true;	
		_this.carrouselTouchMovePosXDif = (_this.carrouselTouchMovePosXDifOriginal - eventTouch.pageX);
		_this.posElem = _this.originPosElem - _this.carrouselTouchMovePosXDif;
		
		if( _this.posElem >= 0 || _GLOBALS.CONF.getDocument.width >= (_this.thumbSizeW*_GLOBALS.CONF.pages.length))
		{
			_this.posElem = 0;
			_this.originPosElem = 0;
			_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
		}else if( _this.posElem-_GLOBALS.CONF.getDocument.width <= -(_this.thumbSizeW*_GLOBALS.CONF.pages.length) && (_GLOBALS.CONF.getDocument.width<_this.thumbSizeW*_GLOBALS.CONF.pages.length))
		{
			_this.posElem = -(_this.thumbSizeW*_GLOBALS.CONF.pages.length)+_GLOBALS.CONF.getDocument.width;
			_this.originPosElem = _this.posElem;
			_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
			
			//nombre de thumbs par ecran
			var nThumbsLastForGetCurrent = -Math.floor(((_this.posElem/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
			_this.thumbsManager(nThumbsLastForGetCurrent);
		}else
		{
			//nombre de thumbs par ecran
			var nThumbsLastForGetCurrent = -Math.floor(((_this.posElem/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
			_this.thumbsManager(nThumbsLastForGetCurrent);
		}
		$("."+_this.sousCarrousel).clearQueue();
		$("."+_this.sousCarrousel).transition(
		{
			x:_this.posElem
		}, 0 )
		return false;
	}
	
	_this.carrouselTouchStart = function(event,curThis)
	{
		var eventTouch = event;
		
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		// var target = event.target || event.srcElement;
		// event est l'objet Event
		
		_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
		
		var elemPos = $("."+_this.sousCarrousel).position();
		var elemPosX = elemPos.left;
		_this.originPosElem = elemPosX;
		
		if(_GLOBALS.main.touchableInfo)
		{
			curThis.bind( "touchmove" , function(e)
			{
				_this.carrouselTouchMove(e);
			})
		}else
		{
			curThis.bind( "mousemove" , function(e)
			{
				_this.carrouselTouchMove(e);
			})
		}
		

		UTILS.preventDefault(event);
		return false;
	}
	
	_this.goToThumb = function( gotoPage , target )
	{
		if(!target)
		{
			var target = $("."+_this.sousCarrousel).find("li[gotopage="+gotoPage+"]");
			if( !target.length )
			{
				return void(0);
			}
		}
		
		var currPos	= 0;
		var leftP	= 0;

		currPos		= $(target).position();
		var targetX	= leftP = currPos.left;

		if( leftP < _this.originalPosThumbCenter )
		{
			leftP = 0;
		}else
		{
			leftP = leftP - _this.originalPosThumbCenter;
		}
		$("."+_this.sousCarrousel).clearQueue();
		$("."+_this.sousCarrousel).transition(
		{
			x:-leftP
		}, _this.xTime )

		
		$(".positioneur").clearQueue();
		
		var posX =  targetX;
		var scaleW = 2;
		var xOrigine = 0;
		var checPair = UTILS.byPageIfDouble(parseInt(gotoPage));
		if(checPair.isDouble)
		{
			scaleW = 2;	
		}
		else
		{
			scaleW = 1;
		}

		$(".positioneur").transition(
		{
			x:posX,
			scale:[scaleW,1]
		},_this.xTime)
		
		_this.lastTarget = $(target);
		return false;
	}
	
	_this.carrouselTouchEnd = function(event,curThis)
	{
		var eventTouch = event;
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		
		_this.carrouselTouchMovePosXDifOriginal = 0;
		if(_GLOBALS.main.touchableInfo)
		{
			curThis.unbind("touchmove");
		}else
		{
			curThis.unbind("mousemove");
		}
		
		if(_this.carrouselTouchMoveIs)
		{
			_this.carrouselTouchMovePosXDif = 0;
			_this.carrouselTouchMoveIs = false;
			return void(0);
		}
		
		var target = event.target || event.srcElement;		
		
		var gotoPage = $(target).attr("gotopage");
		
		if(gotoPage)
		{
			_GLOBALS.main.controlManager.goToPage(gotoPage);
		}

		UTILS.preventDefault(event);
	}
	
	
	_this.loadThumbImg = function( i , diapo , addTo , thumbSizeW , needToload , callBack )
	{
		if(_this.imgList[i])
		{
			_this.imgList[i].askForDeletable = false;
			_this.countNeedLoadonLoading++;
			if( parseInt(_this.countNeedLoad) === parseInt(_this.countNeedLoadonLoading) && callBack )
			{
				callBack();
			}
			return void(0);
		}
		var posXImg = 0;
		var currImg = new Image();
		var currImgLi = "<li><span goToPage='"+i+"'>"+_this.languePage+" "+UTILS.byOffsetIndex(i)+"</span></li>"
		currImgLi = $(currImgLi);
		$(currImg).attr("goToPage",i);
		currImgLi.attr("goToPage",i);
		currImgLi.clearQueue();
		
		var checPair = UTILS.byPageIfDouble(i);
		if(checPair.isDouble)
		{
			if( checPair.isDoublePage[1] )
			{
				posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
			}else
			{
				posXImg = ((i-1)*thumbSizeW-((_this.thumbs.marginLeft)))-1;
			}			
		}
		else
		{
			posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
		}
		
		currImgLi.css(
		{
			left:posXImg
		})
		
		_this.transitBasic( currImgLi , 1 );
		currImg.onload = function()
		{
			_this.countNeedLoadonLoading++;
			var testFinde = addTo.find("[goToPage="+i+"]");
			if(!testFinde.length)
			{
				currImgLi.append($(this));
				addTo.append(currImgLi);
			}
			
			_this.transitBasic( currImgLi , 0 , _this.rotatTime );
			if( parseInt(_this.countNeedLoad) === parseInt(_this.countNeedLoadonLoading) && callBack )
			{
				callBack();
			}			
		}
		currImg.src = UTILS.getPathImage( diapo , i );
		_this.imgList[i] = currImgLi;
		return void(0);
	}
	
	_this.resetAll = function()
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				$("."+_this.sousCarrousel).children("img").remove();
				_this.imgList[J] = null;
				delete _this.imgList[J];
			}
			// _this.thumbsManager();
			// _this.goToThumb(  _GLOBALS.main.pagesLoader.pageCurrentOriginalIs+1  );
		}
	}
	
	_this.thumbsManager = function( loadAddThumbs , callBack )
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				if( J < _this.addressToLoadBefor )
				{
					_this.imgList[J].askForDeletable = true;
					$(_this.imgList[J]).clearQueue();
					$(_this.imgList[J]).transition(
					{
						// rotateY: _this.degCss3
					},_this.rotatTime,function()
					{
						var currJ = $(this).attr("goToPage");
						if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
						{
							return false;
						}
						$(this).remove();
						_this.imgList[currJ] = null;
						delete _this.imgList[currJ];
						return false;
					});
				}else if(  J > _this.addressToLoadAfter )
				{
					_this.imgList[J].askForDeletable = true;
					$(_this.imgList[J]).clearQueue();
					$(_this.imgList[J]).transition(
					{
						// rotateY: _this.degCss3
					},_this.rotatTime,function()
					{
						var currJ = $(this).attr("goToPage");
						if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
						{
							return false;
						}
						$(this).remove();
						_this.imgList[currJ] = null;
						delete _this.imgList[currJ];
						return false;
					});
				}
			}
		}
		
		var currPage = 0;
		
		if( loadAddThumbs )
		{
			currPage = Math.floor(loadAddThumbs);
		}else
		{
			currPage = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		}
		
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var thumbSizeW	= _this.thumbSizeW;
		var pagesLength	= _GLOBALS.CONF.pages.length;
		
		if( _this.maxthumbs > pagesLength )
		{
			_this.maxthumbs = pagesLength;
		}
		else if( _this.maxthumbs < 1)
		{
			_this.maxthumbs = 1;
		}		
		
		var befor = Math.floor(_this.maxthumbs/2);
		var after = Math.floor(_this.maxthumbs/2)+_this.maxthumbs%2;
		var addTo = $("."+_this.sousCarrousel);
		var countPassAfter = 0;
		var countPassBefor = 0;
		
		if( currPage+after > pagesLength )
		{
			after = pagesLength-currPage;
		}
		
		if( befor > currPage )
		{
			befor = currPage-1;
		}
		
		var checkDif = _this.maxthumbs - (after+befor);
		
		if( after > befor )
		{
			after+=checkDif;
		}else
		{
			befor+=checkDif;
		}
		
		_this.addressToLoadAfter = currPage+after;
		_this.addressToLoadBefor = currPage-befor;
		
		_this.countNeedLoadonLoading = 0;
		_this.countNeedLoad = 0;
		_this.countNeedLoad = after+befor;
		for( var i = currPage ; i <= _this.addressToLoadAfter && i!==0 && i <= pagesLength ; i++ )
		{
			_this.loadThumbImg( i , diapo, addTo , thumbSizeW , after+befor , callBack );
		}

		for( var i = currPage ; i >= _this.addressToLoadBefor  && i!==0 && i <= pagesLength ; i-- )
		{
			_this.loadThumbImg( i , diapo , addTo , thumbSizeW , after+befor , callBack );
		}
		
		return false;
	}
	
	_this.resized = function()
	{
		_this.thumbSizeW = (_this.thumbs.width)+(_this.thumbs.marginLeft)*2;
		//nombre de thumbs par ecran
		_this.originalPosThumb = Math.floor(_GLOBALS.CONF.getDocument.width/_this.thumbSizeW)+1;
		
		if( _this.maxthumbs < _this.originalPosThumb )
		{
			_this.maxthumbs =_this.originalPosThumb;
		}
		_this.originalPosThumbCenter = (Math.floor(_GLOBALS.CONF.getDocument.width/2))-(_this.thumbSizeW/2);
		return false;
	}
	
	_this.getCarrouselManager = function()
	{
		_this.resized();
		var pagesLength	= _GLOBALS.CONF.pages.length;
		var thumbSizeW	= _this.thumbSizeW;
		var sizeCarW	= pagesLength*thumbSizeW;
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var objIntern	= $(_this.objectToAppend);
		
		objIntern.append("<ul class='sousCarrousel' style='height:100%;width:"+sizeCarW+"px;' ><li class='positioneur' ></li></ul>");
		
		_this.appendToElem.append(objIntern);
		$(".positioneur").css(
		{
			width:_this.thumbs.width,
			transformOrigin: '0px 0px'
		});
		if(_GLOBALS.main.touchableInfo)
		{
			$("."+_this.carrouselClassName).bind('touchstart', function(event)
			{
				_this.carrouselTouchStart( event , $(this) );	
			});
			
			$("."+_this.carrouselClassName).bind('touchend', function(event)
			{
				_this.carrouselTouchEnd( event , $(this) );	
			});
		}else
		{
			$("."+_this.carrouselClassName).bind("mousedown",function(event)
			{
				_this.carrouselTouchStart( event , $(this) );
			})
			
			$("."+_this.carrouselClassName).bind("mouseup",function(event)
			{
				_this.carrouselTouchEnd( event , $(this) );
			})
		}

		_this.thumbsManager();
		
		_GLOBALS.main.pagesLoader.onPageChange(function(currPage)
		{
			if(!_GLOBALS.main.controlManager.showToolsInfo)
			{
				return void(0);
			}
			
			if(_this.goToThumbTimer)
			{
				clearTimeout(_this.goToThumbTimer);
			}
			
			_this.goToThumbTimer = setTimeout(function()
			{
				_this.thumbsManager(currPage, function()
				{
					if(_GLOBALS.main.controlManager.showToolsInfo)
					{
						_this.goToThumb( currPage );
					}
				})
			},60)
			return void(0);
		});
		
		UTILS.onResizeCustom(function()
		{
			_this.resetAll();
			$(".contentMenuBottom").remove();
			_this.getCarrouselManager();
		});
		
		_GLOBALS.main.controlManager.onShowTools(function(info)
		{
			if(info)
			{
				_this.thumbsManager();
				setTimeout( function()
				{
					_this.goToThumb(  _GLOBALS.main.pagesLoader.pageCurrentOriginalIs  );
				}, 400 );
			}
		});
		
		return false;
	}
	return _this._construct();
}
_GLOBALS.callbackLoadedTmp("CarrouselManager");var ControlManager = function(parent)
{
	var _this 				= this;
	_this.parent 			= parent;
	_this.scaleXDefault 	= 0;
	_this.autoriseChangePage = true;
	_this.originalMiddleX 	= null;
	_this.originalMiddleY 	= null;
	_this.diffScaleDef		= 0;
	_this.diffScale			= 0;
	_this.originalScaleDiff	= 0;
	_this.transformDiffX 	= 0;
	_this.transformDiffY 	= 0;
	_this.transformDiffDefX = 0;
	_this.transformDiffDefY = 0;
	_this.currPosFingerX 	= null;
	_this.currPosFingerY 	= null;
	_this.requestAnimationFrame = false;
	_this.needScaleTo		= 0;
	_this.scaledTo			= false;
	_this.originalScaleDiffMaxDiff = _GLOBALS.CONF.pages.currScaleMaxDiff;
	_this.originalScaleDiffMinDiff = _GLOBALS.CONF.pages.currScaleMinDiff;
	_this.byOneFingers		= false;
	_this.showToolsInfo		= 0;
	_this.onScaleGoList		= new Array();
	_this.onScaleGoListEnd	= new Array();	
	_this.toolsList			= new Array();
	_this.onshowToolsArray	= new Array();
	_this.onTransitionPageWait	= false;
	_this.onTransitionPageArray	= new Array();
	
	_this.showTools = function(info)
	{
		if( !_this.toolsList.length )
		{
			var tools = _this.parent.xmlLinksList.getXml.tools;
			tools.children().each(
			function(e)
			{
				if( $(this).attr("enabled") == "true" )
				{
					_this.toolsList.push($(this));
				}
			});
		}
		
		if( info == "hide" )
		{
			_this.showToolsInfo = 0;
		}
		else if( info == "show" )
		{
			_this.showToolsInfo = 1;
		}
		else if( !_this.showToolsInfo )
		{
			_this.showToolsInfo = 1;
		}
		else
		{
			_this.showToolsInfo = 0;
		}
		
		for( var J in _this.toolsList )
		{
			var obj					= _this.toolsList[J];
			var className			= obj.attr("className");
			var attrAfterTransition = dataToObject(obj.attr("afterTransition"));
			var attrBeforTransition = dataToObject(obj.attr("beforTransition"));
			var attrAfterCss 		= dataToObject(obj.attr("afterCss"));
			var attrBeforCss 		= dataToObject(obj.attr("beforCss"));
			var attrTimeTransition	= obj.attr("timeTransition");
			
			if(!attrTimeTransition)
			{
				attrTimeTransition = 0;
			}			
			$("."+className).clearQueue();
			if( !_this.showToolsInfo )
			{
				//HIDE TOOLS
				if( attrBeforTransition && attrAfterTransition )
				{
					$("."+className).transition(attrBeforTransition,attrTimeTransition,function()
					{
						$(this).css(attrBeforCss);
					});
				}
			}
			else
			{
				//SHOW TOOLS
				$("."+className).css(attrAfterCss);
				$("."+className).transition(attrAfterTransition,attrTimeTransition);
			}
		}
		
		_this.onShowedTools();
	}
	
	_this.onShowTools = function(callback)
	{
		_this.onshowToolsArray.push(callback);
	}
	
	_this.onShowedTools = function()
	{
		var tL = _this.onshowToolsArray.length;
		for( var i = 0 ; i < tL ; i++ )
		{
			_this.onshowToolsArray[i](_this.showToolsInfo);
		}
	}
	
	_this.nextPage = function()
	{
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}
		
		var toAddIndexNext = 1;
		var infoPage = UTILS.byPageIfDouble(_this.parent.pagesLoader.pageCurrentOriginalIs);			
		if( infoPage["isDouble"] )
		{
			toAddIndexNext = 2;
		}
		
		if( _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+toAddIndexNext)] )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+toAddIndexNext)];
			currElemeIs.css('z-index',"1");
			currElemeIs.transition({x:0},_GLOBALS.CONF.pages.animationManager.transitionTime);
		}
		
		if( _this.parent.pagesLoader.pageCurrentOriginalIs < _GLOBALS.CONF.pages.length && infoPage["isDouble"] && (_this.parent.pagesLoader.pageCurrentOriginalIs+1) == _GLOBALS.CONF.pages.length )
		{
			
		}
		else if( _this.parent.pagesLoader.pageCurrentOriginalIs < _GLOBALS.CONF.pages.length )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			currElemeIs.css('z-index',"0");
			currElemeIs.transition({x:-_GLOBALS.CONF.getDocument.width},_GLOBALS.CONF.pages.animationManager.transitionTime);
		}else
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			// currElemeIs.clearQueue();
			currElemeIs.css('z-index',"1");
			currElemeIs.transition({x:0},_GLOBALS.CONF.pages.animationManager.transitionTime);
		}
		// console.log(_GLOBALS.main.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_GLOBALS.main.pagesLoader.pageCurrentOriginalIs]);
		setTimeout(function()
		{
			_this.parent.pagesLoader.nextPage();
		},16)
		return void(0);
	}
	
	_this.prevPage = function()
	{
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}

		var toAddIndexNext = 1;
		var infoPage = UTILS.byPageIfDouble(_this.parent.pagesLoader.pageCurrentOriginalIs-toAddIndexNext);			
		if( infoPage["isDouble"] )
		{
			toAddIndexNext = 2;
		}
		
		if( _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-toAddIndexNext)] )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-toAddIndexNext)];
			currElemeIs.css('z-index',"1");
			currElemeIs.transition({x:0},_GLOBALS.CONF.pages.animationManager.transitionTime);
		}	
		
		if( _this.parent.pagesLoader.pageCurrentOriginalIs > 1 )
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			currElemeIs.css('z-index',"0");
			currElemeIs.transition({x:_GLOBALS.CONF.getDocument.width},_GLOBALS.CONF.pages.animationManager.transitionTime);
		}else
		{
			var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
			// currElemeIs.clearQueue();
			currElemeIs.css('z-index',"1");
			currElemeIs.transition({x:0},_GLOBALS.CONF.pages.animationManager.transitionTime);
		}
		
		setTimeout(function()
		{
			_this.parent.pagesLoader.prevPage();
		},16)
		return void(0);
	}
	
	_this.goToPage = function(nb)
	{
		if(_this.scaledTo)
		{
			_this.scaleEnd()
			_this.scaleGo(false,false,false,1);
			
			setTimeout(function()
			{
				/*Kev*/
				_this.parent.linksManager.goToPage(nb);	
				/*****/
				_this.parent.pagesLoader.goToPage(nb);
			},_GLOBALS.CONF.pages.animationManager.zoomTime+10);
			return void(0);
		}
		
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}
		
		/*Kev*/
		_this.parent.linksManager.goToPage(nb);	
		/*****/
		
		_this.parent.pagesLoader.goToPage(nb);
		return void(0);
	}
	
	_this.onDragElem = function( moveDiffX , moveDiffY , eventTouch )
	{
		if(!_this.autoriseChangePage)
		{
			_this.parent.controlManager.scaleGo(false,false,eventTouch,0);
			return void(0);
		}
		
		/*Kev*/
		_this.parent.linksManager.onDragElem();
		/*****/
		
		_this.onTransitionPageWait = true;
		_this.parent.positionForSlider.onDragElem( moveDiffX );
		return void(0);
	}	
	
	_this.onDropElem = function(moveDiffX)
	{
		if(!_this.autoriseChangePage)
		{
			_this.scaleEnd();
			return void(0);
		}
		
		/*Kev*/
		_this.parent.linksManager.onDropElem();
		/*****/
		
		_this.onTransitionPageWait = false;
		_this.parent.positionForSlider.onDropElem( moveDiffX );
		return void(0);
	}	
	
	_this.onTransitionPage = function(callBack)
	{
		_this.onTransitionPageArray.push(callBack);
		return _this.onTransitionPageArray.length;
	}
	
	_this.onTransitionedPage = function()
	{
		if( _this.onTransitionPageWait )
		{
			return false;
		}
		
		var tL = _this.onTransitionPageArray.length;
		for( var i = 0 ; i < tL ; i++ )
		{
			_this.onTransitionPageArray[i]( i , _this.parent.pagesLoader.pageCurrentOriginalIs );
		}
	}
	
	_this.initialPage = function()
	{
		if(!_this.autoriseChangePage)
		{
			return void(0);
		}
		
		_this.parent.positionForSlider.positionIt( _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs] , _this.parent.pagesLoader.pageCurrentOriginalIs , _this.parent.pagesLoader.pageCurrentOriginalIs );
		return void(0);
	}
	
	_this.resetZoomInfo = function()
	{
		// _this.scaleGo(false,false);
		var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var difProp = _GLOBALS.CONF.pages.sensibleZoom;
		_this.autoriseChangePage = false;
		
		_this.currPosFingerX	= 0;
		_this.currPosFingerY	= 0;
		
		_this.needScaleTo		= _GLOBALS.CONF.pages.scaleDoublTapMin;
	
		_this.diffScale =  0;
		// currElemeIs.clearQueue();
		currElemeIs.transition(
		{
			x: 0
		},0);
		
		_this.scaledTo = false;
		_this.autoriseChangePage = true;
		_this.lastIndexPage = _this.parent.pagesLoader.pageCurrentOriginalIs;
	}
	
	_this.onScaleGo = function( addCallback , addCallbackEnd)
	{
		if(addCallback)
		{
			_this.onScaleGoList.push(addCallback);
		}		
		if(addCallbackEnd)
		{
			_this.onScaleGoListEnd.push(addCallbackEnd);
		}
		return void(0);
	}
	
	_this.onScaledGo = function( inOut )
	{
		if(inOut)
		{
			var sclLength = _this.onScaleGoList.length;
			for( var i = 0; i < sclLength ; i++ )
			{
				_this.onScaleGoList[i]();
			}
		}else
		{
			var sclLength = _this.onScaleGoListEnd.length;
			for( var i = 0; i < sclLength ; i++ )
			{
				_this.onScaleGoListEnd[i]();
			}
		}
		return void(0);		
	}
	
	_this.scaleGo = function(finger0,finger1,touchStartEvent,getScale)
	{
		var currElemeIs = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var difProp = _GLOBALS.CONF.pages.sensibleZoom;
		_this.autoriseChangePage = false;
		
		if( !finger0 && !finger1 )
		{
			_this.byOneFingers = true;
			if(touchStartEvent)
			{
				finger0 = touchStartEvent;
				finger1 = touchStartEvent;
			}else
			{
				finger0 = {};
				finger1 = {};
				finger0.pageX =  _GLOBALS.CONF.getDocument.width/2;
				finger1.pageX =  _GLOBALS.CONF.getDocument.width/2;
			}			
		}
		else
		{
			if(_this.byOneFingers)
			{
				_this.byOneFingers = false;
				_this.scaleEnd();
			}
		}

		if(getScale)
		{
			if(_this.scaledTo)
			{
				_this.needScaleTo		= _GLOBALS.CONF.pages.scaleDoublTapMin;
			}
			else
			{
				_this.needScaleTo		= _GLOBALS.CONF.pages.currScaleMaxDiff/2;
				_this.originalScaleDiff	= 0;
				_this.diffScaleDef		= _this.needScaleTo;
				// _this.transformDiffDefX = _GLOBALS.CONF.getDocument.width/2;
				// _this.transformDiffDefY = _GLOBALS.CONF.getDocument.height/2;
			}
		}
		
		/*By one fingers OR By two fingers*/
		var middleX		= (finger0.pageX+finger1.pageX)/2;
		var middleY		= (finger0.pageY+finger1.pageY)/2;
		
		_this.currPosFingerX = middleX;
		_this.currPosFingerY = middleY;
		
		if(!_this.originalMiddleX)
		{
			_this.originalMiddleX = middleX;
			_this.originalMiddleY = middleY;
		}
		
		
		_this.transformDiffX = _this.transformDiffDefX+(_this.originalMiddleX-middleX);
		_this.transformDiffY = _this.transformDiffDefY+(_this.originalMiddleY-middleY);
		
		var a2			= Math.pow(Math.abs(finger0.pageX-finger1.pageX),2);
		var b2			= Math.pow(Math.abs(finger0.pageY-finger1.pageY),2);
		var c2			= Math.sqrt(a2+b2);
		_this.diffScale	= (c2*difProp);
		
		if(!_this.originalScaleDiff)
		{
			_this.originalScaleDiff = _this.diffScale;
		}
	
		_this.diffScale =  (_this.diffScale - _this.originalScaleDiff) + _this.diffScaleDef;

		if( _this.diffScale <= _this.originalScaleDiffMinDiff )
		{
			_this.diffScale				= _this.originalScaleDiffMinDiff;
			_this.autoriseChangePage	= true;
		}
		else if( _this.diffScale >= _this.originalScaleDiffMaxDiff )
		{
			_this.diffScale = _this.originalScaleDiffMaxDiff;
		}

		currElemeIs.transition(
		{
			x: 0			
		},0);
		
		if(!_this.requestAnimationFrame)
		{
			if(getScale)
			{
				if(_this.scaledTo)
				{
					_this.scaledTo = false;
					_this.autoriseChangePage = true;
					_this.scaleEnd();
					_this.onScaledGo(false);
				}else
				{
					_this.goRenderSimple();
					_this.scaledTo = true;
					_this.scaleEnd();
					_this.onScaledGo(true);
				}
			}else
			{
				_this.goRender();
			}
		}
		_this.lastIndexPage = _this.parent.pagesLoader.pageCurrentOriginalIs;
	}
	
	_this.scaleEnd = function()
	{
		drawCanvasTime( null , 1 , _this.requestAnimationFrame );		
		_this.requestAnimationFrame = false;
		_this.originalMiddleX		= null;
		_this.originalMiddleY		= null;
		
		if( !_this.autoriseChangePage )
		{
			_this.scaledTo			= true;
			_this.originalScaleDiff	= 0;
			_this.diffScaleDef		= _this.diffScale;
			_this.transformDiffDefX = _this.transformDiffX;
			_this.transformDiffDefY = _this.transformDiffY;			
		}else
		{
			_this.scaledTo = false;
			_this.reScaleCanvasToInitAnim( _this.diffScale , _this.transformDiffX , _this.transformDiffY , null , function()
			{
				_this.diffScale				= 0;
				_this.originalScaleDiff 	= 0;
				_this.diffScaleDef			= 0;
				_this.transformDiffDefX 	= 0;
				_this.transformDiffDefY 	= 0;
				_this.transformDiffX		= 0;
				_this.transformDiffY		= 0;
				_this.autoriseChangePage	= true;
			},false);
		}
		return void(0);
	}

	_this.reScaleCanvas = function( scaleDiff , diffX , diffY , currPosFingerX , currPosFingerY )
	{
		var cvs = _this.parent.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_this.parent.pagesLoader.pageCurrentOriginalIs];
		_this.parent.canvasManager.constructPos( cvs , _this.parent.pagesLoader.pageCurrentOriginalIs , scaleDiff , diffX , diffY , function(elem)
		{
			var numCur = 0;
			if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
			}
			else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
			}
			
			var numCur = 1;
			if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
			}
			else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
			{
				cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
			}
			return void(0);
		},currPosFingerX , currPosFingerY , _this);
		return void(0);	
	}
	
	_this.goRender = function()
	{
		_this.reScaleCanvas( _this.diffScale , _this.transformDiffX , _this.transformDiffY , _this.currPosFingerX , _this.currPosFingerY );
		_this.requestAnimationFrame = drawCanvasTime( _this.goRender );
	}
	
	_this.goRenderSimple = function()
	{
		_this.reScaleCanvasToInitAnim( _this.diffScale , _this.transformDiffX , _this.transformDiffY , false , false , true);
	}
	
	_this.reScaleCanvasToInitAnim = function( scaleDiff , diffX , diffY , callBack, callBackAfterAnim , lowToHigh )
	{
		var elem		= _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var cvs			= _this.parent.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_this.parent.pagesLoader.pageCurrentOriginalIs];
		var cDiffX		= 0 ;
		var cDiffY		= 0 ;

		elem.animate(
		{
			getEasingAnim:1
		},
		{
			step:function( now , fx )
			{
				if(lowToHigh)
				{
					cScaleDiff	= (_this.originalScaleDiffMaxDiff/2)*now;				
				}else
				{
					cScaleDiff	= (scaleDiff/2)-(scaleDiff/2)*now;
				}
				
				cDiffX		= diffX*(1-now);
				cDiffY		= diffY*(1-now);
				
				if( cScaleDiff <= _this.originalScaleDiffMinDiff )
				{
					cScaleDiff = _this.originalScaleDiffMinDiff;
				}
				else if( cScaleDiff > _this.originalScaleDiffMaxDiff )
				{
					cScaleDiff = _this.originalScaleDiffMaxDiff;
				}
				
				_this.parent.canvasManager.constructPos( cvs , _this.parent.pagesLoader.pageCurrentOriginalIs , cScaleDiff , cDiffX , cDiffY , function(cvs)
				{
					var numCur = 0;
					if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
					}
					else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
					}
					
					var numCur = 1;
					if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureHigh+numCur].readyToDraw();
					}
					else if( cvs[_GLOBALS.CONF.pages.getTextureLow+numCur] && cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw )
					{
						cvs[_GLOBALS.CONF.pages.textureLow+numCur].readyToDraw();
					}
					return void(0);
				});
			},
			complete:function()
			{
				$(this)[0].getEasingAnim = 0;
				
				if(callBackAfterAnim)
				{
					callBackAfterAnim();
				}
				// _this.scaleEnd();
			},
			duration:_GLOBALS.CONF.pages.animationManager.zoomTime,
			easing:"linear"
		});	
	}
	
	
	_this.drawCanvas = function()
	{
		var numCur = 0;
		var cvs = _this.parent.canvasManager.textureContextList[_GLOBALS.CONF.pages.canvasKey+_this.parent.pagesLoader.pageCurrentOriginalIs];
		if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && !cvs[_GLOBALS.CONF.pages.textureHigh+numCur].drawed )
		{
			cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur]();
		}
		
		var numCur = 1;
		if(	cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur] && !cvs[_GLOBALS.CONF.pages.textureHigh+numCur].drawed )
		{
			cvs[_GLOBALS.CONF.pages.getTextureHigh+numCur]();
		}
	}
	
	_this._construct = function()
	{
		return void(0);
	}
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("ControlManager");var EventManagerFlip = function( parent , elem )
{
	var _this					= {};
	
	_this.currDate				= new Date();
	
	_this.elem					= elem;	
	
	_this.parent				= parent;
	_this.objName				= "";
	_this.swipConfX				= 5;//%
	_this.swipConfTime			= 400;
	
	_this.moveConfX				= 20;//%
	
	_this.currDateTouchStart	= 0;
	_this.currDateTouchEnd		= 0;
	
	_this.goDoubleTouchTime		= 300;//ms

	_this.doubleTapTimeStart	= 0;
	_this.doubleTapTimeEnd		= 0;
	_this.isDoubleTapTimeStart	= 0;
	_this.isDoubleTapTimeEnd	= 0;
    
	_this.isMultiTouch 			= 0;
	_this.touchMoveEvent		= false;
	_this.originaleMoveEvent	= false;
	
	_this.moveDiffX				= 0;
    _this.moveDiffY				= 0;
    
    _this.touchMoveEventHist	= 0;
    
	_this.currentMouse_x		= 0;
	_this.currentMouse_y		= 0;
	
	_this.mouseStart_x			= 0;    
	_this.mouseStart_y			= 0;
	
	_this.touchable				= false;
	_this.handler 				= {};
	_this.handler.TouchMove		= "mousemove";
	_this.handler.TouchStart	= "mousedown";
	_this.handler.TouchEnd		= "mouseup";

	
	_this.touchableInfo			= isEventSupported("touchstart",elem[0]);
	
	_GLOBALS.touchableInfo		= _this.touchableInfo;
	
	//_this.touchableInfo			= false;
	
	if( _this.touchableInfo )
	{
		_this.touchable = true;
		_this.handler.TouchMove	= "touchmove";
		_this.handler.TouchStart= "touchstart";
		_this.handler.TouchEnd	= "touchend";
	}

	_this.myConstruct = function()
	{
		_this.isMultiTouch 			= 0;
		_this.moveTimeStart			= 0;
		_this.moveDiffX             = 0;
		_this.moveDiffY				= 0;
        
		_this.touchMoveEventHist	= 0;
		
		_this.touchStartEvent		= false;
		_this.touchMoveEvent		= false;
		_this.touchEndEvent			= false;
		_this.multiTouchEvent		= false;
		
		_this.currDateTouchStart	= 0;
		_this.currDateTouchEnd		= 0;
		
		_this.multiTouchEventOriginalXY	= false;
		return void(0);
	}
	
	_this.myConstruct();
	
	_this.unbindAll = function()
	{
		_this.myConstruct();
	}	
	
	_this.eventsDefault = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchStart, _this.listenerTouchStart , false);
		_this.elem[0].addEventListener( _this.handler.TouchStart, _this.listenerTouchStart , false);
	}
	
	_this.listenerTouchStart = function(event)
	{
		//TODO date global
		_this.currDateTouchStart = new Date();
		_this.currDateTouchStart = _this.currDateTouchStart.getTime();
		_this.currDateTouchEnd = 0;
		_this.touchEndEvent		= false;
		_this.touchMoveEvent	= false;
		
		if( _this.touchable )
        {
			_this.touchStartEvent = event.targetTouches;
			
			//MULTI
			if ( event.targetTouches.length > 2 )
			{
				_this.multiTouchEvent = false;
				_this.removeEventsMultiTouchMoveStart();
				_this.goMultiDrop();
			}else if ( event.targetTouches.length > 1 )
			{
				_this.multiTouchEvent	= event.targetTouches;
				
				if( _this.multiTouchEventOriginalXY )
				{
					_this.multiTouchEventOriginalXY = _this.multiTouchEvent;
				}
				
				_this.eventsMultiTouchMoveStart();
				if(typeof(setForZoom) != "undefined")
				{
					//setForZoom();
				}
			}
			else
			{
				_this.multiTouchEvent		= false;
				_this.removeEventsMultiTouchMoveStart();
				
				_this.doubleTapStart( _this.currDateTouchStart );
				_this.eventsTouchMoveStart();
				_this.eventsTouchEnd();
			}			
        }
		else
		{
			_this.touchStartEvent		= event;			
			
			_this.multiTouchEvent		= false;
			_this.removeEventsMultiTouchMoveStart();
			
			_this.doubleTapStart( _this.currDateTouchStart );
			_this.eventsTouchMoveStart();
			_this.eventsTouchEnd();
		}
		UTILS.preventDefault(event);
		_this.busyActionByEvent();
	}
	
	_this.eventsTouchEnd = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchEnd, _this.listenerTouchEnd , false);
		_this.elem[0].addEventListener( _this.handler.TouchEnd, _this.listenerTouchEnd , false);
	}
	
	_this.listenerTouchEnd = function(event)
	{
		_this.currDateTouchEnd = new Date();
		_this.currDateTouchEnd = _this.currDateTouchEnd.getTime();
		
		if( _this.touchable )
        {
			_this.touchEndEvent = event.targetTouches;
			_this.doubleTapEnd(_this.currDateTouchStart);
        }
		else
        {
        	_this.touchEndEvent = event;
    		_this.doubleTapEnd(_this.currDateTouchStart);
        }		
		_this.busyActionByEvent();
	}

	
	_this.eventsTouchMoveStart = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchMove, _this.listenerTouchMove , false);
		_this.elem[0].addEventListener( _this.handler.TouchMove, _this.listenerTouchMove , false);
	}
	
	_this.listenerTouchMove = function(event)
	{
	_this.originaleMoveEvent = event;
		if( _this.touchable )
        {
			_this.touchMoveEvent = event.targetTouches;
        }
		else
        {
			_this.touchMoveEvent = event;
        }
		_this.busyActionByEvent();
	}
	
	_this.doubleTapEnd = function( t )
	{
		if(  (t > 0) && ((t - _this.doubleTapTimeEnd) <= _this.goDoubleTouchTime) && _this.isDoubleTapTimeStart )
		{
			_this.isDoubleTapTimeEnd	= true;
			_this.isDoubleTapTimeStart	= false;
			_this.doubleTapTimeStart	= 0;
			_this.doubleTapTimeEnd		= 0;
		}
		else
		{
			_this.doubleTapTimeEnd		= t;
			_this.isDoubleTapTimeStart	= false;
			_this.isDoubleTapTimeEnd	= false;
		}
	}
	
	_this.doubleTapStart = function( t )
	{
		if(  (t > 0) && ((t - _this.doubleTapTimeStart) <= _this.goDoubleTouchTime) )
		{
			_this.isDoubleTapTimeStart	= true;
		}
		else
		{
			_this.doubleTapTimeStart	= t;
			_this.isDoubleTapTimeStart	= false;
		}
	}
	
	_this.removeEventsMultiTouchMoveStart = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchMove, _this.listenerMultiTouchMove , false);
	}
	
	_this.eventsMultiTouchMoveStart = function()
	{
		_this.elem[0].removeEventListener( _this.handler.TouchMove, _this.listenerMultiTouchMove , false);
		_this.elem[0].addEventListener( _this.handler.TouchMove, _this.listenerMultiTouchMove , false);
	}
	
	
	_this.listenerMultiTouchMove = function( event )
	{
		_this.multiTouchEvent = event.targetTouches;
	}
	
	_this.busyActionByEvent = function()
	{
		if( _this.isDoubleTapTimeEnd && _this.touchMoveEvent == false )
		{
			//DOUBLE_TAP
			// console.log("DOUBLE_TAP");
			var currEvt = _this.touchStartEvent;
			if( _this.touchable )
			{
				currEvt = _this.touchStartEvent[0]
			}else
			{
				currEvt = _this.touchStartEvent;
			}
			_this.parent.controlManager.scaleGo(false,false,currEvt,1);
			_this.isDoubleTapTimeEnd	= false;
			_this.isDoubleTapTimeStart	= false;
			_this.doubleTapTimeStart	= 0;
			_this.doubleTapTimeEnd		= 0;
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent == false && _this.touchMoveEvent == false && _this.multiTouchEvent == false )
		{
			// console.log("Touch START");
			//Touch START
			
			if(_this.timTCHEND)
			{
				clearTimeout(_this.timTCHEND);
				_this.timTCHEND = false;
			}
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent != false && _this.touchMoveEvent == false )
		{
			// console.log("Touch END");
			//Touch END
			
			/*Kev*/
			var didTouchLink;	
			if( _this.touchable ) {
				didTouchLink = _GLOBALS.main.linksManager.isTouchPointALink(_this.touchStartEvent[0].pageX, _this.touchStartEvent[0].pageY);	
			} else {
				didTouchLink = _GLOBALS.main.linksManager.isTouchPointALink(_this.touchStartEvent.pageX,_this.touchStartEvent.pageY);	
			}
			
			if (didTouchLink) {
				_this.timTCHEND = true;
				_this.unbindAll();
			} 				
			/*****/
			
			if(_this.timTCHEND)
			{
				clearTimeout(_this.timTCHEND);
				_this.timTCHEND = false;
			}else
			{			
				_this.timTCHEND = setTimeout(function()
				{
					_this.goTouchEnd();
					clearTimeout(_this.timTCHEND);
					_this.timTCHEND = false;
				},_this.goDoubleTouchTime)
			}
			
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent == false && _this.touchMoveEvent != false  && _this.multiTouchEvent == false )
		{
			//console.log("DRAG");
			//DRAG
			_this.isDoubleTapTimeEnd	= false;
			_this.isDoubleTapTimeStart	= false;
			_this.doubleTapTimeStart	= 0;
			_this.doubleTapTimeEnd		= 0;
			_this.goTouchDrag();
		}
		else if( _this.touchStartEvent != false && _this.touchEndEvent != false && _this.touchMoveEvent != false  && _this.multiTouchEvent == false )
		{
			//console.log("DROP");
			//DROP
			_this.goTouchDrop();
		}
		else if(  _this.multiTouchEvent != false && _this.touchEndEvent == false && _this.touchMoveEvent != false)
		{
			// console.log("MUTLITOUCHBEGIN");
			
			// console.log(_this.multiTouchEvent[0].pageX);
			// console.log(_this.multiTouchEvent[1].pageX);
			_this.goMultiDrag(_this.multiTouchEvent[0],_this.multiTouchEvent[1]);
		}
		else if(  _this.multiTouchEvent != false &&  _this.touchStartEvent != false && _this.touchEndEvent != false && _this.touchMoveEvent != false )
		{
			// console.log("MUTLITUCHEND");
			_this.removeEventsMultiTouchMoveStart();
			_this.multiTouchEventOriginalXY = false;
			_this.multiTouchEvent			= false;
			_this.touchEndEvent				= false;
			_this.goMultiDrop();
		}
	}
	
	
	_this.goSwipRight = function()
	{
		_this.parent.controlManager.prevPage();
	}
	
	
	_this.goSwipLeft = function()
	{
		_this.parent.controlManager.nextPage();
	}
	
	_this.goNoSwip = function()
	{
		_this.parent.controlManager.initialPage();
	}
	
	_this.goTouchEnd = function()
	{
		_this.parent.controlManager.showTools();
		_this.unbindAll();
	}
	
	
	_this.goTouchDrag = function()
	{
		var eventTouch = _this.touchMoveEvent;
		if( _this.touchable )
		{
			eventTouch = _this.touchMoveEvent[0];
		}
		
		if(!_this.touchMoveEventHist)
		{
			_this.moveTimeStart		= _this.currDateTouchStart;
			_this.mouseStart_x	= eventTouch.pageX;
            _this.mouseStart_y	= eventTouch.pageY;
			_this.touchMoveEventHist++;
			return void(0);
		}
		
		_this.currentMouse_x	= eventTouch.pageX;
		_this.currentMouse_y	= eventTouch.pageY;
        
		_this.moveDiffX = _this.currentMouse_x - _this.mouseStart_x;
        _this.moveDiffY = _this.currentMouse_y - _this.mouseStart_y;
        
        if( !_this.timeLastToAnimat )
		{
			_this.timeLastToAnimat	= new Date();
			_this.timeLastToAnimat	= _this.timeLastToAnimat.getTime();
		}
		
		_this.parent.controlManager.onDragElem( _this.moveDiffX , _this.moveDiffY , eventTouch );
		return void(0);
	}
		
	_this.goTouchDrop = function()
	{
		var swipConfXPourcCurrent = Math.floor((_this.swipConfX/100)*_GLOBALS.CONF.getDocument.width);
		
		_this.parent.controlManager.onDropElem( _this.moveDiffX );
		
		if( Math.abs(_this.moveDiffX) >= swipConfXPourcCurrent && ( _this.currDateTouchEnd-_this.currDateTouchStart ) <= _this.swipConfTime )
		{
			//console.log("Swip");
			if( _this.moveDiffX >= 0 )
			{
				//RIGHT
				_this.goSwipRight();
			}
			else
			{
				//LEFT
				_this.goSwipLeft();				
			}
		}
		else
		{
			var moveConfXPourcCurrent = Math.floor((_this.moveConfX/100)*_GLOBALS.CONF.getDocument.width);
			if( Math.abs(_this.moveDiffX) >= (moveConfXPourcCurrent) )
			{
				//console.log("Swip");
				if( _this.moveDiffX >= 0 )
				{
					//RIGHT
					_this.goSwipRight();
				}
				else
				{
					//LEFT
					_this.goSwipLeft();
				}				
	        }else
	        {
	        	//LEFT
				_this.goNoSwip();
	        }
		}
		UTILS.preventDefault(_this.originaleMoveEvent);
		_this.unbindAll();
	}
	
    _this.goMultiDrag = function(finger0,finger1)
	{
		if(_this.touchStartEvent && _this.touchStartEvent.length>2)
		{
			_this.goMultiDrop();
			return void(0);
		}
		_this.parent.controlManager.scaleGo(finger0,finger1);
	}
	
	_this.goMultiDrop = function()
	{
		_this.parent.controlManager.scaleEnd();
	}
    _this.eventsDefault();
}
_GLOBALS.callbackLoadedTmp("EventManagerFlip");var fonctionaliteMenuManager = function( parent , objName , dynamiqueDesabler , callBack )
{
	var _this				= this;
	_this.objName			= objName;
	_this.parent			= parent;
	_this.dynamiqueDesabler	= dynamiqueDesabler;
	_this.icoHoverIn		= "rgba(0,0,0,0.3)";
	_this.icoHoverOut		= "transparent";
	_this._construct = function()
	{
		for( var J in _this.dynamiqueDesabler )
		{
			if( _this.fonctionaliteList[J] )
			{
				_this.fonctionaliteList[J].active = _this.dynamiqueDesabler[J];
			}
		}
	}
	
	_this.hardAddFonctionalityList = 
	{
		retourContenaire:
		{
			xmlAdd				: '<bouton type="retourContenaire" classe="retourContenaire"/>',
			elementPos			: _this.parent.baliseName.gauche,
			elementPosNumber	: 0,//positionnement interne gauche
			value				: "retourContenaire",
			active				:true
		}
	}
	
	_this.fonctionaliteList =
	{
		// exemple [logo=value of type] : [logo=variable name] pas l'inverse
		logo:
		{
			value : "logo",
			active:true,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append("<img height='48px' src='"+_GLOBALS.CONF.logo+"' />");
			}
		},
		
		vignette:
		{
			value : "vignette",
			active:true,
			func: function(param)
			{
				//console.log(param);
				_GLOBALS.main.vignetteManager	= new VignetteManager( _GLOBALS.main , "vignetteManager" );				
				_GLOBALS.main.popupSlideList.vignetteManager				= new popupSlide( _GLOBALS.main , "vignetteManager" , false , _GLOBALS.main.vignetteManager.onClose );
				_GLOBALS.main.popupSlideList.vignetteManager.idPopUpUid		= "vignetteManager";
				_GLOBALS.main.popupSlideList.vignetteManager.enableClose	= true;
				_GLOBALS.main.popupSlideList.vignetteManager.enableReduct	= false;
				_GLOBALS.main.popupSlideList.vignetteManager.buildPopup();
				
			
				_GLOBALS.main.popupSlideList.vignetteManager.open("<div class='vignetteParent' onscroll='_GLOBALS.main.vignetteManager.checkScroll(this)'></div>");
				var elemToAdd = "."+_GLOBALS.main.popupSlideList.vignetteManager.popupClass+"_"+_GLOBALS.main.popupSlideList.vignetteManager.idPopUpUid+" .tdBot .popupSlide_content .vignetteParent";
				_GLOBALS.main.vignetteManager.initVignette( elemToAdd );
			},
			actionOnload : function(param)
			{
				UTILS.getMaskOfPng( _GLOBALS.CONF.iconesPath+_this.fonctionaliteList.vignette.value+".png" , param , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
			}
		},
		
		recherche:
		{
			value : "recherche",
			active:true,
			func: function(param)
			{
				_GLOBALS.main.popupSlideList.recherche				= new popupSlide( _GLOBALS.main , "recherche" );
				_GLOBALS.main.popupSlideList.recherche.idPopUpUid	= "recherche";
				_GLOBALS.main.popupSlideList.recherche.enableClose	= false;
				_GLOBALS.main.popupSlideList.recherche.enableReduct	= true;
				_GLOBALS.main.popupSlideList.recherche.buildPopup();
				
				
				if( _GLOBALS.main.instanceOfrechercheTextXml )
				{
					_GLOBALS.main.popupSlideList.recherche.open(_GLOBALS.main.instanceOfrechercheTextXml);
				}
			},
			actionOnload : function(param)
			{
				UTILS.getMaskOfPng( _GLOBALS.CONF.iconesPath+_this.fonctionaliteList.recherche.value+".png" , param , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
				_GLOBALS.main.rechercheTextXml		= new RechercheTextXml( _GLOBALS.main , "rechercheTextXml" , _GLOBALS.main.xmlLinksList.getXml.texte );
				_this.instanceOfrechercheTextXml	= false;
				_GLOBALS.main.instanceOfrechercheTextXml = _GLOBALS.main.rechercheTextXml.initRecherche();
			}
		},
		
		mail:
		{
			value : "mail",
			active:true,
			func: function(param)
			{
				// _GLOBALS.main.popupSlideList.mailManager				= new popupSlide( _GLOBALS.main , "mailManager" );
				// _GLOBALS.main.popupSlideList.mailManager.idPopUpUid		= "mailManager";
				// _GLOBALS.main.popupSlideList.mailManager.enableClose	= false;
				// _GLOBALS.main.popupSlideList.mailManager.enableReduct	= true;
				// _GLOBALS.main.popupSlideList.mailManager.buildPopup();
				
				// if( _GLOBALS.main.instanceOfMailManager )
				// {
					// _GLOBALS.main.popupSlideList.mailManager.open(_GLOBALS.main.instanceOfMailManager);
				// }
				
				var titleDom = $("title").text();
				var mailToM = "mailto:?";
				var subjectM = "subject=Je vous invite  feuilleter la publication " + titleDom;
				var bodyM = "&body=Bonjour\n Je vous invite  feuilleter la publication suivante : " + titleDom + ". \r\n Consultable  l'adresse : " + location.href;
				
				var chaine_mail = mailToM+""+subjectM+""+bodyM;
				location.href = chaine_mail;
			},
			actionOnload : function(param)
			{
				var _convertHexToRGB = new convertHexToRGB(_GLOBALS.CONF.iconesDefaultParam.teinte);
				UTILS.getMaskOfPng( _GLOBALS.CONF.iconesPath+_this.fonctionaliteList.mail.value+".png" , param , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
				// MailManager
				// _GLOBALS.main.mailManager		= new MailManager( _GLOBALS.main , "mailManager" , _GLOBALS.main.xmlLinksList.getXml.tools );
				// _GLOBALS.main.instanceOfMailManager = _GLOBALS.main.xmlLinksList.getXml.tools.children("menuBasic").find("templateHtmlMail").children();
				// console.log(_GLOBALS.main.instanceOfMailManager);				
			}
		},
		
		sommaire:
		{
			value : "sommaire",
			active:true,
			func: function(param)
			{
				_GLOBALS.main.popupSlideList.sommaireManager				= new popupSlide( _GLOBALS.main , "sommaireManager" );
				_GLOBALS.main.popupSlideList.sommaireManager.idPopUpUid		= "sommaireManager";
				_GLOBALS.main.popupSlideList.sommaireManager.enableClose	= false;
				_GLOBALS.main.popupSlideList.sommaireManager.enableReduct	= true;
				_GLOBALS.main.popupSlideList.sommaireManager.buildPopup();
				
				if( _GLOBALS.main.instanceOfSommaireManager )
				{
					_GLOBALS.main.popupSlideList.sommaireManager.open(_GLOBALS.main.instanceOfSommaireManager);
				}
			},
			actionOnload : function(param)
			{
				var _convertHexToRGB = new convertHexToRGB(_GLOBALS.CONF.iconesDefaultParam.teinte);
				UTILS.getMaskOfPng( _GLOBALS.CONF.iconesPath+_this.fonctionaliteList.sommaire.value+".png" , param , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
				_GLOBALS.main.sommaireTextXml		= new SommaireManager( _GLOBALS.main , "sommaireTextXml" , _GLOBALS.main.xmlLinksList.getXml.menu2 );
				_GLOBALS.main.instanceOfSommaireManager = _GLOBALS.main.sommaireTextXml.getSommaire();
			}
		},
	
		zoom:
		{
			value : "zoom",
			active:true,
			func: function(param)
			{
				var touchStartEvent = {};
				touchStartEvent.pageX = _GLOBALS.CONF.getDocument.width/2;
				touchStartEvent.pageY = _GLOBALS.CONF.getDocument.height/2;
				_GLOBALS.main.controlManager.scaleGo(false,false,touchStartEvent,1);
			},
			actionOnload : function(param)
			{
				var _convertHexToRGB = new convertHexToRGB(_GLOBALS.CONF.iconesDefaultParam.teinte);
				UTILS.getMaskOfPng( _GLOBALS.CONF.iconesPath+_this.fonctionaliteList.zoom.value+".png" , param , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
				_GLOBALS.main.controlManager.onScaleGo(function()
				{
					$(param).css("background-color",_this.icoHoverIn);
				},function()
				{
					$(param).css("background-color",_this.icoHoverOut);
				});
				
				UTILS.onResizeCustom(function()
				{
					$(param).css("background-color",_this.icoHoverOut);
				});
			}
		},
		
		postit:
		{
			value : "postit",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		marquepage:
		{
			value : "marquepage",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
	
		vignetteshd:
		{
			value : "vignetteshd",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		
		paint:
		{
			value : "paint",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		
		autoflip:
		{
			value : "autoflip",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		pages:
		{
			value : "pages",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		fullScreen:
		{
			value : "fullScreen",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		imprimer:
		{
			value : "imprimer",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		pdf:
		{
			value : "pdf",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		aide:
		{
			value : "aide",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		fermer:
		{
			value : "fermer",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				// var _convertHexToRGB = new convertHexToRGB(_GLOBALS.CONF.iconesDefaultParam.teinte);
				// UTILS.getMaskOfPng( _GLOBALS.CONF.iconesPath+_this.fonctionaliteList.fermer.value+".png" , param , _GLOBALS.CONF.iconesDefaultParam.teinteRGB );
			}
		},
		
		Home:
		{
			value : "Home",
			active:false,
			func: function(param)
			{
				//console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
				//console.log(param);
			}
		},
		
		retourContenaire:
		{
			value : "retourContenaire",
			active:false,
			func: function(param)
			{
				// console.log(param);
			},
			actionOnload : function(param)
			{
				param.append(param.attr("currclass"));
			}
		}		
	}
	
	_this._construct();
	return this;
}
_GLOBALS.callbackLoadedTmp("fonctionaliteMenuManager");
(function(a){function d(a){var c=["Moz","Webkit","O","ms"];var d=a.charAt(0).toUpperCase()+a.substr(1);if(a in b.style){return a}for(var e=0;e<c.length;++e){var f=c[e]+d;if(f in b.style){return f}}}function e(){b.style[c.transform]="";b.style[c.transform]="rotateY(90deg)";return b.style[c.transform]!==""}function i(a){if(typeof a==="string"){this.parse(a)}return this}function j(a,b,c){if(b===true){a.queue(c)}else if(b){a.queue(b,c)}else{c()}}function k(b){var c=[];for(var d in b){if(b.hasOwnProperty(d)){d=a.camelCase(d);d=a.transit.propertyMap[d]||d;d=n(d)}if(a.inArray(d,c)===-1){c.push(d)}}return c}function l(b,c,d,e){var f=k(b);if(a.cssEase[d]){d=a.cssEase[d]}var g=""+p(c)+" "+d;if(parseInt(e,10)>0){g+=" "+p(e)}var h=[];for(var i=0;i<f.length;i++){var j=f[i];h.push(j+" "+g)}return h.join(", ")}function m(b,d){if(!d){a.cssNumber[b]=true}a.transit.propertyMap[b]=c.transform;a.cssHooks[b]={get:function(c){var d=a(c).css("transit:transform")||new i;return d.get(b)},set:function(c,d){var e=a(c);var f=e.css("transit:transform")||new i;f.setFromString(b,d);e.css("transit:transform",f)}}}function n(a){return a.replace(/([A-Z])/g,function(a){return"-"+a.toLowerCase()})}function o(a,b){if(typeof a==="string"&&!a.match(/^[\-0-9\.]+$/)){return a}else{return""+a+b}}function p(b){var c=b;if(a.fx.speeds[c]){c=a.fx.speeds[c]}return o(c,"ms")}"use strict";a.transit={version:"0.1.3",propertyMap:{marginLeft:"margin",marginRight:"margin",marginBottom:"margin",marginTop:"margin",paddingLeft:"padding",paddingRight:"padding",paddingBottom:"padding",paddingTop:"padding"},enabled:true,useTransitionEnd:false};var b=document.createElement("div");var c={};var f=navigator.userAgent.toLowerCase().indexOf("chrome")>-1;c.transition=d("transition");c.transitionDelay=d("transitionDelay");c.transform=d("transform");c.transformOrigin=d("transformOrigin");c.transform3d=e();a.extend(a.support,c);var g={MozTransition:"transitionend",OTransition:"oTransitionEnd",WebkitTransition:"webkitTransitionEnd",msTransition:"MSTransitionEnd"};var h=c.transitionEnd=g[c.transition]||null;b=null;a.cssEase={_default:"ease","in":"ease-in",out:"ease-out","in-out":"ease-in-out",snap:"cubic-bezier(0,1,.5,1)"};a.cssHooks["transit:transform"]={get:function(b){return a(b).data("transform")},set:function(b,d){var e=d;if(!(e instanceof i)){e=new i(e)}if(c.transform==="WebkitTransform"&&!f){b.style[c.transform]=e.toString(true)}else{b.style[c.transform]=e.toString()}a(b).data("transform",e)}};if(a.fn.jquery<"1.8.0"){a.cssHooks.transformOrigin={get:function(a){return a.style[c.transformOrigin]},set:function(a,b){a.style[c.transformOrigin]=b}};a.cssHooks.transition={get:function(a){return a.style[c.transition]},set:function(a,b){a.style[c.transition]=b}}}m("scale");m("translate");m("rotate");m("rotateX");m("rotateY");m("rotate3d");m("perspective");m("skewX");m("skewY");m("x",true);m("y",true);i.prototype={setFromString:function(a,b){var c=typeof b==="string"?b.split(","):b.constructor===Array?b:[b];c.unshift(a);i.prototype.set.apply(this,c)},set:function(a){var b=Array.prototype.slice.apply(arguments,[1]);if(this.setter[a]){this.setter[a].apply(this,b)}else{this[a]=b.join(",")}},get:function(a){if(this.getter[a]){return this.getter[a].apply(this)}else{return this[a]||0}},setter:{rotate:function(a){this.rotate=o(a,"deg")},rotateX:function(a){this.rotateX=o(a,"deg")},rotateY:function(a){this.rotateY=o(a,"deg")},scale:function(a,b){if(b===undefined){b=a}this.scale=a+","+b},skewX:function(a){this.skewX=o(a,"deg")},skewY:function(a){this.skewY=o(a,"deg")},perspective:function(a){this.perspective=o(a,"px")},x:function(a){this.set("translate",a,null)},y:function(a){this.set("translate",null,a)},translate:function(a,b){if(this._translateX===undefined){this._translateX=0}if(this._translateY===undefined){this._translateY=0}if(a!==null){this._translateX=o(a,"px")}if(b!==null){this._translateY=o(b,"px")}this.translate=this._translateX+","+this._translateY}},getter:{x:function(){return this._translateX||0},y:function(){return this._translateY||0},scale:function(){var a=(this.scale||"1,1").split(",");if(a[0]){a[0]=parseFloat(a[0])}if(a[1]){a[1]=parseFloat(a[1])}return a[0]===a[1]?a[0]:a},rotate3d:function(){var a=(this.rotate3d||"0,0,0,0deg").split(",");for(var b=0;b<=3;++b){if(a[b]){a[b]=parseFloat(a[b])}}if(a[3]){a[3]=o(a[3],"deg")}return a}},parse:function(a){var b=this;a.replace(/([a-zA-Z0-9]+)\((.*?)\)/g,function(a,c,d){b.setFromString(c,d)})},toString:function(a){var b=[];for(var d in this){if(this.hasOwnProperty(d)){if(!c.transform3d&&(d==="rotateX"||d==="rotateY"||d==="perspective"||d==="transformOrigin")){continue}if(d[0]!=="_"){if(a&&d==="scale"){b.push(d+"3d("+this[d]+",1)")}else if(a&&d==="translate"){b.push(d+"3d("+this[d]+",0)")}else{b.push(d+"("+this[d]+")")}}}}return b.join(" ")}};a.fn.transition=a.fn.transit=function(b,d,e,f){var g=this;var i=0;var k=true;if(typeof d==="function"){f=d;d=undefined}if(typeof e==="function"){f=e;e=undefined}if(typeof b.easing!=="undefined"){e=b.easing;delete b.easing}if(typeof b.duration!=="undefined"){d=b.duration;delete b.duration}if(typeof b.complete!=="undefined"){f=b.complete;delete b.complete}if(typeof b.queue!=="undefined"){k=b.queue;delete b.queue}if(typeof b.delay!=="undefined"){i=b.delay;delete b.delay}if(typeof d==="undefined"){d=a.fx.speeds._default}if(typeof e==="undefined"){e=a.cssEase._default}d=p(d);var m=l(b,d,e,i);var n=a.transit.enabled&&c.transition;var o=n?parseInt(d,10)+parseInt(i,10):0;if(o===0){var q=function(a){g.css(b);if(f){f.apply(g)}if(a){a()}};j(g,k,q);return g}var r={};var s=function(d){var e=false;var i=function(){if(e){g.unbind(h,i)}if(o>0){for(var a=0;a<g.length;a++){var b=g[a];b.style[c.transition]=r[b]||null}}if(typeof f==="function"){f.apply(g)}if(typeof d==="function"){d()}};if(o>0&&h&&a.transit.useTransitionEnd){e=true;g.bind(h,i)}else{window.setTimeout(i,o)}for(var j=0;j<g.length;j++){var k=g[j];if(o>0){k.style[c.transition]=m}a(k).css(b)}};var t=function(a){var b=0;if(c.transition==="MozTransition"&&b<25){b=25}window.setTimeout(function(){s(a)},b)};j(g,k,t);return this};a.transit.getTransitionValue=l})(jQuery);
_GLOBALS.callbackLoadedTmp("jqueryTransit");/*Kev*/

_GLOBALS.LinkTypeZoomPartiel = "zoomPartiel";
_GLOBALS.LinkTypeVideoFiche = "video fiche";
_GLOBALS.LinkTypeVideoIncruster = "video incuster";
_GLOBALS.LinkTypeWeb = "web";
_GLOBALS.LinkTypeGalerie = "galerie";
_GLOBALS.LinkTypeFiche = "fiche";
_GLOBALS.LinkTypeImageFiche = "image fiche";
_GLOBALS.LinkTypeImageIncruster = "image incruster";
_GLOBALS.LinkTypeAudio = "audio";
_GLOBALS.LinkTypeGotoPage = "gotopage";
_GLOBALS.LinkTypePhone = "phone";
_GLOBALS.LinkTypeMail = "mail";
_GLOBALS.LinkTypeNone = "none";

_GLOBALS.VideoExtSupported = ["m4v","ogv","webm"];
_GLOBALS.VideoTypeSupported = ["video/mp4","video/ogg","video/webm"];
		
		
var LinkObj = function( linkAttr ) {
	var _this = this;
	_this.xOrig = 0;
	_this.xScreen = 0;
	_this.x = 0;
	_this.yOrig = 0;
	_this.yScreen = 0;
	_this.y = 0;
	_this.wOrig = 0;
	_this.w = 0;
	_this.hOrig = 0;
	_this.h = 0;
	_this.url = "";
	_this.urlvideo = new Array();
	_this.target = "";
	_this.color = "";
	_this.pagenum = "";
	_this.type;
	
	 _this._construct = function()
	{
        _this.xOrig = parseInt($(linkAttr).attr('x'));
		_this.yOrig = parseInt($(linkAttr).attr('y'));
        _this.wOrig = parseInt($(linkAttr).attr('w'));
		_this.hOrig = parseInt($(linkAttr).attr('h'));
		_this.pagenum = $(linkAttr).attr('pagenum');
		
        if ($(linkAttr).attr('url') != undefined)
        	_this.url = $(linkAttr).attr('url');
        else if ($(linkAttr).attr('page') != undefined)
        	_this.url = "page:" + $(linkAttr).attr('page');
        
        if ($(linkAttr).attr('target') != undefined)
        	_this.target = $(linkAttr).attr('target');
		_this.color = "0,0,255,0.1";
	}
	
	_this.resizeLink = function(currScale, decalageX, decalageY) {
		
		_this.x = UTILS.arrondi(_this.xOrig*currScale);
        _this.y = UTILS.arrondi(_this.yOrig*currScale);
        _this.xScreen = _this.x + decalageX;
        _this.yScreen = _this.y + decalageY;
        _this.w = UTILS.arrondi(_this.wOrig*currScale);
        _this.h = UTILS.arrondi(_this.hOrig*currScale);
	}
	
	
	_this._construct();
}



var LinkTypeManager = function() {
	var _this = this;
	
	_this.getLinkType = function( lien ) {
		if (lien.url.length == 0) {
			return _GLOBALS.LinkTypeNone;
		}
		
		if (lien.target == "swf_fiche" || lien.target == "swf_video") {
			var extension = UTILS.getFileExtension(lien.url);
			if (extension == "jpg" || extension == "png") {
				return (lien.target == "swf_fiche") ? _GLOBALS.LinkTypeImageFiche : _GLOBALS.LinkTypeImageIncruster;
			}
			if (extension == "flv") {
				for (var i = 0; i < _GLOBALS.VideoExtSupported.length; i++) {
					lien.urlvideo[i] = UTILS.getFilenameWithoutExtension(lien.url) + "." + _GLOBALS.VideoExtSupported[i];
    			} 							
				return (lien.target == "swf_fiche") ? _GLOBALS.LinkTypeVideoFiche : _GLOBALS.LinkTypeNone;
			}
			console.log('alerte 1 ! '); 
		}
		
		if (lien.target == "_blank") {
			if (/[http:]/.exec(lien.url)) {
				return _GLOBALS.LinkTypeWeb;
			}
			console.log('alerte 2 ! ');
		}
		
		if (lien.target == "_self") {
			if (/[mailto:]/.exec(lien.url)) {
				return _GLOBALS.LinkTypeMail;
			}
			console.log('alerte 3 ! ');
		}
		
		if (lien.target.length == 0) {
			if (/[page:]/.exec(lien.url)) {
				return _GLOBALS.LinkTypeGotoPage;
			}
		}
		
		console.log('lien non reconnu ! ');
		console.log(lien);
		return _GLOBALS.LinkTypeNone;	
	}
}


var LinksManager = function( links ) {
    
    var _this = this;
    _this.links;
    _this.pageWidth;
    _this.pageHeight;
    _this.redrawLinksTimer = null;
    _this.videoTimer = null;
    _this.linkTypeManager = new LinkTypeManager();
    _this.videoIncruster = new Array();
    
    _this._construct = function()
	{
		var nbPages = _GLOBALS.CONF.pages.length;
        _this.links = new Array();
        
        for (var pagenum = 1; pagenum <= nbPages; pagenum++) {
        	var linksForPage = $(links).find('page[num='+pagenum+']').find('lien');
        	$(linksForPage).attr("pagenum",pagenum);
             
            _this.links[pagenum] = new Array(); 
        	for (var i = 0; i < linksForPage.length; i++) {
           		var lien = new LinkObj(linksForPage[i]);           		
           		lien.type = _this.linkTypeManager.getLinkType(lien);
           		
           		if (lien.type != _GLOBALS.LinkTypeNone && !_this.isDoublonLinks(_this.links[pagenum], lien)) {
           			_this.links[pagenum].push(lien);
           		}
        	}
        }
        
        _this.pageWidth  = _GLOBALS.CONF.pagesOnInit.width;
        _this.pageHeight = _GLOBALS.CONF.pagesOnInit.height;
        
	}
    
    _this.isDoublonLinks = function( liensArr , lienToCheck) {
    	for (var i = 0; i < liensArr.length; i++) {
    		var lien = liensArr[i];
    		var tolerence = 5;
    		var xDif = Math.abs(lien.xOrig-lienToCheck.xOrig);
    		var yDif = Math.abs(lien.yOrig-lienToCheck.yOrig);
    		var wDif = Math.abs(lien.wOrig-lienToCheck.wOrig);
    		var hDif = Math.abs(lien.hOrig-lienToCheck.hOrig);
    		if (xDif < tolerence && yDif < tolerence && wDif < tolerence && hDif < tolerence) {
    			if (lien.url != lienToCheck.url) {
    				console.log('Doublon found mais pas la meme url !');
    				console.log(lien);
    				console.log(lienToCheck);
    			}
    			return true;
    		}
    	}
    	return false;
    }
        
    _this.getLinksForPage = function( pagenum, currScale, decalageX, decalageY)
    
	{ 
		var linksForPage = _this.links[pagenum];
		//console.log(linksForPage);
		for (var i = 0; i < linksForPage.length; i++) {
           		var lien = linksForPage[i];
				lien.resizeLink(currScale, decalageX, decalageY);         	
        }
        return linksForPage;
    }
    
    _this.isTouchPointALink = function( offsetX, offsetY ) {  	
    	var linksFounded = new Array();
    	
    	var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
    	var infoPage = UTILS.byPageIfDouble(pagenum);			
		var pageToShow = 1;
		if( infoPage["isDouble"] )
			pageToShow = 2;
			
		
			
    	for (var j = 0; j < pageToShow; j++) {
    		var pagen = pagenum+j;
    		for (var i = 0; i < _this.links[pagen].length; i++) {
    			var lien = _this.links[pagen][i];
    			if ((offsetX >= lien.xScreen && offsetX <= lien.xScreen + lien.w) && (offsetY >= lien.yScreen && offsetY <= lien.yScreen + lien.h)) {
    				//console.log("trouved !!!!!!");
    				if (lien.type == _GLOBALS.LinkTypeImageIncruster)
    					return false;
    				linksFounded.push(lien);
    			}
    		}
    	}
    	if (linksFounded.length > 0) {
    		//console.log(linksFounded);
    		var bestMatch = linksFounded[0];
    		for (var i = 1; i < linksFounded.length; i++) {
    			var lien = linksFounded[i];
    			if (bestMatch.w * bestMatch.h > lien.w * lien.h) {
    				bestMatch = lien;
    			}
    		}
    		console.log("Lien cliqued :");
    		console.log(bestMatch);
    			
    		_this.loadLink(bestMatch);
    		return true;
    	}
    	return false;	
    } 
    
    _this.getVideoTag = function(lien, isPopup) {
    		var path = (isPopup) ? _GLOBALS.CONF.pages.videoFichePath : _GLOBALS.CONF.pages.videoIncrustePath;
    		var size = (isPopup) ? 80 : 100;
    		var style = (isPopup) ? 'popup' : 'incruster';
    		var controls = (isPopup) ? 'controls="controls"' : 'controls="controls"';
    		var id = (isPopup) ? 'v2' : 'v';
    		
			var video = '<div class="videoParent '+ style +'">';
    		video += '<video id="'+id+'" class="video" width="'+size+'%" height="'+size+'%" autobuffer="true" '+controls+'>';
    		for (var i = 0; i < _GLOBALS.VideoTypeSupported.length; i++) {
    			video += '<source src="' + path + lien.urlvideo[i] + '" type="' + _GLOBALS.VideoTypeSupported[i] + '">';
    		}
    		video += 'Your browser does not support the video tag.</video>';
    		if (isPopup) {
    			var closeSize = ($(window).height() <= 480) ? 36 : 48;
    			video += '<div class="close" ';
    			video += 'style="width:'+closeSize+'px; height:'+closeSize+'px;">';
    			video += '<img src="'+_GLOBALS.CONF.iconesPath+'x_2.png" style="height:100%; margin-left:-50%; margin-top:-50%;">';
    			video += '</div>';
    		}
    		video += '</div>';
    		return video;
    }
        
    _this.loadLink = function(lien) {
    	_this.closeVideo();
    	
    	if (lien.type == _GLOBALS.LinkTypeWeb || lien.type == _GLOBALS.LinkTypeMail)
    		window.open(lien.url,lien.target,"",false);

		if (lien.type == _GLOBALS.LinkTypeImageFiche) {	
			_this.drawImageOnBody(lien);
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeVideoFiche) {

			$('body').append(_this.getVideoTag(lien,true));

			$('.videoParent').css('opacity','0');
			$('.videoParent').transition({opacity:1},1000);
			$('.blockCont').css('-webkit-filter','blur(5px)');
			$('.close').click(function() {                                     
				_this.closeVideo();
			});
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeGotoPage) {
    		var gotoPage = lien.url.split(':').pop();
    		_GLOBALS.main.controlManager.goToPage(gotoPage);
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeVideoIncruster) {
    		/*var video = $('video')[0];
    		console.log(video);
			if(video.paused) {				
				video.play();
			} else {
				video.pause();
			}*/
    	}
    	
    	if (lien.type == _GLOBALS.LinkTypeImageIncruster) {

    	}
    }
    
    _this.closeImage = function( )
	{
		$('.imageParent').transition({opacity:0},500,function(){$('.imageParent').remove();});
		$('.blockCont').css('-webkit-filter',''); 
	}
	
    _this.closeVideo = function( )
	{
		$('.videoParent.popup').transition({opacity:0},500,function(){$('.videoParent.popup').detach();});
		$('.blockCont').css('-webkit-filter',''); 
	}
	
	_this.showVideo = function( )
	{
		clearTimeout(_this.videoTimer);
		_this.videoTimer = setTimeout(function() {
				var v = $("#v");
				if (!v.length) {
					var pagenum = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;

					if (_this.videoIncruster[pagenum])
						$(_this.videoIncruster[pagenum]).appendTo($('body'));
						
				}
		},500);
	}
	
	_this.hideVideo = function( )
	{
		var v = $("#v");
		if (v.length) {
			for (var l = 0; l < v.length; l++) {
				$("#v")[l].pause();
			}			
			$('.linkVideo').remove();
		}
	}
		

    _this.drawLinks = function(elem, pagenum, multiplicateurX) {
    	
    			//console.log('pagenum : ' + (pagenum+i));
    	var listenerFlipable = $('.listenerFlipable');
		
		var decalageX = (elem.pos.x+(multiplicateurX*elem.pos.width));
        var decalageY = elem.pos.y;
               	        
        var links =  _this.getLinksForPage(pagenum+multiplicateurX, elem.pos.currScale, decalageX, decalageY);
        
        for (var l = 0; l < links.length; l++) {
        			
        	var lienObj = links[l];
            
        	if (lienObj.type == _GLOBALS.LinkTypeVideoIncruster) {
                
                if (!_this.videoIncruster[pagenum]) {
              		var link = '<div class="linkVideo" href="';
               		link += lienObj.url;
               		link += '" style="';
               		link += 'left:' + lienObj.xScreen + 'px; ' + 'top:' + lienObj.yScreen + 'px; ' + 'width:' + lienObj.w + 'px; ' + 'height:' + lienObj.h + 'px; ';
               		link += '">'
               		link += _this.getVideoTag(lienObj,false);
               		link +='</div>';
               		$(link).appendTo($('body'));
               		
               		_this.videoIncruster[pagenum] = $('.linkVideo');
                } else {
                	$(_this.videoIncruster[pagenum]).css('left',lienObj.xScreen+'px');
                	$(_this.videoIncruster[pagenum]).css('top',lienObj.yScreen+'px');
                	$(_this.videoIncruster[pagenum]).css('width',lienObj.w+'px');
                	$(_this.videoIncruster[pagenum]).css('height',lienObj.h+'px');
                }
        	
        	} else if (lienObj.type == _GLOBALS.LinkTypeImageIncruster) {
				_this.drawImageOnContext(elem,lienObj);
  				
           	} else {
           		
  				elem.ctx.fillStyle = "rgba("+lienObj.color+")";
    			elem.ctx.fillRect(lienObj.x+decalageX,lienObj.y+decalageY,lienObj.w,lienObj.h);
           	}
        }
   	}    
   	   	
   	_this.drawImageOnContext = function(elem, lienObj) {
   		
   		if (elem.linksList[lienObj.url]) {
   			_this.onImageReady(elem,elem.linksList[lienObj.url],lienObj);
   		} else {
			var img = new Image();
			img.src = _GLOBALS.CONF.pages.imageIncrustePath + lienObj.url;
			img.onload = function(){
				_this.onImageReady(elem,img,lienObj);
				elem.linksList[lienObj.url] = img;
			}	
   		}	
   	}
   	
   	_this.onImageReady = function(elem, img, lienObj) {
		var ratioW = img.width/lienObj.w;
		var ratioH = img.height/lienObj.h;
		var newW = lienObj.w;
		var newH = lienObj.h;
		var newX = lienObj.xScreen;
		var newY = lienObj.yScreen;
		
		if (ratioH > ratioW) {
			newW = imgs.width / ratioH;
			newX += (lienObj.w - newW)/2;
		} else {
			newH = img.height / ratioW;
			newY += (lienObj.h - newH)/2;	
		}
		if (elem.ctx)
			elem.ctx.drawImage(img,(newX),(newY),(newW),(newH));
		//console.log('image Draw');	
   	}
   	
   	_this.drawImageOnBody = function(lienObj) {
   		
		$('body').append('<div class="imageParent"></div>');
		$('.imageParent').css({opacity:0});
		$('.imageParent').transition({opacity:1},1000);
		
		var img = new Image();
		img.src = _GLOBALS.CONF.pages.imageFichePath + lienObj.url;
		img.onload = function(){
			var closeSize = ($(window).height() <= 480) ? 36 : 48;
			var windowW = $(window).width()-closeSize;
			var windowH = $(window).height()-closeSize;
			var newW = this.width;
			var newH = this.height;
			var newX = ((windowW - newW)/2) + (closeSize/2);
			var newY = ((windowH - newH)/2) + (closeSize/2);
				
			if (this.width > windowW || this.height > windowH) {
				var newW = windowW;
				var newH = windowH;
				var ratioW = this.width/windowW;
				var ratioH = this.height/windowH;			

				if (ratioH > ratioW) {
					newW = this.width / ratioH;
					newX = ((windowW - newW)/2) + (closeSize/2);
					newY = (closeSize/2);
				} else {
					newH = this.height / ratioW;
					newY = ((windowH - newH)/2) + (closeSize/2);
					newX = (closeSize/2);
				}
			} 
			var div = '';
			div += '<div class="image" style="margin-left:'+(newX)+'px; margin-top:'+(newY)+'px; width:'+(newW)+'px; height:'+(newH)+'px">'
			div += '<img src="'+this.src+'" style="height: 100%;">';
			div += '</div>';
			div += '<div class="close" ';
			div += 'style="margin-left:'+(newX+newW)+'px; margin-top:'+(newY)+'px; width:'+closeSize+'px; height:'+closeSize+'px;">';
			div += '<img src="'+_GLOBALS.CONF.iconesPath+'x_2.png" style="height: 100%; margin-left:-50%; margin-top:-50%;">';
			//div += 'style="background: url('+_GLOBALS.CONF.iconesPath+'x_2.png) no-repeat; ';
			
			div += '</div>';
			
			$('.imageParent').append(div);
			$('.blockCont').css('-webkit-filter','blur(5px)');
			$('.close').click(function() {                                    
				_this.closeImage();                                     
			});
		}
   	}
   	
   	
   	/*_this.playVideo = function(elem , lienObj) {
    	var v = document.getElementById('v');

    	v.addEventListener('play', function(){
        	draw(this,elem.ctx,lienObj);
    	},false);
   	}

	function draw(v,c,lienObj) {
    	if(v.paused || v.ended) return false;
    	c.drawImage(v,lienObj.xScreen,lienObj.yScreen,lienObj.w,lienObj.h);
    	setTimeout(draw,20,v,c,lienObj);
	}*/
   	
		
		
	/* EVENTS */
		
	$(window).bind("resize",function(e)
	{
		_this.hideVideo();
		_this.closeImage();
		_this.videoIncruster = new Array();
	});
		
	_this.onDragElem = function( ) {
		_this.hideVideo();
	}

	_this.onDropElem = function( ) {
		_this.showVideo();
	}
	
	_this.goToPage = function(nb)
	{
		_this.hideVideo();
		_this.showVideo();
	}

   	
    _this._construct();
}
/*****/

_GLOBALS.callbackLoadedTmp("LinksManager");var Main = function(parent)
{
	var _this 							= this;
	_this.parent						= parent;
	_this.templateManager				= new Object();
	_this.pagesLoader					= new Object();
	_this.xmlLinksList					= new Object();
	/*Kev*/	
	_this.linksManager 					= new Object();
	/*****/
	_this.eventManagerFlip				= new Object();
	_this.currElemPos 					= new Object();
	_this.pagesListConstructor			= new Object();
	_this.carrouselManager				= new Object();
	_this.popupSlideList				= new Object();
	_this.param							= new Object();
	_this.canvasManager					= new CanvasManager(_this);
	_this.controlManager 				= new ControlManager(_this);
	_this.blockCont						= null;
	_this.timeOfResize					= 500;
	_this.timeOfResizeMobile			= 300;
	_this.touchableInfo					= isEventSupported("touchstart",$(document)[0]);	
	_this.supportsOrientationChange;
	
	_this._construct = function()
	{
		return void(0);
	}
	
	_this.init = function()
	{
		_this.templateManager			= new TemplateManager(_this);
		_this.templateManager.listTpl	= _GLOBALS.CONF.getTemplatesList();
		_this.positionForSlider			= new PositionForSlider(_this);
		_this.templateManager.getList(
		function()
		{
			_this.xmlLinksList = new XmlLoader( _this , "xmlLinksList" , _GLOBALS.CONF.xmlNeededToLoadPath , _GLOBALS.CONF.getXmlNeededToLoad() , function()
			{
				var toolsXml = new Array();
				toolsXml.push("tools");
				_this.xmlToolsLoad = new XmlLoader( _this , "xmlToolsLoad" , _GLOBALS.CONF.systemPath+"xml_system/" , toolsXml , function()
				{
					_this.xmlLinksList.getXml.tools = _this.xmlToolsLoad.getXml.tools;
					_this.xmlToolsLoad = null;
					delete _this.xmlToolsLoad;
					_this.param = new Param();
					var langueXml = new Array();
					langueXml.push(_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng);
					_this.xmlLangueLoad = new XmlLoader( _this , "xmlLangueLoad" , _GLOBALS.CONF.pathLangue , langueXml , function(info)
					{
						if(!info)
						{
							_GLOBALS.CONF.getDocument.lng = _GLOBALS.CONF.getDocument.lngDefault;
							console.log(_GLOBALS.CONF.getDocument.lng);
							var langueXml = new Array();
							langueXml.push(_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng);
							_this.xmlLangueLoad = new XmlLoader( _this , "xmlLangueLoad" , _GLOBALS.CONF.pathLangue , langueXml , function(info)
							{
								_this.xmlLinksList.getXml.langue = _this.xmlLangueLoad.getXml[_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng];
								_this.xmlLangueLoad = null;
								delete _this.xmlLangueLoad;
								_this.loadFirstPage(_this.documentReadyCustomPreloader);
								/*Kev*/	 
								_this.linksManager = new LinksManager(_GLOBALS.main.xmlLinksList.getXml.liens);
								/*****/
							})						
						}else
						{
							_this.xmlLinksList.getXml.langue = _this.xmlLangueLoad.getXml[_GLOBALS.CONF.lngKey+_GLOBALS.CONF.getDocument.lng];
							_this.xmlLangueLoad = null;
							delete _this.xmlLangueLoad;
							_this.loadFirstPage(_this.documentReadyCustomPreloader);
							/*Kev*/	 
							_this.linksManager = new LinksManager(_GLOBALS.main.xmlLinksList.getXml.liens);
							/*****/
						}
					});
				});
			});
		});
	}
	
	_this.loadFirstPage = function( callback )
	{
		_this.blockCont = $(".blockCont");
		_this.pagesLoader = new PagesLoader( _this , _this.blockCont );
		_this.pagesLoader.objName = "pagesLoader";		
		_this.pagesLoader.preloadPageFrom(function( listLoadedArray , currentLoaded , currentLoadedNumber , needLoadedNumber )
		{
			if( currentLoadedNumber == needLoadedNumber )
			{
				_this.pagesLoader.imagePreloaded = new Array();
				callback();
			}
		});
	}

	_this.eventBegin = function()
	{
		_this.eventManagerFlip = new EventManagerFlip( _this , $(".listenerFlipable") );
	}
	
	_this.documentReadyCustomPreloader = function()
	{
		_GLOBALS.javascriptInit.stopPreladerSplashScreen(_this.documentReadyCustom)
	}
	
	_this.documentReadyCustom = function()
	{
		_this.eventBegin();
		_this.positionForSlider.alignAll();
		
		_this.supportsOrientationChange = "onorientationchange" in window,orientationEvent = _this.supportsOrientationChange ? "orientationchange" : "resize";
		
		UTILS.onResizeCustom(function()
		{
			_GLOBALS.idResize++;
			_this.positionForSlider.alignAll();
			_this.carrouselManager.resized();
			_this.carrouselManager.resetAll();
			_this.controlManager.showTools("hide");
		})
		
		if(_this.supportsOrientationChange)
		{
			$(window).bind("orientationchange",function(e)
			{
				UTILS.onResizedCustom(e);
			});
		}else
		{
			$(window).bind("resize",function(e)
			{
				UTILS.onResizedCustom(e);
			});
		}
		

		if( _this.xmlLinksList.getXml.menuParam )
		{
			_this.menuParamManager = new menuParamManager( _this , "menuParamManager" , _this.xmlLinksList.getXml.menuParam , null );
		}		
		
		if( _this.menuParamManager )
		{
			_this.menuParamManager.getMenu();
		}
		
		_this.carrouselManager = new CarrouselManager( _this , "carrouselManager" )
		if( _this.carrouselManager )
		{
			_this.carrouselManager.getCarrouselManager();
		}
		
		_this.controlManager.showTools("hide");
		
		//astuceMassi Active touch pour android voir aussi index.html
		$(document)[0].removeEventListener( "touchstart", _GLOBALS.initEventTouch , false);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("Main");var menuParamManager = function( parent , objName , menuParam , dynamiqueDesabler )
{
	var _this = this;
	_this.objName;
	_this.parent;
	_this.menuParam;
	_this.tools = parent.xmlLinksList.getXml.tools;
	_this.fonctionaliteMenu;
	_this.arrayOfClassElemForEvent		= new Array();
	_this.arrayOfClassElemForEventFuncs	= new Array();
	_this.dynamiqueDesabler				= dynamiqueDesabler;
	_this.objectToAppend				= "";
	_this.appendToElem					= "";
	_this.contDiv						= "";
	_this.menu_alpha					= _GLOBALS.CONF.menu_alpha;
	_this.baliseName = 
	{
		conf	: "conf",
		gauche	: "gauche",
		milieu	: "milieu",
		droite	: "droite",
		bouton	: "bouton"
	}
	
	_this.simulViewMenu	=
	{
		gauche : new Array(),
		milieu : new Array(),
		droite : new Array()
	}
	
	_this.attrListAll =
	{
		type				: "type",
		classe 				: "classe",
		custom 				: "custom",
		tip 				: "tip"
	}	
	
	_this._construct = function()
	{
		_this.objName			= objName;
		_this.parent			= parent;
		_this.menuParam			= menuParam;
		
		if(!_this.checkIfCustomEnabled())
		{
			return false;
		}
		
		_this.fonctionaliteMenu = new fonctionaliteMenuManager( _this , "fonctionaliteMenu" , _this.dynamiqueDesabler );
		
		_this.hardAddFonctionalityList();
		_this.constructMenuCss();
		_this.constructMenu();
	}
	
	_this.hardAddFonctionalityList = function()
	{
		for( var J in _this.fonctionaliteMenu.hardAddFonctionalityList )
		{
			var currF = _this.fonctionaliteMenu.hardAddFonctionalityList[J];
			if( currF.active )
			{
				var currBalise = _this.menuParam.find(_this.baliseName[ currF.elementPos ]);
				// console.log( currF.xmlAdd );
				currBalise.children().each(function(e)
				{
					if( currF.elementPosNumber === e )
					{
						$(currF.xmlAdd).insertBefore($(this));
					}
				})
			}
		}
	}	
	
	_this.checkIfCustomEnabled = function()
	{
		var menuBasic = _this.tools.find("menuBasic");
		_this.objectToAppend = menuBasic.attr("className");
		_this.appendToElem = $(menuBasic.attr("appendToElem"));
		
		if( !menuBasic.attr("enabled") || menuBasic.attr("enabled") == "false" )
		{
			return false;
		}
		return true;
	}
	
	_this.constructMenuCss = function()
	{
		var menuBasic = _this.tools.find("menuBasic");
		var defCss = menuBasic.children("defCss");
		var styleCur = "";
		if(defCss)
		{
			styleCur = document.createElement("style");
			$(styleCur).append(defCss.text());
			$("head").append($(styleCur));
		}
	}
	
	_this.constructMenu = function()
	{
		_this.contDiv = $("<div class='"+_this.objectToAppend+"' ></div>");
		for( var J in _this.simulViewMenu )
		{
			var infoXML = _this.menuParam.find(_this.baliseName[J]).find(_this.baliseName.bouton);
			infoXML.each(function()
			{
				var attrList = _this.getAttrToArray($(this));
				_this.simulViewMenu[J].push(attrList);							
			})			
		}
		return _this.simulViewMenu;
	}
	
	_this.getAttrToArray = function(OBJ)
	{
		var methodeNameArray = new Array();
		
		if( OBJ.attr(_this.attrListAll.type) && _this.fonctionaliteMenu.fonctionaliteList[OBJ.attr(_this.attrListAll.type)]
			&& _this.fonctionaliteMenu.fonctionaliteList[OBJ.attr(_this.attrListAll.type)].active
		){}else
		{
			return false;
		}
		
		methodeNameArray["func"] = _this.fonctionaliteMenu.fonctionaliteList[OBJ.attr(_this.attrListAll.type)].func;
		
		for( var J = 0 ; J < OBJ[0].attributes.length ; J++ )
		{
			if( _this.attrListAll[OBJ[0].attributes[J].name] )
			{
				methodeNameArray[ _this.attrListAll[OBJ[0].attributes[J].name] ] = OBJ.attr(OBJ[0].attributes[J].name);
			}
		}

		return methodeNameArray;
	}

	_this.setStyleContent = function()
	{
		var sty = "style='";
		var amount = _this.menu_alpha;
		var teinte = _this.menuParam[0].getAttribute("teinte");
		if( teinte )
		{
			_GLOBALS.CONF.iconesDefaultParam.teinte = parseInt(teinte,16).toString(16);
			_GLOBALS.CONF.iconesDefaultParam.teinteRGB = new convertHexToRGB(_GLOBALS.CONF.iconesDefaultParam.teinte);
		}
		
		var hexColor = _this.menuParam[0].getAttribute("fond");
		
		if(!amount)
		{
			amount = _this.menuParam[0].getAttribute("amount");
			if( amount !==0 && !amount )
			{
				amount = 100;
			}
		}
		
		
		if( hexColor )
		{
			var rCol = parseInt(hexColor,16).toString(16);
			var rCol = new convertHexToRGB(rCol);
			sty+="background-color:rgba("+rCol+" , "+(amount/100)+" );";
			_this.contDiv.css( "box-shadow" , "0px 0px 5px 1px rgba( 0, 0, 0, "+(amount/100)+" )");
		}
		
		sty+="' ";
		return sty;
	}
	
	//AND CSS
	_this.htmlMenu = function( htmlArray )
	{
		var styleTable = _this.setStyleContent();
		var maTable ="";
		for( J in htmlArray )
		{
			maTable += "<td class='menu_"+J+"'>"+htmlArray[J]+"</td>";
		}
		return $("<table class='menuTop' "+styleTable+" ><tr>"+maTable+"</tr></table>");
	}
	
	_this.activAllEventIco = function(currJqElem)
	{
		for( var i = 0 ; i < _this.arrayOfClassElemForEvent.length ; i++ )
		{
			var currElem = currJqElem.find("."+_this.arrayOfClassElemForEvent[i]);
			var currFunc = _this.fonctionaliteMenu.fonctionaliteList[currElem.attr("currClass")].func;
			var currOnload = _this.fonctionaliteMenu.fonctionaliteList[currElem.attr("currClass")].actionOnload;
			
			if( currOnload )
			{
				currOnload(currElem);
			}
			
			currElem.unbind("click");
			currElem.bind("click",function( event )
			{
				if( currFunc && currFunc != "" )
				{
					_this.fonctionaliteMenu.fonctionaliteList[$(this).attr("currClass")].func($(this));
				}
				UTILS.preventDefault(event);
			})
		}
	}
	
	_this.menuTouchStart = function(event)
	{
		var target = event.target || event.srcElement;
		$(target).parent("td").triggerHandler("click");
		UTILS.preventDefault(event);
	}
	
	_this.getMenu = function()
	{
		var htmlArray = new Array();
		for( var J in _this.simulViewMenu )
		{
			htmlArray[J] = "<table><tr>";
			for( var sJ in _this.simulViewMenu[J] )
			{
				if( !_this.simulViewMenu[J][sJ] )
				{
					continue;
				}
				
				var currFunc	= _this.simulViewMenu[J][sJ].func;				
				var currClass	= "menuTop_"+_this.simulViewMenu[J][sJ].type;
				var currElem	= "<td class='"+currClass+"' currClass='"+_this.simulViewMenu[J][sJ].type+"' href='javascript:void(0)' ></td>";
				htmlArray[J]	+= currElem;
			
				_this.arrayOfClassElemForEvent.push(currClass);
				_this.arrayOfClassElemForEventFuncs[currClass] = currFunc;
				
			}
			htmlArray[J] += "</tr></table>";
		}
		
		var currJqElem = _this.htmlMenu( htmlArray );
		_this.activAllEventIco(currJqElem);
		_this.contDiv.append(currJqElem);
		_this.appendToElem.append(_this.contDiv);
		
		$("."+_this.objectToAppend)[0].addEventListener( "touchstart", _this.menuTouchStart , false);
		
		return currJqElem;
	}
	return _this._construct();
}
_GLOBALS.callbackLoadedTmp("menuParamManager");var PagesLoader = function( parent , blockCont )
{
	var _this					= this;
	_this.parent 				= parent;
	_this.objName				= "";
	_this.imagePreloaded 		= new Array();
	_this.lastPage 				= false;
	_this.pageCurrentOriginalIs	= _GLOBALS.CONF.pages.beginPage;
	_this.doublOrSimplePage		= 1;
	_this.pageCreated			= new Object();
	_this.preloadedNext 		= 0;
	_this.preloadedPrev 		= 0;
	_this.qteToLoadTT			= 0;
	_this.pageCreatedIndex		= new Object();
	_this.callBackListOnPageChange = new Array();
	_this.queryByGoToPage		= false;
	
	
	_this.loadPagFunc = function( i , pathTextureLow , defaultName , preloadBy , qteToLoadTT , currentCallBack  )
	{
		// alert(_this.pageCurrentOriginalIs + " " + _GLOBALS.CONF.pages.beginPage);
		_this.pageCreatedIndex[i] = _this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i] = new Image();
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].onload = function()
		{
			_this.qteToLoadTT++;
			if( currentCallBack )
			{
				currentCallBack( _this.imagePreloaded , _GLOBALS.CONF.pages.defaultName+""+i , preloadBy , _this.qteToLoadTT );
			}
		}
		_this.imagePreloaded[_GLOBALS.CONF.pages.defaultName+""+i].src = UTILS.getPathImage( pathTextureLow , i );
	}

	_this.preloadPageFrom = function( currentCallBack , timerActivat )
	{
		var preloadBy	= _GLOBALS.CONF.pages.preloadBy;
		
		if( preloadBy > _GLOBALS.CONF.pages.length )
		{
			preloadBy = _GLOBALS.CONF.pages.preloadBy = _GLOBALS.CONF.pages.length;
		}else if( preloadBy < 1)
		{
			preloadBy = _GLOBALS.CONF.pages.preloadBy = 1;
		}
		
		var pathTextureLow	= _GLOBALS.CONF.pages.pathTextureLow;
		var defaultName		= _GLOBALS.CONF.pages.defaultName;
		var pagesLength		= _GLOBALS.CONF.pages.length;
		var currPage		= _this.pageCurrentOriginalIs;		
		var befor			= Math.floor(preloadBy/2);
		var after			= Math.floor(preloadBy/2)+preloadBy%2;
		var countPassAfter	= 0;
		var countPassBefor	= 0;

		if( currPage < 1 )
		{
			currPage = 1;
		}
		else if( currPage > _GLOBALS.CONF.pages.length )
		{
			currPage = _GLOBALS.CONF.pages.length;
		}
		
		if( _GLOBALS.CONF.pages.doublePage && ( currPage !== 1 ) && UTILS.impair(currPage) )
		{
			currPage--;
		}
		
		if( currPage+after > pagesLength )
		{
			after = pagesLength-currPage;
		}
		
		if( befor >= currPage )
		{
			befor = currPage;
		}
		
		var checkDif = (preloadBy) - (after+befor);

		if( after > befor )
		{
			after+=checkDif;
		}else
		{
			befor+=checkDif;
		}

		var addressToLoadAfter = currPage+after;
		var addressToLoadBefor = currPage-befor;		
		_this.qteToLoadTT = 0;
		
		for( var i = addressToLoadBefor ; i <= addressToLoadAfter ; i++ )
		{
			if(i<1)
			{
				continue;
			}
			
			if(!_this.pageCreatedIndex[i])
			{
				_this.loadPagFunc( i , pathTextureLow , defaultName , preloadBy , _this.qteToLoadTT , currentCallBack );
			}			
		}
		
		_this.pageCurrentOriginalIs = currPage;
		_this.preloadedNext = addressToLoadAfter;
		_this.preloadedPrev = addressToLoadBefor;

		for( var J in _this.pageCreatedIndex )
		{
			if( J < addressToLoadBefor )
			{
				if(_this.pageCreatedIndex[J])
				{
					$(_this.pageCreatedIndex[J]).remove();
					_this.pageCreatedIndex[J] = null;
					delete _this.pageCreatedIndex[J];
					_this.removeOtherObjects(J);
				}				
			}
			else if(  J > addressToLoadAfter  )
			{
				if(_this.pageCreatedIndex[J])
				{
					$(_this.pageCreatedIndex[J]).remove();
					_this.pageCreatedIndex[J] = null;
					delete _this.pageCreatedIndex[J];
					_this.removeOtherObjects(J);
				}
			}
		}
		if( !currentCallBack )
		{
			for(var i = addressToLoadBefor ; i <= addressToLoadAfter ; i++ )
			{
				if(i<1)
				{
					continue;
				}
				i = _this.creatNow( i , timerActivat );
			}
			_this.queryByGoToPage = false;
		}
	}
	
	_this.creatNow2 = function(i , timerActivat )
	{
		var timeAnim = 0;
		if( timerActivat )
		{
			var timeAnim = "active";
		}
		if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i])
		{
			_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , timeAnim , false);
			return void(0);
		}
		
		_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] = $(_this.parent.canvasManager.texture(i));
		_this.pageCreatedIndex[i] = _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i];
		_this.parent.positionForSlider.positionIt( _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+i] , i , _this.pageCurrentOriginalIs , 0 , true );
		return void(0);
	}
	
	_this.creatNow = function( i , timerActivat )
	{
		if( _GLOBALS.CONF.pages.doublePage && ( i === 1 ) )
		{
			_this.creatNow2(i , timerActivat );
			return i;
		}else if( _GLOBALS.CONF.pages.doublePage && i === _GLOBALS.CONF.pages.length && UTILS.impair(_GLOBALS.CONF.pages.length) )
		{
			_this.creatNow2(i , timerActivat );
			return i;
		}
		
		if( _GLOBALS.CONF.pages.doublePage && UTILS.impair(i) )
		{
			i++;
		}
		
		_this.creatNow2( i , timerActivat );
		return i;
	}
	
	_this.removeOtherObjects = function(J)
	{
		var finit = 0;
		if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)])
		{
			if(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove)
			{
				_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)].remove();
			}
			if($(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove)
			{
				$(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove();
			}
			
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
			delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
			finit++;
		}				
		if(_GLOBALS.main.currElemPos[J])
		{
			_GLOBALS.main.currElemPos[J] = null;
			delete _GLOBALS.main.currElemPos[J];
			finit++;
		}				
		if(_this.parent.canvasManager.textureContextList && _this.parent.canvasManager.textureContextList[_this.parent.canvasManager.canvasKey+J])
		{
			_this.parent.canvasManager.textureContextList[_this.parent.canvasManager.canvasKey+J] = null;
			delete _this.parent.canvasManager.textureContextList[_this.parent.canvasManager.canvasKey+J];
			finit++;
		}
		return finit;	
	}
	
	_this.prevPage = function(nb)
	{
		_this.doublOrSimplePage = _this.checkDoublePrev();
		
		if(nb)
		{
			var nextN = nb;
		}else
		{
			var nextN = _this.pageCurrentOriginalIs - _this.doublOrSimplePage;
		}	
		
		if( _this.lastPage )
		{
			_this.lastPage = false;
			nextN = _this.pageCurrentOriginalIs;
		}
			_GLOBALS.CONF.pages.pageCurrentIs = nextN;
			_this.pageCurrentOriginalIs = nextN;
		_this.preloadPageFrom(false,true);
		_this.onPageIsChanged();		
		return void(0);
	}
	
	_this.nextPage = function(nb)
	{
		_this.doublOrSimplePage = _this.checkDoubleNext();
		
		if(nb)
		{
			var nextN = nb;
		}else
		{
			var nextN = _this.pageCurrentOriginalIs + _this.doublOrSimplePage;
		}		
		
		_GLOBALS.CONF.pages.pageCurrentIs = nextN;
		_this.pageCurrentOriginalIs = nextN;
		
		_this.preloadPageFrom(false,true);
		_this.onPageIsChanged();
		
		return void(0);
	}

	_this.goToPage = function(nb)
	{
		_this.queryByGoToPage = true;
		nb = Math.floor(nb);
		if( nb > _this.pageCurrentOriginalIs )
		{
			_this.nextPage(nb);
		}else if( nb < _this.pageCurrentOriginalIs )
		{
			_this.prevPage(nb);
		}
	}

	_this.onPageIsChanged = function()
	{
		var len = _this.callBackListOnPageChange.length;
		for( var i = 0 ; i < len ; i++ )
		{
			_this.callBackListOnPageChange[i](_this.pageCurrentOriginalIs);
		}
	}
	
	_this.onPageChange = function( callBack )
	{
		_this.callBackListOnPageChange.push( callBack );
	}
	
	_this.checkDoubleNext = function(nb)
	{		
		if(!nb)
		{
			nb = _this.pageCurrentOriginalIs;
		}
		
		if( ( _GLOBALS.CONF.pages.doublePage && nb != 1 && nb < _GLOBALS.CONF.pages.length && !UTILS.impair(nb) ))
		{
			return 2;
			
		}
		return 1;
	}
	
	_this.checkDoublePrev = function()
	{
		if( ( _GLOBALS.CONF.pages.doublePage && _this.pageCurrentOriginalIs != 2 && _this.pageCurrentOriginalIs <= _GLOBALS.CONF.pages.length && !UTILS.impair(_this.pageCurrentOriginalIs) ))
		{
			return 2;
		}
		return  1;
	}
	
	_this.goDoublePage = function()
	{
		_GLOBALS.CONF.setDocument();
		
		if( _GLOBALS.CONF.getDocument.height > _GLOBALS.CONF.getDocument.width )
		{
			_GLOBALS.CONF.pages.doublePage = false;
		}else
		{
			_GLOBALS.CONF.pages.doublePage = true;
		}
		
		for( var J = 0 ; J <= _GLOBALS.CONF.pages.length ; J++ )
		{
			if( !_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] )
			{
				continue;
			}
			
			if($(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove)
			{
				$(_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)]).remove();
			}
			_this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)] = null;
			delete _this.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(J)];
			_GLOBALS.main.currElemPos[J] = null;
			delete _GLOBALS.main.currElemPos[J];	
			continue;				
		}
        
		_this.parent.canvasManager.textureContextList = null;
		delete _this.parent.canvasManager.textureContextList;
		_this.parent.canvasManager.textureContextList = new Object();
		_this.pageCreated = null;
		_this.pageCreatedIndex = null;
		_this.pageCreatedIndex = new Object();
		_this.pageCreated = new Object();
		
	    _this.parent.positionForSlider.getInfoPosition();
		_this.preloadPageFrom(false,0);
		return _GLOBALS.CONF.pages.doublePage;
	}
}
_GLOBALS.callbackLoadedTmp("PagesLoader");var Param = function()
{
	_this = this;
	
	_this._construct = function()
	{
		// _this.param
		_this.parameters = _GLOBALS.main.xmlLinksList.getXml.param;
		
		_this.decalagePage();
		_this.setlngDefault();
		_this.setTitle();
		_this.setNbPages();
		_this.sBackgroundColor();
		_this.setPages_W_H();
		_this.menu_alpha();
	}
	
	_this.setNbPages = function()
	{
		var nbPages = _this.parameters.find("parameter[name=nbPages]").attr("value");
		_GLOBALS.CONF.pagesOnInit.length = parseInt(nbPages);
		_GLOBALS.CONF.pages.length = parseInt(nbPages);
	}
	
	_this.setPages_W_H = function()
	{
		// heightB
		var width = _this.parameters.find("parameter[name=widthB]").attr("value");
		var height = _this.parameters.find("parameter[name=heightB]").attr("value");
		_GLOBALS.CONF.pagesOnInit.width = parseInt(width)/2;
		_GLOBALS.CONF.pagesOnInit.height = parseInt(height);
		_GLOBALS.CONF.pages.width = parseInt(width)/2;
		_GLOBALS.CONF.pages.height = parseInt(height);
	}
	
	_this.sBackgroundColor = function()
	{
		var sBackgroundColor = _this.parameters.find("parameter[name=sBackgroundColor]").attr("value");		
		sBackgroundColor = parseInt(sBackgroundColor,16).toString(16);
		_GLOBALS.CONF.getDocument.sBackgroundColor = sBackgroundColor;		
		$("body").css(
		{
			backgroundColor:"#"+_GLOBALS.CONF.getDocument.sBackgroundColor
		});
	}
	
	_this.setTitle = function()
	{
		var title = _this.parameters.find("parameter[name=pdf]").attr("value");
		title = title.slice(0,-4);
		$("title").text(title);
	}
	
	_this.setlngDefault = function()
	{
		var urlLng = _GLOBALS.x_y_z_Manager.getVar("lng");
		
		var lng = _GLOBALS.CONF.getDocument.lngDefault;
		
		lngDef = _this.parameters.find("parameter[name=lng]").attr("value");
		if( lngDef && $.trim(lngDef) != "" )
		{
			_GLOBALS.CONF.getDocument.lngDefault = lngDef;
		}else
		{
			lngDef = _GLOBALS.CONF.getDocument.lngDefault;
		}
		
		if( urlLng && $.trim(urlLng) != "" )
		{
			lng = urlLng;
		}
		_GLOBALS.CONF.getDocument.lng = lng;
		
	}
	
	_this.menu_alpha = function()
	{
		var menu_alpha = _this.parameters.find("parameter[name=menu_alpha]").attr("value");
		_GLOBALS.CONF.menu_alpha = parseInt(menu_alpha);
	}
	
	_this.decalagePage = function()
	{
		var decalagePage = _this.parameters.find("parameter[name=decalagePage]").attr("value");
		_GLOBALS.CONF.decalagePage = parseInt(decalagePage);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("Param");var popupSlide = function( parent , objName , contentHtml , callbackonClose )
{
	var _this			= this;
	_this.objName;
	_this.parent;
	_this.popupSlide	= "";
	_this.popupSlideFull;
	_this.idPopUpUid	= "";
	_this.idPopUp;
	_this.closeClass	= "popupSlide_close";
	_this.reductClass	= "popupSlide_reduct";
	_this.popupClass	= "popupSlide";
	_this.popupSlide_content	= "popupSlide_content";
	_this.enableClose	= true;
	_this.enableReduct	= false;
	
	if( _GLOBALS["openedPOP_"+objName] !== false && _GLOBALS["openedPOP_"+objName] !== true )
	{
		_GLOBALS["openedPOP_"+objName] = false;
	}
	
	_this._construct = function()
	{}
	
	_this.buildPopup = function()
	{
		_this.idPopUp		= _this.popupClass+"_"+_this.idPopUpUid;
		_this.popupSlide	= '<table class="'+_this.popupClass+' '+_this.idPopUp+'">';
			_this.popupSlide	+= '<tr>';
			
			if(_this.enableClose)
			{
				_this.popupSlide	+= '<td class="tdTop">';
					_this.popupSlide	+= '<a class="'+_this.closeClass+'" href="javascript:void(0)"><img src="'+_GLOBALS.CONF.getIconesPath()+'close.png" /></a>';
				_this.popupSlide	+= '</td>';
			}
			
			if(_this.enableReduct)
			{
				_this.popupSlide	+= '<td class="tdTop">';
					_this.popupSlide	+= '<a class="'+_this.reductClass+'" href="javascript:void(0)"><img src="'+_GLOBALS.CONF.getIconesPath()+'close.png" /></a>';
				_this.popupSlide	+= '</td>';
			}
			
			_this.popupSlide	+= '</tr>';
			_this.popupSlide	+= '<tr>';
				_this.popupSlide	+= '<td class="tdBot" >';
				_this.popupSlide	+= '<div class="popupSlide_content"></div>';
				_this.popupSlide	+= '</td>';
			_this.popupSlide	+= '</tr>';
		_this.popupSlide	+= '</table>';
		
		_this.popupSlide	= $(_this.popupSlide);
	}
	
	_this.contentToTpl = function()
	{
		_this.popupSlideFull = true;
		_this.popupSlide.append(contentHtml);
	}
	
	_this.open = function( htmlContent )
	{
		if( !_this.popupSlideFull )
		{
			_this.contentToTpl();
		}

		if(!_GLOBALS["openedPOP_"+objName])
		{
			_GLOBALS["openedPOP_"+objName] = true;
			if( htmlContent )
			{
				_this.popupSlide.find("."+_this.popupSlide_content).append(htmlContent);
			}
			
			_this.popupSlide.css("display","none");
			
			$("body").append(_this.popupSlide);
			
			if(_GLOBALS.main.touchableInfo)
			{
				$("."+_this.popupClass).unbind('touchstart');
				$("."+_this.popupClass).bind('touchstart', function(event)
				{
					if(event.target.className == "tdTop" || event.target.className == "tdBot" )
					{
						UTILS.preventDefault(event);
					}		
				});
			}
			
			if(_this.enableClose)
			{
				_this.creatClose();
			}
			
			if(_this.enableReduct)
			{
				_this.creatReduct();
			}
			
			$("."+_this.idPopUp).transition(
			{
				y:(-(_GLOBALS.CONF.getDocument.height+200))
			},0)
			
			$("."+_this.idPopUp).css("display","table");
			
			$("."+_this.idPopUp).transition(
			{
				y:0
			},400)
		}else
		{
			$("."+_this.idPopUp).css("display","table");
			$("."+_this.idPopUp).transition(
			{
				y:0
			},400)
		}
	}
	
	_this.creatClose = function()
	{
		$("."+_this.idPopUp+" ."+_this.closeClass).bind("click",function()
		{
			_this.close();
		})
	}
	
	_this.close = function()
	{
		_GLOBALS["openedPOP_"+objName] = false;
		$("."+_this.idPopUp+" ."+_this.closeClass).unbind("click");
		
		$("."+_this.idPopUp).transition(
		{
			y:(-(_GLOBALS.CONF.getDocument.height+200))
		},400,function()
		{
			if(callbackonClose)
			{
				callbackonClose();
			}
			
			$(this).remove();
		})	
	}
	
	_this.creatReduct = function()
	{
		$("."+_this.idPopUp+" ."+_this.reductClass).unbind("click");
		$("."+_this.idPopUp+" ."+_this.reductClass).bind("click",function()
		{
			_this.reduct();
		})
	}
	
	_this.reduct = function()
	{
		$("."+_this.idPopUp).transition(
		{
			y:(-(_GLOBALS.CONF.getDocument.height+200))
		},400,function()
		{
			$(this).css("display","none");
		})
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("popupSlide");var PositionForSlider = function(parent)
{
	var _this					= this;
	_this.parent				= parent;
	_this.posCurrentOfElem		= 0;
	_this.currElem				= null;
	_this.defaultPosElementY	= 0;
	_this.lastElemIndex			= 0;
	_this.centerPosXe			= 0;
	
	_this.positionIt = function( currElem , index , currPageN , timeConfCustom , appendIt )
	{
		index			= Math.floor(index);
		currPageN		= Math.floor(currPageN);
		timeConfCustom	= (timeConfCustom !== 0)?_GLOBALS.CONF.pages.animationManager.transitionTime:timeConfCustom;
		_GLOBALS.main.currElemPos[index] = (typeof _GLOBALS.main.currElemPos[index] != "object")?new Object():_GLOBALS.main.currElemPos[index];
		_GLOBALS.main.currElemPos[index].y = _this.defaultPosElementY;
		// currElem.clearQueue();
		var funcToCall = false;
		if( index < currPageN )
		{
			funcToCall = _this.posLeft;
		}
		else if( index == currPageN )
		{
			funcToCall = _this.posCenter;
		}
		else if( index > currPageN )
		{
			funcToCall = _this.posRight;
		}

		if(funcToCall)
		{
			var tT = 16;
			if(!timeConfCustom)
			{
				funcToCall( currElem , index , 0 , appendIt );
				return void(0);
			}
			funcToCall( currElem , index , timeConfCustom , appendIt );
		}
		return void(0);
	}

	_this.posRight = function( currElem , index , timeConfCustom , appendIt )
	{
		var transitTo = {x:_GLOBALS.CONF.getDocument.width,y:0};
		if( appendIt )
		{
			currElem.transition(transitTo, 0 , _GLOBALS.CONF.pages.animationManager.swipEasing);
			_this.parent.blockCont.append(currElem);
		}else if( transitTo && !appendIt && _this.parent.pagesLoader.queryByGoToPage )
		{
			currElem.transition(transitTo, timeConfCustom ,_GLOBALS.CONF.pages.animationManager.swipEasing);
		}
		_GLOBALS.main.currElemPos[index].x = _GLOBALS.CONF.getDocument.width;
	}
	
	_this.posCenter = function( currElem , index , timeConfCustom , appendIt )
	{
		if( index == 1 || index == _GLOBALS.CONF.pages.length )
		{
			currElem.clearQueue();
		}
		_this.currElem = null;
		delete _this.currElem;
		var transitTo = {x:_this.centerPosXe,y:0};
		if(_GLOBALS.timerDrawCanvas)
		{
			clearTimeout(_GLOBALS.timerDrawCanvas);
		}

		if(appendIt)
		{
			currElem.transition(transitTo, 0 , _GLOBALS.CONF.pages.animationManager.swipEasing);
			_this.parent.blockCont.append(currElem);
			
			_GLOBALS.timerDrawCanvas = setTimeout(function()
			{
				_this.parent.controlManager.drawCanvas();
			},_GLOBALS.CONF.pages.timeToLoadHD);	
		}else if( transitTo && !appendIt || _this.parent.pagesLoader.queryByGoToPage )
		{
			if( _this.lastElemIndex && _this.lastElemIndex === index ||  _this.parent.pagesLoader.queryByGoToPage )
			{
				currElem.transition(transitTo, timeConfCustom ,_GLOBALS.CONF.pages.animationManager.swipEasing);
			}
			_this.lastElemIndex = index;
		}
		
		_GLOBALS.timerDrawCanvas = setTimeout(function()
		{
			_this.parent.controlManager.drawCanvas();
		},_GLOBALS.CONF.pages.timeToLoadHD);
		_GLOBALS.main.currElemPos[index].x = _this.centerPosXe;
	}
	
	_this.posLeft = function( currElem , index , timeConfCustom , appendIt )
	{
		var transitTo = {x:-_GLOBALS.CONF.getDocument.width,y:0};
		if(appendIt)
		{
			currElem.transition(transitTo, 0 , _GLOBALS.CONF.pages.animationManager.swipEasing);
			_this.parent.blockCont.append(currElem);
			
		}else if( transitTo && !appendIt && _this.parent.pagesLoader.queryByGoToPage )
		{
			currElem.transition(transitTo, timeConfCustom ,_GLOBALS.CONF.pages.animationManager.swipEasing);
		}
		
		_GLOBALS.main.currElemPos[index].x = -_GLOBALS.CONF.getDocument.width;
	}
	
	_this.onDragElem = function( diffPosX )
	{
		clearTimeout(_GLOBALS.timerDrawCanvas);
		if( !_this.currElem )
		{
			_this.currElem = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		}
		
		_this.posCurrentOfElem = _GLOBALS.main.currElemPos[_this.parent.pagesLoader.pageCurrentOriginalIs].x+diffPosX;
		
		// $("canvas").clearQueue();
		
		_this.currElem.transition(
        {
        	x: _this.posCurrentOfElem
        },0,_GLOBALS.CONF.pages.animationManager.defEasing);
		
		// if(_this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+1)])
		// {
			// _this.currElemP2 = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs+1)];
			// _this.currElemP2.transition(
			// {
				// x: _this.posCurrentOfElem+_GLOBALS.CONF.getDocument.width
			// },0,_GLOBALS.CONF.pages.animationManager.defEasing);
		// }
		// if(_this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-1)])
		// {
			// _this.currElemP2 = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+(_this.parent.pagesLoader.pageCurrentOriginalIs-1)];
			// _this.currElemP2.transition(
			// {
				// x: -_GLOBALS.CONF.getDocument.width+_this.posCurrentOfElem
			// },0,_GLOBALS.CONF.pages.animationManager.defEasing);
		// }
	}
	
	_this.onDropElem = function( diffPosX )
	{
		if( !_this.currElem )
		{
			_this.currElem = _this.parent.pagesLoader.pageCreated[_GLOBALS.CONF.pages.defaultName+""+_this.parent.pagesLoader.pageCurrentOriginalIs];
		}
		_GLOBALS.main.currElemPos[_this.parent.pagesLoader.pageCurrentOriginalIs].x = _GLOBALS.main.currElemPos[_this.parent.pagesLoader.pageCurrentOriginalIs].x+diffPosX;  
	}

	_this.getInfoPosition = function()
	{
		_GLOBALS.CONF.setDocument();
		
		var pageW				= _GLOBALS.CONF.pagesOnInit.width;
		var pageWX2				= pageW;
		var pageH				= _GLOBALS.CONF.pagesOnInit.height;		
		var pageOutW			= _GLOBALS.CONF.pages.width;
		var pageOutH			= _GLOBALS.CONF.pages.height;		
		var docW				= _GLOBALS.CONF.getDocument.width;
		var docH				= _GLOBALS.CONF.getDocument.height;		
		var currScaleOut		= _GLOBALS.CONF.pagesOnInit.currScale;
		var keepMaxResolution	= _GLOBALS.CONF.pages.keepMaxResolution;	
		var nbFloat				= 1000;
		var prW					= 0;
		var prH					= 0;
		var operatDouble		= 1;
		var propCibleScale		= prW;
		_GLOBALS.CONF.pages.currScale	= currScaleOut;		
		
		if( _GLOBALS.CONF.pages.doublePage )
		{
			pageWX2 *= 2;
			operatDouble = 2;
		}
		
		if( ((docH > pageH) && (docW > pageWX2)) && keepMaxResolution )
		{
			pageOutH	= pageH;
			pageOutW	= pageW;
		}else
		{
			prW = Math.floor(docW/pageWX2*nbFloat)/nbFloat;
			prH = Math.floor(docH/pageH*nbFloat)/nbFloat;
			
			if( prW<prH )
			{
				propCibleScale	= prW;            
			}else
			{
				propCibleScale	= prH;
			}
			
			currScaleOut	= propCibleScale;
			pageOutH		= pageH*propCibleScale;
			pageOutW		= (pageWX2*propCibleScale)/operatDouble;
		}
		
		_GLOBALS.CONF.pages.width		= pageOutW;
		_GLOBALS.CONF.pages.height		= pageOutH;
		_GLOBALS.CONF.pages.currScale	= currScaleOut;		
		return void(0);
	}
	
	_this.alignAll = function()
	{
		if( _this.parent.controlManager.resetZoomInfo && !_this.parent.controlManager.autoriseChangePage )
		{
			_this.parent.controlManager.resetZoomInfo();
		}
		_this.parent.pagesLoader.goDoublePage();
		// _this.positionAll();
		return void(0);
	}
	
	
	_this._construct = function()
	{
		return void(0);
	}
	
	_this._construct();
	
}
_GLOBALS.callbackLoadedTmp("PositionForSlider");var RechercheSlider = function( parent , objName )
{
	var _this = this;
	_this.objName;
	_this.parent;
	_this.tools				= parent.xmlLinksList.getXml.tools;
	_this.contDiv			= "";
	_this.objectToAppend	= "";
	_this.appendToElem		= "";
	_this.thumbs			= {};
	_this.thumbs.width		= "";
	_this.thumbs.height		= "";
	_this.thumbs.marginLeft	= "";
	_this.imgList			= {};
	_this.carrouselClassName	= "";
	_this.thumbSizeW		= 0;
	_this.carrouselTouchMoveIs = false;
	_this.carrouselTouchMovePosXDif = 0;
	_this.carrouselTouchMovePosXDifOriginal = 0;
	_this.posElem			= 0;
	_this.originPosElem		= 0;
	_this.maxthumbs			= 5;
	_this.rotatTime			= 300;
	_this.xTime				= 200;
	_this.goToThumbTimer	= false;
	_this.perspectiveCss3	= "100px";
	_this.degCss3			= "360";
	_this.countNeedLoad		= 0;
	
	_this.addressToLoadAfter = 0;
	_this.addressToLoadBefor = 0;
		
	_this._construct = function()
	{
		if(!_this.checkIfCustomEnabled())
		{
			return false;
		}
		
		_this.constructMenuCss();
	}
	
	_this.transitBasic = function( elem , posOrNeg , timeT )
	{
		if(!timeT)
		{
			timeT = 0;
		}
		elem.clearQueue();
		elem.transition(
		{
			perspective: _this.perspectiveCss3,
			rotateY: _this.degCss3*posOrNeg
		},timeT);
		elem.attr("style",elem.attr("style")+";transform:translateZ(100px)")
		return false;
	}
	
	_this.checkIfCustomEnabled = function()
	{
		var carrousel = _this.tools.find("carrousel");
		_this.carrouselClassName = carrousel.attr("className");
		_this.objectToAppend = "<div class='"+_this.carrouselClassName+"'></div>";
		_this.appendToElem = $(carrousel.attr("appendToElem"));
		
		if( !carrousel.attr("enabled") || carrousel.attr("enabled") == "false" )
		{
			return false;
		}
		// thumbs
		var thumbs = carrousel.find("thumbs");
		_this.thumbs.width = Math.floor(thumbs.attr("width"));
		_this.thumbs.height = Math.floor(thumbs.attr("height"));
		_this.thumbs.marginLeft = Math.floor(thumbs.attr("marginLeft"));
		
		return true;
	}
	
	_this.constructMenuCss = function()
	{
		var carrousel = _this.tools.find("carrousel");
		var defCss = carrousel.children("defCss");
		var styleCur = "";
		if(defCss)
		{
			styleCur = document.createElement("style");
			$(styleCur).append(defCss.text());
			$("head").append($(styleCur));
		}
	}
	
	_this.carrouselTouchMove = function(event,curThis)
	{
		var eventTouch = event;
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		
		_this.carrouselTouchMoveIs = true;	
		_this.carrouselTouchMovePosXDif = (_this.carrouselTouchMovePosXDifOriginal - eventTouch.pageX);
		_this.posElem = _this.originPosElem - _this.carrouselTouchMovePosXDif;
		
		if( _this.posElem >= 0 || _GLOBALS.CONF.getDocument.width >= (_this.thumbSizeW*_GLOBALS.CONF.pages.length))
		{
			_this.posElem = 0;
			_this.originPosElem = 0;
			_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
		}else if( _this.posElem-_GLOBALS.CONF.getDocument.width <= -(_this.thumbSizeW*_GLOBALS.CONF.pages.length) && (_GLOBALS.CONF.getDocument.width<_this.thumbSizeW*_GLOBALS.CONF.pages.length))
		{
			_this.posElem = -(_this.thumbSizeW*_GLOBALS.CONF.pages.length)+_GLOBALS.CONF.getDocument.width;
			_this.originPosElem = _this.posElem;
			_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
			
			//nombre de thumbs par ecran
			var nThumbsLastForGetCurrent = -Math.floor(((_this.posElem/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
			_this.thumbsManager(nThumbsLastForGetCurrent);
		}else
		{
			//nombre de thumbs par ecran
			var nThumbsLastForGetCurrent = -Math.floor(((_this.posElem/_this.thumbSizeW)-(_this.maxthumbs/2))-1);
			_this.thumbsManager(nThumbsLastForGetCurrent);
		}
		$(".sousCarrousel").clearQueue();
		$(".sousCarrousel").transition(
		{
			x:_this.posElem
		}, 0 )
		return false;
	}
	
	_this.carrouselTouchStart = function(event,curThis)
	{
		var eventTouch = event;
		
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		// var target = event.target || event.srcElement;
		// event est l'objet Event
		
		_this.carrouselTouchMovePosXDifOriginal = eventTouch.pageX;
		
		var elemPos = $(".sousCarrousel").position();
		var elemPosX = elemPos.left;
		_this.originPosElem = elemPosX;
		
		if(_GLOBALS.main.touchableInfo)
		{
			curThis.bind( "touchmove" , function(e)
			{
				_this.carrouselTouchMove(e);
			})
		}else
		{
			curThis.bind( "mousemove" , function(e)
			{
				_this.carrouselTouchMove(e);
			})
		}
		

		UTILS.preventDefault(event);
		return false;
	}
	
	_this.goToThumb = function( gotoPage , target )
	{
		if(!target)
		{
			var target = $(".sousCarrousel").find("[gotopage="+gotoPage+"]");
			if( !target.length )
			{
				return void(0);
			}
		}
		
		var currPos	= 0;
		var leftP	= 0;

		currPos		= $(target).position();
		var targetX	= leftP = currPos.left;
		
		if( leftP < _this.originalPosThumbCenter )
		{
			leftP = 0;
		}else
		{
			leftP = leftP - _this.originalPosThumbCenter;
		}
		$(".sousCarrousel").clearQueue();
		$(".sousCarrousel").transition(
		{
			x:-leftP
		}, _this.xTime )

		
		$(".positioneur").clearQueue();
		
		var posX =  (targetX)
		var scaleW = 2;
		var xOrigine = 0;
		var checPair = UTILS.byPageIfDouble(gotoPage);
		if(checPair.isDouble)
		{
			scaleW = 2;	
		}
		else
		{
			scaleW = 1;
		}

		$(".positioneur").transition(
		{
			x:posX,
			scale:[scaleW,1]
		},_this.xTime)
		
		_this.lastTarget = $(target);
		return false;
	}
	
	_this.carrouselTouchEnd = function(event,curThis)
	{
		var eventTouch = event;
		if(_GLOBALS.main.touchableInfo)
		{
			eventTouch = eventTouch.originalEvent.touches[0];
		}
		
		_this.carrouselTouchMovePosXDifOriginal = 0;
		if(_GLOBALS.main.touchableInfo)
		{
			curThis.unbind("touchmove");
		}else
		{
			curThis.unbind("mousemove");
		}
		
		if(_this.carrouselTouchMoveIs)
		{
			_this.carrouselTouchMovePosXDif = 0;
			_this.carrouselTouchMoveIs = false;
			return void(0);
		}
		
		var target = event.target || event.srcElement;		
		
		var gotoPage = $(target).attr("gotopage");
		if(gotoPage)
		{
			_GLOBALS.main.controlManager.goToPage(gotoPage);
			_this.thumbsManager(gotoPage, function()
			{
				_this.goToThumb( gotoPage , target );
			})
		}

		UTILS.preventDefault(event);
	}
	
	
	_this.loadThumbImg = function( i , diapo , addTo , thumbSizeW , needToload , callBack )
	{
		if(_this.imgList[i])
		{
			_this.imgList[i].askForDeletable = false;
			_this.countNeedLoad++;
			if( _this.countNeedLoad >= needToload && callBack )
			{
				callBack();
			}
			return void(0);
		}
		var posXImg = 0;
		var currImg = new Image();
		$(currImg).attr("goToPage",i);
		$(currImg).clearQueue();
		
		var checPair = UTILS.byPageIfDouble(i);
		if(checPair.isDouble)
		{
			if( checPair.isDoublePage[1] )
			{
				posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
			}else
			{
				posXImg = ((i-1)*thumbSizeW-((_this.thumbs.marginLeft)))-1;
			}			
		}
		else
		{
			posXImg = (i-1)*thumbSizeW+((_this.thumbs.marginLeft)/2);
		}
		
		
		$(currImg).transition(
		{
			left:posXImg
		},0);
		
		_this.transitBasic( $(currImg) , 1 );
		currImg.onload = function()
		{
			_this.countNeedLoad++;
			var testFinde = addTo.find("[goToPage="+i+"]");
			if(!testFinde.length)
			{
				addTo.append($(this));
			}
			
			_this.transitBasic( $(this) , 0 , _this.rotatTime );
			if( _this.countNeedLoad >= needToload && callBack )
			{
				callBack();
			}			
		}
		currImg.src = UTILS.getPathImage( diapo , i );
		_this.imgList[i] = currImg;
		return void(0);
	}
	
	_this.resetAll = function()
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				$(".sousCarrousel").children("img").remove();
				_this.imgList[J] = null;
				delete _this.imgList[J];
			}
			// _this.thumbsManager();
			// _this.goToThumb(  _GLOBALS.main.pagesLoader.pageCurrentOriginalIs+1  );
		}
	}
	
	_this.thumbsManager = function( loadAddThumbs , callBack )
	{
		if(_this.imgList)
		{
			//cleanOthers
			for( var J in _this.imgList )
			{
				if( J < _this.addressToLoadBefor )
				{
					_this.imgList[J].askForDeletable = true;
					$(_this.imgList[J]).clearQueue();
					$(_this.imgList[J]).transition(
					{
						rotateY: _this.degCss3
					},_this.rotatTime,function()
					{
						var currJ = $(this).attr("goToPage");
						if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
						{
							return false;
						}
						$(this).remove();
						_this.imgList[currJ] = null;
						delete _this.imgList[currJ];
						return false;
					});
				}else if(  J > _this.addressToLoadAfter )
				{
					_this.imgList[J].askForDeletable = true;
					$(_this.imgList[J]).clearQueue();
					$(_this.imgList[J]).transition(
					{
						rotateY: _this.degCss3
					},_this.rotatTime,function()
					{
						var currJ = $(this).attr("goToPage");
						if(!_this.imgList[currJ] || !_this.imgList[currJ].askForDeletable )
						{
							return false;
						}
						$(this).remove();
						_this.imgList[currJ] = null;
						delete _this.imgList[currJ];
						return false;
					});
				}
			}
		}
		var currPage = 0;
		if( loadAddThumbs )
		{
			currPage = Math.floor(loadAddThumbs);
		}else
		{
			currPage = _GLOBALS.main.pagesLoader.pageCurrentOriginalIs;
		}
		
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var thumbSizeW	= _this.thumbSizeW;
		var pagesLength	= _GLOBALS.CONF.pages.length;
		
		if( _this.maxthumbs > pagesLength )
		{
			_this.maxthumbs = pagesLength;
		}
		else if( _this.maxthumbs < 1)
		{
			_this.maxthumbs = 1;
		}		
		
		var befor = Math.floor(_this.maxthumbs/2);
		var after = Math.floor(_this.maxthumbs/2)+_this.maxthumbs%2;
		var addTo = $(".sousCarrousel");
		var countPassAfter = 0;
		var countPassBefor = 0;
		
		if( currPage+after > pagesLength )
		{
			after = pagesLength-currPage;
		}
		
		if( befor > currPage )
		{
			befor = currPage-1;
		}
		
		var checkDif = _this.maxthumbs - (after+befor);
		
		if( after > befor )
		{
			after+=checkDif;
		}else
		{
			befor+=checkDif;
		}
		
		_this.addressToLoadAfter = currPage+after;
		_this.addressToLoadBefor = currPage-befor;
		
		_this.countNeedLoad = 0;
		
		for( var i = currPage ; i <= _this.addressToLoadAfter ; i++ )
		{
			_this.loadThumbImg( i , diapo, addTo , thumbSizeW , after+befor , callBack );
		}

		for( var i = currPage ; i >= _this.addressToLoadBefor ; i-- )
		{
			_this.loadThumbImg( i , diapo , addTo , thumbSizeW , after+befor , callBack );
		}
		return false;
	}
	
	_this.resized = function()
	{
		_this.thumbSizeW = (_this.thumbs.width)+(_this.thumbs.marginLeft)*2;
		//nombre de thumbs par ecran
		_this.originalPosThumb = Math.floor(_GLOBALS.CONF.getDocument.width/_this.thumbSizeW)+1;
		
		if( _this.maxthumbs < _this.originalPosThumb )
		{
			_this.maxthumbs =_this.originalPosThumb;
		}
		_this.originalPosThumbCenter = (Math.floor(_GLOBALS.CONF.getDocument.width/2))-(_this.thumbSizeW/2);
		return false;
	}
	
	_this.getCarrouselManager = function()
	{
		_this.resized();
		var pagesLength	= _GLOBALS.CONF.pages.length;
		var thumbSizeW	= _this.thumbSizeW;
		var sizeCarW	= pagesLength*thumbSizeW;
		var diapo		= _GLOBALS.CONF.pages.Diapo;
		var objIntern	= $(_this.objectToAppend);
		
		objIntern.append("<div class='sousCarrousel' style='height:100%;width:"+sizeCarW+"px;' ><div class='positioneur' ></div></div>");
		
		_this.appendToElem.append(objIntern);
		$(".positioneur").css(
		{
			width:_this.thumbs.width,
			transformOrigin: '0px 0px'
		});
		if(_GLOBALS.main.touchableInfo)
		{
			$("."+_this.carrouselClassName).bind('touchstart', function(event)
			{
				_this.carrouselTouchStart( event , $(this) );	
			});
			
			$("."+_this.carrouselClassName).bind('touchend', function(event)
			{
				_this.carrouselTouchEnd( event , $(this) );	
			});
		}else
		{
			$("."+_this.carrouselClassName).bind("mousedown",function(event)
			{
				_this.carrouselTouchStart( event , $(this) );
			})
			
			$("."+_this.carrouselClassName).bind("mouseup",function(event)
			{
				_this.carrouselTouchEnd( event , $(this) );
			})
		}
		
		_this.thumbsManager();
		
		_GLOBALS.main.pagesLoader.onPageChange(function(currPage)
		{
			if(_this.goToThumbTimer)
			{
				clearTimeout(_this.goToThumbTimer);
			}
			
			_this.goToThumbTimer = setTimeout(function()
			{
				_this.thumbsManager(currPage, function()
				{
					if(_GLOBALS.main.controlManager.showToolsInfo)
					{
						_this.goToThumb( currPage );
					}
				})
			},60)		
		});
		
		_GLOBALS.main.controlManager.onShowTools(function(info)
		{
			if(info)
			{
				_this.thumbsManager();
				_this.goToThumb(  _GLOBALS.main.pagesLoader.pageCurrentOriginalIs  );
			}
		});
		
		return false;
	}
	
	return _this._construct();	
}
_GLOBALS.callbackLoadedTmp("RechercheSlider");var RechercheTextXml = function( parent , objName , textXml )
{
	var _this					= this;				//Object
	_this.objName				= String(objName);	//String
	_this.parent				= parent;			//Object	
	_this.saveLastQuery			= false;			//Bool	
	_this.textXml;								//Object jQuery xml
	_this.toFind				= new Array();		//Array
	_this.bigContResRecherche	= "bigContResRecherche";
	_this.formRechercheClass 	= "formRecherche";
	_this.resultRechercheParent	= "resultRechercheParent";
	_this.resultRecherche		= "resultRecherche";
	_this.motRecherche			= "";
	_this.absolutePathMain		= "_GLOBALS.main."+objName;
	_this.tplHtml				= "";
	_this.finderTimeId;
	_this.asyncFinderPos		= 0;
	_this.asyncFinderPosProgress	= 0;
	_this.timerFinder			= 40;
	_this.rechercheTimer;
	_this.languePage			= _GLOBALS.main.xmlLinksList.getXml.langue.find("menuitem[index=93]").attr("label");
	_this.langueRechecheInput	= _GLOBALS.main.xmlLinksList.getXml.langue.find("menuitem[index=151]").attr("label");
	_this._construct = function()
	{
		// _this.textXml = textXml.find("page");
		_this.textXml = textXml.children("page");
	}

	_this.rechercheParPage = function( pageN )
	{
		for(var i = 0 ; i < _this.toFind.length ; i++ )
		{
			var pattern = new RegExp('('+UTILS.addslashes(_this.toFind[i])+')', ['gi']);
			return pattern.test(pageN);
		}
		return false;
	}
	
	_this.thumbClicked = function(elem)
	{
		_GLOBALS.main.controlManager.goToPage($(elem).attr("gotopage"));
		$(elem).transition(
		{
			rotateX:"40deg"
		},200,function()
		{
			$(this).transition(
			{
				rotateX:"0deg"
			},200,function()
			{
				//CLOSE
				_GLOBALS.main.popupSlideList.recherche.reduct();
			})
		})
	}

	_this.asyncFinder = function( elem )
	{
		if( elem[_this.asyncFinderPos] && _this.asyncFinderPos <= _GLOBALS.CONF.pages.length )
		{
			_this.finderTimeId = setTimeout(function()
			{
				var jsOnclick='javascript:_GLOBALS.main.rechercheTextXml.thumbClicked';
				var currR = ( _this.rechercheParPage( $(elem[_this.asyncFinderPos]).text() ) );
				if(currR)
				{
					var tplHtml = "";
						tplHtml += "<table class='rechercheReslutByOne rechercheReslutByOne"+UTILS.impair(_this.asyncFinderPosProgress)+"' cellpadding='0' cellspacing='0' style='display:none' onclick='"+jsOnclick+"(this)' gotopage='"+(_this.asyncFinderPos+1)+"' >";
							tplHtml += "<tr>";
								tplHtml += "<td class='tdImgRecherche' ><img src='"+UTILS.getPathImage(_GLOBALS.CONF.pages.Diapo,_this.asyncFinderPos+1)+"' /></td>";
								tplHtml += "<td class='tdTXTRecherche' ><p>"+_this.languePage+" N "+UTILS.byOffsetIndex(_this.asyncFinderPos+1)+"</p></td>";
							tplHtml += "</tr>";
						tplHtml += "</table>";
					$("."+_this.resultRecherche).append(tplHtml);
					$(".rechercheReslutByOne[gotopage="+(_this.asyncFinderPos+1)+"]").transition(
					{
						rotateX:"90deg"
					},0)
					
					$(".rechercheReslutByOne[gotopage="+(_this.asyncFinderPos+1)+"]").css(
					{
						display:"table",
						transformOrigin: '40px 40px',
						perspective:"500"
					})
					
					$(".rechercheReslutByOne[gotopage="+(_this.asyncFinderPos+1)+"]").transition(
					{
						rotateX:"0deg"
					},200)
					
					_this.asyncFinderPosProgress++;
				}
				_this.asyncFinderPos++;
				_this.asyncFinder(elem);
			},_this.timerFinder);
		}else
		{
			_this.asyncFinderPos = 0;
		}
	}
	
	_this.recherche = function( toFind )
	{
		console.log(_GLOBALS.CONF.getDocument.height);
		$("."+_this.resultRechercheParent).transition(
		{
				height:(_GLOBALS.CONF.getDocument.height-100)
		},0)
		$("."+_this.bigContResRecherche).transition(
		{
			height:(_GLOBALS.CONF.getDocument.height-100)
		},0)
		clearTimeout(_this.rechercheTimer);
		clearTimeout(_this.finderTimeId);
		_this.asyncFinderPos = 0;
		if(!toFind)
		{
			return void(0);
		}
		else
		{
			if( toFind[0] == _this.toFind[0] )
			{
				return void(0);
			}
			$("."+_this.resultRecherche).empty();
			_this.toFind = toFind;
		}
		if( !_this.textXml )
		{
			_this._construct();
		}
		
		var textXml = _this.textXml;
		textXml.toArray();
		textXmlL = textXml.length;
		
		// $("."+_this.resultRechercheParent).height(textXmlL*);
		
		_this.rechercheTimer = setTimeout(function(textXml)
		{
			_this.asyncFinder( textXml );
		},200,textXml)
		
		if(_GLOBALS.main.touchableInfo)
		{
			setTimeout(function()
			{
				$("."+_this.resultRechercheParent).scroll(function(eventSc)
				{
					_this.scrollTopE = $(this).scrollTop();
					if( $(this).scrollTop() <=0 )
					{
						$(this).scrollTop(1);
					}else if( $(this).scrollTop() == $("."+_this.resultRecherche).height()-$(this).height() )
					{
						$(this).scrollTop( ($("."+_this.resultRecherche).height()-$(this).height()-1) )
					}
				});
			},20);			
		}
	}


	_this.listenIt = function(strVal)
	{
		_this.motRecherche = strVal;
		var rStrVal = new Array();
		rStrVal.push(_this.motRecherche);
		_this.recherche( rStrVal , true );
	}

	_this.formRecherche = function()
	{
		var onSubmited = "("+_this.absolutePathMain+".listenIt( this.valRech.value , this ))";
		var tplForm = "<form class='"+_this.formRechercheClass+"' onSubmit='javascript:"+onSubmited+"' method='GET' action='javascript:void(0)' >";
			tplForm += "<input name='valRech' type='text' pattern='.{3,}' placeholder='"+_this.langueRechecheInput+"' required autofocus value='"+UTILS.stripslashes(_this.motRecherche)+"' />";
			tplForm += "<input name='rechercheOK' type='submit' value='OK' />";
		tplForm += "</form>";
		return tplForm;
	}
	
	_this.initRecherche = function()
	{
		_this.tplHtml = "";		
		_this.tplHtml = "<div class='"+_this.bigContResRecherche+"' style='height:"+(_GLOBALS.CONF.getDocument.height-100)+"px' >";
			_this.tplHtml += _this.formRecherche();
			_this.tplHtml += "<div class='"+_this.resultRechercheParent+"' style='height:"+(_GLOBALS.CONF.getDocument.height-100)+"px' >";
				_this.tplHtml += "<div class='"+_this.resultRecherche+"' >";
				_this.tplHtml += "</div>";
			_this.tplHtml += "</div>";
		_this.tplHtml += "</div>";
		
		UTILS.onResizeCustom(function()
		{
			$("."+_this.resultRechercheParent).transition({
				height:(_GLOBALS.CONF.getDocument.height-100)
			},200)
			
			$("."+_this.bigContResRecherche).transition({
				height:(_GLOBALS.CONF.getDocument.height-100)
			},200)			
		});
		return _this.tplHtml;
	}
}
_GLOBALS.callbackLoadedTmp("RechercheTextXml");var SommaireManager = function( parent , objName , sommaire )
{
    var _this = this;
	_this.absolutePathMain	= "_GLOBALS.main."+objName;
    _this.sommaire;
    
    _this._construct = function()
	{
        _this.sommaire = sommaire;
        //console.log(sommaire);
	}
   
	_this.listenIt = function(target)
	{
		if($(target).attr("gotopage"))
		{
			_GLOBALS.main.controlManager.goToPage($(target).attr("gotopage"));
			_GLOBALS.main.popupSlideList.sommaireManager.reduct();
		}
	}
    
	_this.getDepth = function( curr , niveau , nbspNiveau ) 
    {
    	var listElement = '';
		var marginLeft = 10*niveau;
		var label = "";
		var numPage = "";
		var width = 100-marginLeft;
		var gotopage = $(curr).attr('numPage');
		var spansIn = "";
		if(!gotopage)
		{
			gotopage = "";
		}else
		{
			gotopage = " gotopage='"+gotopage+"' onclick='"+_this.absolutePathMain+".listenIt(this)' ";
		}
		
		if($(curr).attr("numPage"))
		{
			numPage = $(curr).attr("numPage");
		}
		
		if($(curr).attr("numPage"))
		{
			label = $(curr).attr("label");
		}
		
		if(label ||  numPage)
		{
			spansIn = "<li class='label' style='text-indent:"+marginLeft+"px'  ><span class='labelSpan' "+gotopage+" >"+label+"</span><span class='numSpan'  "+gotopage+" >"+numPage+"</span></li>";
		}
		
		
		listElement +="<ul class='ul_niveau_"+niveau+"' >";
		listElement += spansIn;
       	var currChild = curr.children();
        
    	if (currChild.length)
    	{
            currChild.each(function(e)
            {
				listElement +="<li class='childs'>"+_this.getDepth( $(this) , niveau+1 )+"</li>";
            });
    	}
		listElement +="</ul>";
       	return listElement;
    }
	
	_this.checkScroll = function(target)
	{
		_this.scrollTopE = $(target).scrollTop();
		var clacuSc = ($(target).scrollTop() - ($(".sommaire").height()-$(target).height()));
		if( $(target).scrollTop() <=0 && $(target).scrollTop() >= -5 )
		{
			$(target).scrollTop(1);
		}
		else if( clacuSc <= 1 && clacuSc >=-5 )
		{
			$(target).scrollTop( ($(".sommaire").height()-$(target).height()-2) )
		}
	}
	
    _this.getSommaire = function()
	{
        var html = "<div class='sommaireParent' onscroll='"+_this.absolutePathMain+".checkScroll(this)' style='height:"+(_GLOBALS.CONF.getDocument.height-100)+"px' ><div class='sommaire'>";
		var nbspNiveau = "";
     	var listElement = _this.getDepth(_this.sommaire , 0 , nbspNiveau );
        html += listElement;
        html += '</div></div>';
		
		UTILS.onResizeCustom(function()
		{
			$(".sommaireParent").transition({
				height:(_GLOBALS.CONF.getDocument.height-100)
			},200)
			
			$(".sommaireParent").transition({
				height:(_GLOBALS.CONF.getDocument.height-100)
			},200)			
		});
		
        return html;
    }
       
    _this._construct();
}
_GLOBALS.callbackLoadedTmp("SommaireManager");var TemplateManager = function(parent)
{
	var _this = this;
	
	_this.construct = function()
	{
		return void(0);
	}
	
	_this.listTpl = {};
	
	_this.listTplResult = {};
	
	_this.getList = function( callback )
	{
		var infoTpl = new Array();
		for( var tpl in _this.listTpl )
		{
			infoTpl.push(tpl);			
			continue;
		}
		
		_this.getHttpRess( 0, infoTpl , callback );
	}
	
	_this.getHttpRess = function( cc , infoTpl , callback )
	{
		if( !infoTpl[cc] || !_this.listTpl[infoTpl[cc]] )
		{
			if( callback )
			{
				console.log("!! No tpl infoTpl[cc] = undefined cc = N")
				callback();
			}			
			return void(0);
		}
		
		$.get(_this.listTpl[infoTpl[cc]],
		function( data , stat)
		{
			if( stat == "success" )
			{
				var uid = infoTpl[cc];
				Object.defineProperty( _this.listTplResult, uid,
				{
					value: data,
					writable : true,
					configurable : true,
					enumerable : true
				})
			
				cc++;
				
				if( infoTpl.length <= cc )
				{
					if( callback )
					{
						callback();
					}				
					return void(0);
				}else
				{
					_this.getHttpRess( cc , infoTpl , callback );
					return void(0);
				};
			}			
			return void(0);
		},"html");
		
		return void(0);		
	}
	
	_this.construct();
}
_GLOBALS.callbackLoadedTmp("TemplateManager");var Utils = function()
{
	var _this = this;
	_this.onResizeCustomList = new Array();	
	
	_this._construct = function()
	{
		/*Accelerator func*/
		Math.abs = function(a)
		{
			return a < 0 ? -a : a;
		}
		
		Math.floor = function(a)
		{
			return a>>0;
		}
		
		Math.ceil = function(a)
		{
			var xa = Math.floor(a);
			return (a>xa)?xa++:a;
		}
		
		custFloor = function(numb,app)
		{
			if(!app){app = 100;	}
			return Math.floor(numb*app)/app;
		}
		
		return void(0);
		
	}
	
	/*Kev*/
	_this.arrondi = function(nombre)
	{
	   return Math.floor(nombre*100)/100;
	}
	
	_this.getFileExtension = function(filename)
	{
	   return (/[.]/.exec(filename)) ? /[^.]+$/.exec(filename) : undefined;
	}
	
	_this.getFilenameWithoutExtension = function(filename)
	{
	   return (/[.]/.exec(filename)) ? /^[^.]+/.exec(filename) : undefined;
	}
	/*****/
	
	_this.impair = function(nombre)
	{
	   return ((nombre)&1);
	}
	
	/*
	 * Fonction de clonage
	 * @author Keith Devens
	 * @see http://keithdevens.com/weblog/archive/2007/Jun/07/javascript.clone
	 */
	_this.clone = function(srcInstance)
	{
		/*Si l'instance source n'est pas un objet ou qu'elle ne vaut rien c'est une feuille donc on la retourne*/
		if(typeof(srcInstance) != 'object' || srcInstance == null)
		{
			return srcInstance;
		}
		/*On appel le constructeur de l'instance source pour cre une nouvelle instance de la mme classe*/
		var newInstance = srcInstance.constructor();
		/*On parcourt les proprits de l'objet et on les recopies dans la nouvelle instance*/
		for(var i in srcInstance)		{
			newInstance[i] = _this.clone(srcInstance[i]);			continue;
		}
		/*On retourne la nouvelle instance*/
		return newInstance;
	}	
	
	_this.getMaskOfPng = function( pathPng , inElementHtml , isColor )//return data of png
	{
		var imgObject = new Image();
		imgObject.src = pathPng;
		var sizeW	= 48;
		var sizeH	= 48;
		
		imgObject.onload = function()
		{
			var cvsElem		= document.createElement('canvas');
			
			var posToPutX	= sizeW/2 - imgObject.width/2;
			var posToPutY	= sizeH/2 - imgObject.height/2;
			
			// cvsElem.width	= imgObject.width;
			// cvsElem.height	= imgObject.height;
			
			cvsElem.width	= sizeW;
			cvsElem.height	= sizeH;
			var canvas		= cvsElem;
			var ctx			= cvsElem.getContext("2d");
			var image		= this;
			
			ctx.shadowColor		= "rgba( "+isColor+", 0.2 )";
			ctx.shadowOffsetX	= 2;
			ctx.shadowOffsetY	= 2;
			ctx.shadowBlur		= 2;
			ctx.drawImage(image,0,0);
			var imgd		= ctx.getImageData(0, 0, cvsElem.width , cvsElem.height );
			// Loops through all of the pixels and modifies the components.
			var imgDl		= imgd.data.length;
			var counter = 0;
			for ( var i = 0 ; i < imgDl ; i += 4 )
			{
				if( !imgd.data[i+3] )
				{
					// console.log(imgd.data[i+3]);
					// imgd.data[i+3]=0;
					continue;
				}
				
				imgd.data[i]	= isColor[0];   // Red component
				imgd.data[i+1]	= isColor[1]; // Blue component
				imgd.data[i+2]	= isColor[2]; // Green component
				// imgd.data[i+3]	= 255;
				counter++;
			}

			var currImgData = ctx.createImageData(cvsElem.width, cvsElem.height);
			ctx.putImageData(currImgData, 0, 0);

			ctx.putImageData(imgd, posToPutX, posToPutY);
			inElementHtml.append("<img src='"+cvsElem.toDataURL("image/png")+"'/>");
			// inElementHtml.append(cvsElem);
		}
	}
	
	
	_this.addslashes = function(str)
	{
		return (str + '').replace(/[\\"']/g, '\\$&').replace(/\u0000/g, '\\0');
	}

	_this.stripslashes = function(str)
	{
		return (str + '').replace(/\\(.?)/g, function (s, n1)
		{
			switch (n1)
			{
				case '\\':
					return '\\';
				case '0':            return '\u0000';
				case '':
					return '';
				default:
					return n1;
			}
		});
	}
	
	_this.preventDefault = function(event)
	{
		// event est l'objet Event
		if (event.stopPropagation)
		{
			event.stopPropagation();
		}
		event.cancelBubble = true;
		if (event.preventDefault)
		{
			event.preventDefault();
		}
		event.returnValue = false;
	}
	
	_this.byPageIfDouble = function( pageN )
	{
		var infos 					= new Object();
		infos["isDoubleDoc"]		= _GLOBALS.CONF.pages.doublePage;
		infos["isDoublePage"]		= new Object();
		infos["isDoublePage"][1]	= pageN;
		infos["isDoublePage"][2]	= 0;
		infos["isDouble"]			= 0;
		// pageN = Math.floor(pageN);
		
		var pgLength = _GLOBALS.CONF.pages.length;
		
		if( infos["isDoubleDoc"] )
		{
			if( pageN === 1 )
			{
				infos["isDoublePage"][1] = 1;
				infos["isDoublePage"][2] = 0;
				infos["isDouble"] = 0;
				return infos;
			}
			
			if( pageN === pgLength && !_this.impair(pgLength))
			{
				infos["isDoublePage"][1] = 0;
				infos["isDoublePage"][2] = 1;
				infos["isDouble"] = 0;
				return infos;
			}
			
			if( !_this.impair(pageN) )
			{
				infos["isDoublePage"][1] = 1;
				infos["isDoublePage"][2] = 0;
				infos["isDouble"] = 1;
				return infos;
			}
			else if( _this.impair(pageN) )
			{
				infos["isDoublePage"][1] = 0;
				infos["isDoublePage"][2] = 1;
				infos["isDouble"] = 1;
				return infos;
			}
			
		}
		return infos;		
	}
	
	_this.onResizeCustom = function(func)
	{
		_this.onResizeCustomList.push(func);
	}
	
	_this.onResizedCustom = function(event)
	{
		if(_GLOBALS.main.supportsOrientationChange)
		{
			//0
			$(".blockCont").children("canvas").transition(
			{
				// x:_GLOBALS.CONF.getDocument.width*2
				opacity: 0
			})
			if(!_GLOBALS.main.supportsOrientationChange)
			{
				clearTimeout(_this.timeResize);
			}
			_this.timeResize = setTimeout(function()
			{				
				var rL = _this.onResizeCustomList.length;
				for( var i = 0 ; i < rL ; i++ )
				{
					_this.onResizeCustomList[i](event);
				}
				
			}, _GLOBALS.main.timeOfResizeMobile );
		}else
		{
			if(!_GLOBALS.main.supportsOrientationChange)
			{
				clearTimeout(_this.timeResize);
			}
			_this.timeResize = setTimeout(function()
			{				
				var rL = _this.onResizeCustomList.length;
				for( var i = 0 ; i < rL ; i++ )
				{
					_this.onResizeCustomList[i](event);
				}
				
			}, _GLOBALS.main.timeOfResize );
		}
	}

	_this.byOffsetIndex = function( index )
	{
		index = index + _GLOBALS.CONF.decalagePage;
		return index;
	}
	
	_this.getPathImage = function( type , index )
	{
		return type+_GLOBALS.CONF.pages.defaultName+""+(index)+""+_GLOBALS.CONF.pages.imgFormat;
	}
	
	_this._construct();
}


function isEventSupported(eventName, element)
{
	element = element || document.createElement(TAGNAMES[eventName] || 'div');
	eventName = 'on' + eventName;
   
	var isSupported = (eventName in element);
   
	if (!isSupported)
	{
		// if it has no `setAttribute` (i.e. doesn't implement Node interface), try generic element
		if (!element.setAttribute)
		{
			element = document.createElement('div');
		}
	
		if (element.setAttribute && element.removeAttribute)
		{
			element.setAttribute(eventName, '');
			isSupported = typeof element[eventName] == 'function';
			// if property was created, "remove it" (by setting value to `undefined`)
			if (typeof element[eventName] != 'undefined')
			{
				element[eventName] = undef;
			}
			element.removeAttribute(eventName);
		}
	}
   
	element = null;
	return isSupported;
}

var convertHexToRGB = function( hex )
{
	this.resultH = new Array();
	this._construct = function()
	{
		this.resultH.push(this.hexToR(hex));
		this.resultH.push(this.hexToG(hex));
		this.resultH.push(this.hexToB(hex));		  
		return this.resultH;
	}
	 
	this.hexToR = function(h)
	{
		return parseInt((this.cutHex(h)).substring(0,2),16);
	}

	this.hexToG = function(h)
	{
		return parseInt((this.cutHex(h)).substring(2,4),16);
	}

	this.hexToB = function(h)
	{
		return parseInt((this.cutHex(h)).substring(4,6),16);
	}

	this.cutHex = function(h)
	{
		return (h.charAt(0)=="#") ? h.substring(1,7):h;
	}

	return this._construct();
}

var dataToObject = function(obj)
{
	return eval('({'+obj+'})');
}

var drawCanvasTime = function( callback , cancel , id )
{
	if(cancel)
	{
		clearTimeout(id);
	}else
	{
		var timeToCall = 0;
		var id = window.setTimeout(function()
		{
			callback();
		},timeToCall);
		return id;
	}		
}

var UTILS = new Utils();
_GLOBALS.callbackLoadedTmp("Utils");var VignetteManager = function( parent , objName )
{
	var _this = this;
	_this.objName;
	_this.absolutePathMain	= "_GLOBALS.main."+objName;
	_this.parent;
	_this.appendToElem		= "";
	_this.thumbs			= {};
	_this.thumbs.width		= "";
	_this.thumbs.height		= "";
	_this.thumbs.marginLeft	= "";
	_this.imgList			= {};
	_this.imgByStep			= 4;
	_this.greatUlGallery	= "greatUlGallery";
	_this.newArrForCoupleArrayLength = 0;
	_this.toAppendElem		= "";
	_this.thumbinfo;
	_this.toAppendElemSteps;
	_this.newArrForCouple	= new Array();
	_this.ifDouble			= 1;
	_this.languePage		= _GLOBALS.main.xmlLinksList.getXml.langue.find("menuitem[index=93]").attr("label");
	_this.isClose			= false;
	
	_this._construct = function()
	{
		
	}
	
	_this.listenIt = function(target)
	{
		if($(target).attr("gotopage"))
		{
			_GLOBALS.main.controlManager.goToPage($(target).attr("gotopage"));
			_GLOBALS.main.popupSlideList.vignetteManager.close();
		}
	}
	
	_this.creatStepFloor = function()
	{
		// _GLOBALS.main.pagesLoader.pageCurrentOriginalIs
		var imgWidthPourc = "";		
		
		for( var J = 1 ; J <= _GLOBALS.CONF.pages.length ; J++ )
		{
			var gotopage = " gotopage='"+J+"' onclick='"+_this.absolutePathMain+".listenIt(this)' ";
			var currClassPathPage = "";
			if( _GLOBALS.main.pagesLoader.pageCurrentOriginalIs === J )
			{
				currClassPathPage = " pageIsCurrent";
			}
			
			var checkD = UTILS.byPageIfDouble(J);
			if( checkD["isDoubleDoc"] )
			{
				imgWidthPourc = "width:45%; ";
			}
			
			var pourc = 100/(_this.imgByStep);
			var curImg = "<li "+gotopage+" style='margin:5px 0;width:"+(pourc)+"%' id='gallery_liImg_"+J+"' class='liImg"+currClassPathPage+"' ><img style='"+imgWidthPourc+"' src='"+UTILS.getPathImage( _GLOBALS.CONF.pages.Diapo , J )+"'>";
			if( checkD["isDouble"] && checkD["isDoublePage"][1] )
			{
				curImg += "<img style='"+imgWidthPourc+"' src='"+UTILS.getPathImage( _GLOBALS.CONF.pages.Diapo , J+1 )+"'>";
				J++;
			}
			curImg += "<p>"+_this.languePage+" "+UTILS.byOffsetIndex(J)+"</p></li>";
			_this.newArrForCouple.push(curImg);
		}
		
		_this.newArrForCoupleArrayLength = _this.newArrForCouple.length;
		return _this.newArrForCouple;
	}
	
	_this.appendElem = function(J)
	{
		setTimeout(function()
		{			
			if(_this.isClose)
			{
				return void(0);
			}
			
			if( J < _this.newArrForCoupleArrayLength )
			{
				_this.toAppendElemSteps.append(_this.newArrForCouple[J]);
				var elem = $("#"+$(_this.newArrForCouple[J]).attr("id"));
				elem.transition(
				{
					perspective:400,
					rotateY:90
				},0,function()
				{
					$(this).transition(
					{
						rotateY:0
					},100)
				})
				
				if( _GLOBALS.main.pagesLoader.pageCurrentOriginalIs === J )
				{
					// var pos = elem.position();
					// console.log(elem.height());
					// console.log(elem);
					// $(".vignetteParent").scrollTop(pos.top-40);
				}
				_this.appendElem(J+1);
			}
		},16);
	}
	
	_this.checkImageInfo = function(callback)
	{
		var imagec = new Image();
		var checkD = UTILS.byPageIfDouble(J);
		if( checkD["isDoubleDoc"] )
		{
			_this.ifDouble = 2;
		}
		
		imagec.onload = function()
		{
			_this.thumbinfo = this;
			_this.imgByStep = Math.floor(_GLOBALS.CONF.getDocument.width/(_this.thumbinfo.width*_this.ifDouble));
			if(callback)
			{
				callback();
			}
		}
		imagec.src = UTILS.getPathImage( _GLOBALS.CONF.pages.Diapo , 1 );		
	}
	
	_this.checkScroll = function(target)
	{
		_this.scrollTopE = $(target).scrollTop();
		var clacuSc = ($(target).scrollTop() - ($(target).children(".steps").height()-$(target).height()));
		if( $(target).scrollTop() <=0 && $(target).scrollTop() >= -5 )
		{
			$(target).scrollTop(1);
		}
		else if( clacuSc <= 1 && clacuSc >=-5 )
		{
			$(target).scrollTop( ($(target).children(".steps").height()-$(target).height()-2) )
		}
	}
	
	_this.initVignette = function(toAppendElem)
	{
		_this.checkImageInfo(function()
		{
			_this.toAppendElem = toAppendElem;
			$(_this.toAppendElem).append("<ul class='steps' ></ul>");
			_this.toAppendElemSteps = $(_this.toAppendElem).children(".steps");
			_this.creatStepFloor();			
			_this.appendElem(0);
			$(toAppendElem).css("height",_GLOBALS.CONF.getDocument.height-100);
			
			UTILS.onResizeCustom(function()
			{
				$(toAppendElem).transition({
					height:(_GLOBALS.CONF.getDocument.height-100)
				},200)
				
				$(toAppendElem).transition({
					height:(_GLOBALS.CONF.getDocument.height-100)
				},200)			
			});			
		})
	}
	
	_this.onClose = function()
	{
		_this.isClose = true;
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("VignetteManager");var X_y_z_Manager = function()
{
	var _this			= this;
	_this.urlVarId		= false;
	_this.urlStartPage	= false;
	
	_this._construct = function()
	{
		var getVarID = _this.getVar("id");
		var getVarStartPage = parseInt(_this.getVar("startPage"));
		if( getVarID )
		{
			_this.urlVarId = getVarID;
		}
		
		if( getVarStartPage )
		{
			_GLOBALS.urlStartPage = _this.urlStartPage = getVarStartPage;
		}
		_this.varAllId = false;
	}
	
	_this.getVar = function(name)
	{
		var get_string = document.location.search;         
		var return_value = '';

		do
		{
			//This loop is made to catch all instances of any get variable.
			var name_index = get_string.indexOf(name + '=');
			if(name_index != -1)
			{
				get_string = get_string.substr(name_index + name.length + 1, get_string.length - name_index);

				var end_of_value = get_string.indexOf('&');
				var value;
				
				if(end_of_value != -1)
				{
					value = get_string.substr(0, end_of_value);                
				}
				else
				{
					value = get_string;                
				}  
				if(return_value == '' || value == '')
				{
					return_value += value;
				}
				else
				{
					return_value += ', ' + value;
				}
			}
		}while(name_index != -1)
		
		//Restores all the blank spaces.
		var space = return_value.indexOf('+');
		while(space != -1)
		{ 
			return_value = return_value.substr(0, space) + ' ' + 
			return_value.substr(space + 1, return_value.length);
			space = return_value.indexOf('+');
		}
		
		return(return_value);        
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("X_y_z_Manager");var XmlLoader = function( parent , objName , path , xmlLisInArray , callBack )
{
	var _this				= this;
	_this.objName			= objName;
	_this.parent			= parent;
	_this.path				= path;
	
	_this.xmlNeededToLoad	= new Array(); 
	_this.xmlNeededToLoad	= xmlLisInArray;
	_this.currXmlLength		= 0;
	
	_this.getXml = {};
	
	_this._construct = function()
	{
		_this.whileListXml();
		return void(0);
	}
	
	_this.loadCurrXml = function( cPath , cIndex , xmlLength )
	{
		$.ajax(
		{
			xhr: function()
			{
				var xhr = new window.XMLHttpRequest();
				//Download progress
				xhr.addEventListener("progress", function(evt)
				{
					if (evt.lengthComputable)
					{
						var percentComplete = evt.loaded / evt.total;
						//Do something with download progress
						//console.log(evt);
					}
				}, false);
				return xhr;
			},type: 'GET',url: cPath ,data: {},
			success: function(data)
			{
				_this.currXmlLength++;
				_this.getXml[_this.xmlNeededToLoad[cIndex]] = $(data.documentElement);
				if( xmlLength == _this.currXmlLength )
				{
					if( callBack )
					{
						callBack(true);
					}
				}
				return void(0);
			},error:function(data)
			{
				_this.currXmlLength++;
				_this.getXml[_this.xmlNeededToLoad[cIndex]] = false;
				if( xmlLength == _this.currXmlLength )
				{
					if( callBack )
					{
						callBack(false);
					}					
				}
				return void(0);
			}
		});	
		return void(0);		
	}
	
	_this.whileListXml = function()
	{
		var xmlLength = _this.xmlNeededToLoad.length;
		for( var i = 0 ; i < xmlLength ; i++ )
		{
			var pathGetXml = _this.path+_this.xmlNeededToLoad[i]+".xml";
			_this.loadCurrXml( pathGetXml , i , xmlLength );		
		}
		return void(0);
	}

	_this._construct();
}
_GLOBALS.callbackLoadedTmp("XmlLoader");var Config = function( parent , urlVarId )
{
	var _this					= this;
	_this.systemPath			= "./mobile_v7/";
	//reserved for changing dynamically
	_this.clientPath			= "./";
	_this.vendors				= "";
	_this.pages					= {};
	_this.getDocument			= {};
	_this.logo					= "";
	_this.xmlNeededToLoadPath	= "";
	_this.xmlNeededToLoad		= new Array();
	_this.iconesPath			= "";
	_this.lngKey				= "langue_";
	_this.pathMobile			= "./mobile/";
	_this.pathLangue			= _this.pathMobile+"lng/";
	_this.usePaginationPointeurCustom = false;
	_this.menu_alpha			= 1;
	_this.decalagePage			= 0;
	
	_this.iconesDefaultParam	=
	{
		teinte : "#000000"
	};
	
	_this.vendorsList	= ['ms','Ms', 'moz', 'Moz', 'webkit', 'Webkit', 'o', 'O'];
	
	//like constant WARNING not changing this object dynamically for changing use "pagesDynamiqueInfo"	
	
	_this.pagesOnInit = {}
	
	_this.getTemplatesList = function()
	{
		var templatesPath = "templates/";
		var templatesList = {};		
		// templatesList.popupSlide = templatesPath+"popupSlide.tpl";
		return templatesList;
	}
	
	_this.getVendor = function()
	{
		return _this.vendors;
	}
	
	_this.getClientPath = function()
	{
		return _this.clientPath;
	}
	
	_this.getXmlNeededToLoad = function()
	{
		return _this.xmlNeededToLoad;
	}

	
	_this.getIconesPath = function()
	{
		return _this.iconesPath;
	}	
	
	_this.setIconesPath = function()
	{
		_this.iconesPath = _this.systemPath+"icones_1/";
	}
	
	_this.setDocument = function()
	{
		_this.getDocument.width		= $(window).width();
		_this.getDocument.height	= $(window).height();
		_this.getDocument.sBackgroundColor	= "#ffffff";
		_this.getDocument.lngDefault		= "fr";
		_this.getDocument.lng		= "fr";		
	}
	
	_this.setVendor = function()
	{
		var vStyle = $("body")[0].style;
		var vendorsList = _this.vendorsList;
		var vendorsListLength = vendorsList.length;
		for(var x = 0; x < vendorsListLength && typeof vStyle[_this.vendors+"Transition"] != "string"; ++x)
		{
			_this.vendors = vendorsList[x];
		}
	}
	
	_this.setXmlNeededToLoad = function()
	{
		_this.xmlNeededToLoad = new Array("menu2","menuParam","texte" , "param","liens");
	}
	
	_this.setClientPath = function()
	{
		_this.clientPath = urlVarId+"/";
	}
	
	_this.setAllPath = function()
	{
		_this.setClientPath();
		_this.logo			= _this.getClientPath()+'logo.png',
		_this.xmlNeededToLoadPath = _this.getClientPath();
		_this.setPagesOnInit();
		_this.setPaginationPointeur();
	}

	_this.setPagesOnInit = function()
	{
		_this.pagesOnInit = 
		{
			doublePage			: true,
			keepMaxResolution	: false,
			width				: 1024,
			height				: 1356,
			currScale			: 1,
			currScaleMaxDiff	: 2,
			currScaleMinDiff	: 0,
			scaleDoublTapMax	: 2,
			scaleDoublTapMin	: 0,
			sensibleZoom		: 0.004,
			beginPage			: _GLOBALS.urlStartPage,
			//min 4
			preloadBy			: 6,
			pageCurrentIs		: 1,
			length				: 40,
			timeToLoadHD		: 400,
			pathTextureHigh		: _this.getClientPath()+'Zoom/',
			pathTextureLow		: _this.getClientPath()+'Big1/',
			Diapo				: _this.getClientPath()+'Diapo/',
			/*Kev*/
			videoFichePath		: _this.getClientPath()+'fiches/',
			videoIncrustePath	: _this.getClientPath()+'multimedia/',
			imageFichePath		: _this.getClientPath()+'multimedia/',
			imageIncrustePath	: _this.getClientPath()+'multimedia/',
			/*****/
			forFisrtPreloadIsBy	: 6,
			defaultName			: "page",
			imgFormat			: ".jpg",
			listElem			: new Array(),
			animationManager	:
			{
				swipTime	: 150,
				zoomTime	: 100,
				transitionTime	: 400,
				//ToDo check problem bounce for android 3.1
				swipEasing	: "linear",
				defEasing	: "linear"
			},
			canvasKey			: "canvas_",
			element				: "element",
			textureHigh			: "pathTextureHigh",
			textureLow			: "pathTextureLow",
			getTextureHigh		: "getTextureHigh",
			getTextureLow		: "getTextureLow"
		}
	}
	
	//RETURN INDEX OF PAGE
	// _this.listPagePointeur = new Array();
	// _this.listPagePointeur.push(1);
	// _this.listPagePointeur.push(2);
	// _this.listPagePointeur.push(3);
	// _this.listPagePointeur.push(4);
	// _this.listPagePointeur.push(5);
	// _this.listPagePointeur.push(6);
	// _this.listPagePointeur.push(7);
	// _this.listPagePointeur.push(8);
	// _this.listPagePointeur.push(9);
	// _this.listPagePointeur.push(10);
	// _this.listPagePointeur.push(11);
	
	_this.setPaginationPointeur = function()
	{
		if( _this.usePaginationPointeurCustom )
		{
			if(!_this.listPagePointeur)
			{
				_this.usePaginationPointeurCustom = false;
				_this.setPaginationPointeur();
			}else
			{
				_this.pagesOnInit.length = _this.listPagePointeur.length;
			}
		}else
		{
			_this.listPagePointeur = new Array();			
			for( var j = 1 ; j <= _this.pagesOnInit.length ; j++ )
			{
				_this.listPagePointeur.push(j);
			}
		}
	}
	
	_this.getPaginationPointeur = function(i)
	{
		if( _this.listPagePointeur[i] )
		{
			return _this.listPagePointeur[i];
		}else
		{
			return false;
		}
	}
	
	_this._construct = function()
	{
		_this.setAllPath();
		_this.setIconesPath();
		_this.setXmlNeededToLoad();
		_this.pages = UTILS.clone(_this.pagesOnInit);
		_this.setDocument();
		_this.setVendor();
		return void(0);
	}
	
	_this._construct();
}
_GLOBALS.callbackLoadedTmp("Config");
_GLOBALS.callbackLoaded("allJs");